// Card Service
//
// COPYRIGHT
// ---------
// The software was developed by the National Institute of Standards and 
// Technology (NIST), an agency of the Federal Government.  Pursuant to 
// Title 15 United States Code Section 105, works of NIST are not subject
// to copyright protection in the United States and are considered to be
// in the public domain.  As a result, a formal license is not needed to
// use the software.
// 
// The Government Smart Card Reference Implementation software is provided
// by NIST as a service and is expressly provided "AS IS."  
// NIST MAKES NO WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR STATUTORY, 
// INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT AND DATA ACCURACY.
// NIST does not warrant or make any representations regarding the use of
// the software or the results thereof, including but not limited to the
// correctness, accuracy, reliability or usefulness of the software.
// 
// Permission to use this software is contingent upon your acceptance of 
// the terms of this agreement and upon your providing appropriate
// acknowledgments of NIST's ownership of the software.

#include "Card_Service.h"

unsigned char
Card_Service :: get_card_content_state ( void )
{
  return the_card_manager -> get_card_content_state ( this ) ;
}


bool
Card_Service :: set_card_content_state ( unsigned char new_state )
{
  return the_card_manager -> set_card_content_state ( this, new_state ) ;
}


unsigned char
Card_Service :: get_card_state ( void )
{
  return the_card_manager -> get_card_state ( this ) ;
}


bool
Card_Service :: lock_card ( void )
{
  return the_card_manager -> lock_card ( this ) ;
}


bool
Card_Service :: terminate_card ( void )
{
  return the_card_manager -> terminate_card ( this ) ;
}


bool
Card_Service :: set_ATR_hist_bytes ( Octet_String & new_hist_bytes )
{
  return the_card_manager -> set_ATR_hist_bytes ( this, new_hist_bytes ) ;
}
