/* file tlpclib-debug.h
 *
 * NIST PIV Demo
 *
 * Copyright  2005 Electrosoft Services Inc.
 * http://www.electrosoft-inc.com
 * 
 * This file codes and documents all the necessary debug functions.  It was
 * from csp-debug.h
 * 
 * Adapted from work of Romain Chantereau <rchantereau@entrouvert.com> (CSP11 code)
 */
#ifndef _TLPCLIB_DEBUG_H_
#define _TLPCLIB_DEBUG_H_

#ifdef __cplusplus
extern "C" {
#endif

#define TLPCLIB_DEBUG_FILE				"C:\\tlpclib.log" /**< Path to the debug log file.*/

#define TLPCLIB_DEBUG_LEVEL				4  /**< Debug level 0 to 5 */

/** \brief Close the debug log file.
 *
 * \return TRUE if the log file was closed. FALSE if not, (not opened or worse).
 */
void TlpclibCloseDebug();

/** \brief Write debug to file
 *
 *  Lock the debug file, open it, write in it, close it, unlock it.
 *  
 *  \param  message C string containgin the message to write.
 *
 *  \return TRUE if ok.
 */
void TlpclibFdebug(const char *message);
void TlpclibFdebug2(const char *message, int len);

/** \brief Debug macro
 *
 *
 */
#define TLPCLIB_DEBUG_MSG(LEVEL, MESSAGE) \
    if(LEVEL <= TLPCLIB_DEBUG_LEVEL) \
    { \
        TlpclibFdebug(MESSAGE); \
    }

#define TLPCLIB_DEBUG_MSG2(LEVEL, MESSAGE, LEN) \
    if(LEVEL <= TLPCLIB_DEBUG_LEVEL) \
    { \
        TlpclibFdebug2(MESSAGE, LEN); \
    }

#ifdef __cplusplus
}
#endif
#endif // _TLPCLIB_DEBUG_H_

