// CommandLine
//
// COPYRIGHT
// ---------
// The software was developed by the National Institute of Standards and 
// Technology (NIST), an agency of the Federal Government.  Pursuant to 
// Title 15 United States Code Section 105, works of NIST are not subject
// to copyright protection in the United States and are considered to be
// in the public domain.  As a result, a formal license is not needed to
// use the software.
// 
// The Government Smart Card Reference Implementation software is provided
// by NIST as a service and is expressly provided "AS IS."  
// NIST MAKES NO WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR STATUTORY, 
// INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT AND DATA ACCURACY.
// NIST does not warrant or make any representations regarding the use of
// the software or the results thereof, including but not limited to the
// correctness, accuracy, reliability or usefulness of the software.
// 
// Permission to use this software is contingent upon your acceptance of 
// the terms of this agreement and upon your providing appropriate
// acknowledgments of NIST's ownership of the software.

#if !defined(__COMMANDLINE_H_INCLUDED__)
#define __COMMANDLINE_H_INCLUDED__



  typedef struct _tag_option
  {
    char option_char;
    char *option_name;
    int option_num;
    char parameter;
    char *description;
  }
  option;

  #define NO_PARM '\0'

#if defined(__cplusplus)
extern "C"
#endif
extern void
show_usage(const option options[],
           int NOPTIONS,
           const char *usage_head,
           const char *usage_tail);


typedef int (*CPROCESSFN) (const int option, int *pargc, char ***pargv);

#if defined(__cplusplus)
  typedef bool (*PROCESSFN) (const int option, int &argc, char **&argv);


  extern bool process_command_line (int &argc, char **&argv,
                                    const option options[],
                                    int NOPTIONS,
                                    const char *usage_head,
                                    const char *usage_tail,
                                    PROCESSFN process_option);


#else    // defined(__cplusplus)
  
  extern int C_process_command_line (int *pargc, char ***pargv,
                                     const option options[],
                                     int NOPTIONS,
                                     const char *usage_head,
                                     const char *usage_tail,
                                     CPROCESSFN process_option);
#endif   // defined(__cplusplus)

#endif /* __COMMANDLINE_H_INCLUDED__ */
