// pivvscr_configDlg.cpp : implementation file
//

#include "stdafx.h"
#include "pivvscr_config.h"
#include "pivvscr_configDlg.h"
#include "Registry.h"
#include ".\pivvscr_configdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// Cpivvscr_configDlg dialog



Cpivvscr_configDlg::Cpivvscr_configDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Cpivvscr_configDlg::IDD, pParent)
	, m_bAutoInsert(TRUE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void Cpivvscr_configDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text	  (pDX, IDC_HOSTNAME,	  m_cstrHostName );
	DDX_Text      (pDX, IDC_PORTNUMBER,   m_dwPortNumber  );
	DDX_Text      (pDX, IDC_POLLINTERVAL, m_dwPollInterval);

	// port ranges
	DDV_MinMaxDWord (pDX, m_dwPortNumber,
		PIVVSCR_CONFIG_PORT_MINVALUE,
		PIVVSCR_CONFIG_PORT_MAXVALUE);
	// poll interval
	DDV_MinMaxDWord (pDX, m_dwPollInterval,
		PIVVSCR_CONFIG_POLLINTERVAL_MINVALUE,
		PIVVSCR_CONFIG_POLLINTERVAL_MAXVALUE);
	DDX_Check(pDX, IDC_AUTO_INSERT, m_bAutoInsert);
}

BEGIN_MESSAGE_MAP(Cpivvscr_configDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(ID_APPLY_NOW, OnBnClickedApplyNow)
	ON_BN_CLICKED(IDCLOSE, OnBnClickedClose)
END_MESSAGE_MAP()


// Cpivvscr_configDlg message handlers

BOOL Cpivvscr_configDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// set default values stored in registry
	DWORD dwLength, dwAutoInsert;
	CString *pCStrHostName;
	
	// get host IP address
	if (::GetRegistryValueSize(HKEY_LOCAL_MACHINE, PIVVSCR_PARAMETERS_REGKEY,
		PIVVSCR_HOSTNAME_REGVALUE, &dwLength) == ERROR_SUCCESS)
	{
		pCStrHostName = new CString(' ', dwLength);
		if (::GetRegistryValue(HKEY_LOCAL_MACHINE, PIVVSCR_PARAMETERS_REGKEY,
			PIVVSCR_HOSTNAME_REGVALUE, pCStrHostName, dwLength) == ERROR_SUCCESS)
		{
			m_cstrHostName = *pCStrHostName;
		}
		else
			m_cstrHostName = "";
	}
	else
		m_cstrHostName = "127.0.0.1";

	// get host port number
	if (::GetRegistryValue(HKEY_LOCAL_MACHINE, PIVVSCR_PARAMETERS_REGKEY,
		PIVVSCR_PORT_REGVALUE, &m_dwPortNumber) != ERROR_SUCCESS) { 

		m_dwPortNumber = 9025;
	}

	// get poll interval
	if (::GetRegistryValue(HKEY_LOCAL_MACHINE, PIVVSCR_PARAMETERS_REGKEY,
		PIVVSCR_POLLINTERVAL_REGVALUE, &m_dwPollInterval) != ERROR_SUCCESS)	{ 
		
		m_dwPollInterval = 100;
	}

	// get auto insert
	if (::GetRegistryValue(HKEY_LOCAL_MACHINE, PIVVSCR_PARAMETERS_REGKEY,
		PIVVSCR_AUTOINSERT_REGVALUE, &dwAutoInsert) != ERROR_SUCCESS)	{ 
		
		m_bAutoInsert = TRUE;
	}
	else
		m_bAutoInsert = (dwAutoInsert > 0) ? TRUE : FALSE;

	// load defaults from registry into the controls
	UpdateData(FALSE);

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void Cpivvscr_configDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Cpivvscr_configDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Cpivvscr_configDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void Cpivvscr_configDlg::OnBnClickedApplyNow()
{
	if (UpdateData(TRUE))
	{
		DWORD dwAutoInsert;

		if (::SetRegistryValue(HKEY_LOCAL_MACHINE, PIVVSCR_PARAMETERS_REGKEY,
			PIVVSCR_HOSTNAME_REGVALUE, &m_cstrHostName) != ERROR_SUCCESS)
		{
			MessageBox("Could not set the Host registry key.");
			return;
		}

		if (::SetRegistryValue(HKEY_LOCAL_MACHINE, PIVVSCR_PARAMETERS_REGKEY,
			PIVVSCR_PORT_REGVALUE, &m_dwPortNumber) != ERROR_SUCCESS)
		{
			MessageBox("Could not set the Port Number registry key.");
			return;
		}

		if (::SetRegistryValue(HKEY_LOCAL_MACHINE, PIVVSCR_PARAMETERS_REGKEY,
			PIVVSCR_POLLINTERVAL_REGVALUE, &m_dwPollInterval) != ERROR_SUCCESS)
		{
			MessageBox("Could not set the Poll Interval registry key.");
			return;
		}

		dwAutoInsert = m_bAutoInsert ? 1 : 0;

		if (::SetRegistryValue(HKEY_LOCAL_MACHINE, PIVVSCR_PARAMETERS_REGKEY,
			PIVVSCR_AUTOINSERT_REGVALUE, &dwAutoInsert) != ERROR_SUCCESS)
		{
			MessageBox("Could not set the Auto Insert registry key.");
			return;
		}

		MessageBox(_T("Configuration updated successfully!"));
	}
}

void Cpivvscr_configDlg::OnBnClickedClose()
{
	OnCancel();
	// TODO: Add your control notification handler code here
}