// File System Initial Configuration
//
// COPYRIGHT
// ---------
// The software was developed by the National Institute of Standards and
// Technology (NIST), an agency of the Federal Government.  Pursuant to
// Title 15 United States Code Section 105, works of NIST are not subject
// to copyright protection in the United States and are considered to be
// in the public domain.  As a result, a formal license is not needed to
// use the software.
//
// The Government Smart Card Reference Implementation software is provided
// by NIST as a service and is expressly provided "AS IS."
// NIST MAKES NO WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR STATUTORY,
// INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT AND DATA ACCURACY.
// NIST does not warrant or make any representations regarding the use of
// the software or the results thereof, including but not limited to the
// correctness, accuracy, reliability or usefulness of the software.
//
// Permission to use this software is contingent upon your acceptance of
// the terms of this agreement and upon your providing appropriate
// acknowledgments of NIST's ownership of the software.


//
// Each SP 800-73 Data Object is a File of BER-TLV Structure in the MF
//

static Octet MF_FCP [ ] =
    {
      FCP_TAG, 18,                                                                // 20
                FCP_FDB , 2 , FDB_SHAREABLE_DF , DCB_PROPRIETARY_BYTES ,          //   4
                FCP_FID , 2 , NETWORK_WORD_BYTES ( MF ) ,                         //   4
                FCP_LIFECYCLE , 1 , LCS_OPERATIONAL_ACTIVATED ,                   //   3
                ACR_EXPANDED_FORM , 5 ,                                            //   7
                                  ACR_AM_DO        , 1 ,  ACR_AM_DIR_ANY ,        //     3
                                  ACR_SC_DO_ALWAYS , 0                            //     2
    } ;

//
// The Default Data for the SP 800-73 Data Objects
//

// BER-TLV Tag 5FC101
static Octet CARD_X509_DATA [ ] = 
{ 0x70, 0x82, 0x05, 0x19, 0x30, 0x82, 0x05, 0x15, 0x30, 0x82, 
 0x03, 0xFD, 0xA0, 0x03, 0x02, 0x01, 0x02, 0x02, 0x01, 0x16, 
 0x30, 0x0D, 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 
 0x01, 0x01, 0x05, 0x05, 0x00, 0x30, 0x32, 0x31, 0x0B, 0x30, 
 0x09, 0x06, 0x03, 0x55, 0x04, 0x06, 0x13, 0x02, 0x55, 0x53, 
 0x31, 0x0D, 0x30, 0x0B, 0x06, 0x03, 0x55, 0x04, 0x0A, 0x13, 
 0x04, 0x4E, 0x49, 0x53, 0x54, 0x31, 0x14, 0x30, 0x12, 0x06, 
 0x03, 0x55, 0x04, 0x03, 0x13, 0x0B, 0x50, 0x49, 0x56, 0x20, 
 0x54, 0x65, 0x73, 0x74, 0x20, 0x43, 0x41, 0x30, 0x1E, 0x17, 
 0x0D, 0x30, 0x37, 0x30, 0x34, 0x31, 0x39, 0x31, 0x35, 0x32, 
 0x32, 0x33, 0x33, 0x5A, 0x17, 0x0D, 0x30, 0x39, 0x30, 0x34, 
 0x31, 0x39, 0x31, 0x35, 0x32, 0x32, 0x33, 0x33, 0x5A, 0x30, 
 0x71, 0x31, 0x0B, 0x30, 0x09, 0x06, 0x03, 0x55, 0x04, 0x06, 
 0x13, 0x02, 0x55, 0x53, 0x31, 0x27, 0x30, 0x25, 0x06, 0x03, 
 0x55, 0x04, 0x0B, 0x13, 0x1E, 0x6F, 0x72, 0x67, 0x61, 0x6E, 
 0x69, 0x7A, 0x61, 0x74, 0x69, 0x6F, 0x6E, 0x61, 0x6C, 0x20, 
 0x55, 0x6E, 0x69, 0x74, 0x20, 0x2D, 0x20, 0x50, 0x49, 0x56, 
 0x20, 0x54, 0x65, 0x73, 0x74, 0x31, 0x18, 0x30, 0x16, 0x06, 
 0x03, 0x55, 0x04, 0x0A, 0x13, 0x0F, 0x55, 0x2E, 0x53, 0x2E, 
 0x20, 0x47, 0x6F, 0x76, 0x65, 0x72, 0x6E, 0x6D, 0x65, 0x6E, 
 0x74, 0x31, 0x1F, 0x30, 0x1D, 0x06, 0x03, 0x55, 0x04, 0x03, 
 0x0C, 0x16, 0x63, 0x6F, 0x6D, 0x6D, 0x6F, 0x6E, 0x5F, 0x6E, 
 0x61, 0x6D, 0x65, 0x20, 0x2D, 0x20, 0x50, 0x49, 0x56, 0x20, 
 0x54, 0x65, 0x73, 0x74, 0x30, 0x81, 0x9F, 0x30, 0x0D, 0x06, 
 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x01, 0x01, 
 0x05, 0x00, 0x03, 0x81, 0x8D, 0x00, 0x30, 0x81, 0x89, 0x02, 
 0x81, 0x81, 0x00, 0xCC, 0xD8, 0x7D, 0xEE, 0x80, 0xF0, 0x7B, 
 0x65, 0x53, 0xB2, 0x16, 0x08, 0xD6, 0xFC, 0xD1, 0xA3, 0x89, 
 0xF7, 0x77, 0x65, 0x18, 0x58, 0x3F, 0xD0, 0x83, 0x6E, 0x07, 
 0x2D, 0xE0, 0xD7, 0x58, 0x3F, 0x5E, 0x11, 0x4D, 0x00, 0x28, 
 0x85, 0x13, 0x50, 0xD1, 0x0E, 0x52, 0xA5, 0x39, 0xD6, 0x51, 
 0xF9, 0x1A, 0x12, 0x1F, 0xBA, 0x17, 0x5E, 0xB1, 0x8F, 0xE2, 
 0xDF, 0xF3, 0x02, 0x67, 0x60, 0x70, 0x76, 0xA1, 0x08, 0x00, 
 0xEF, 0x0A, 0xF4, 0x65, 0xDB, 0xA7, 0xDA, 0xE9, 0xEF, 0xD2, 
 0xC0, 0x4B, 0x9A, 0x80, 0x10, 0xE5, 0x73, 0x5F, 0xFE, 0x5A, 
 0xB0, 0xFA, 0x49, 0xA5, 0xFF, 0x9B, 0x79, 0x3B, 0x83, 0x1E, 
 0x7B, 0xF8, 0x75, 0x8F, 0xE9, 0x5C, 0x8A, 0xD2, 0x71, 0x49, 
 0x18, 0xEC, 0x6E, 0xAB, 0x1C, 0x1D, 0x51, 0x5F, 0x3B, 0x5E, 
 0xDF, 0xF1, 0x6C, 0x2E, 0x68, 0x66, 0xA5, 0x22, 0x75, 0xB8, 
 0x21, 0x02, 0x03, 0x01, 0x00, 0x01, 0xA3, 0x82, 0x02, 0x79, 
 0x30, 0x82, 0x02, 0x75, 0x30, 0x1F, 0x06, 0x03, 0x55, 0x1D, 
 0x23, 0x04, 0x18, 0x30, 0x16, 0x80, 0x14, 0xEB, 0xDA, 0x19, 
 0xD2, 0x08, 0x42, 0x8D, 0xF4, 0xDE, 0x25, 0x87, 0x69, 0xC9, 
 0xBB, 0xAB, 0x0C, 0xD3, 0x96, 0x30, 0x01, 0x30, 0x1D, 0x06, 
 0x03, 0x55, 0x1D, 0x0E, 0x04, 0x16, 0x04, 0x14, 0xF8, 0x36, 
 0x17, 0xF6, 0xBA, 0x89, 0x6C, 0x0B, 0xBE, 0xF7, 0x9B, 0xC4, 
 0xF6, 0x10, 0x70, 0x52, 0x64, 0xA1, 0x93, 0xBA, 0x30, 0x0E, 
 0x06, 0x03, 0x55, 0x1D, 0x0F, 0x01, 0x01, 0xFF, 0x04, 0x04, 
 0x03, 0x02, 0x07, 0x80, 0x30, 0x16, 0x06, 0x03, 0x55, 0x1D, 
 0x25, 0x01, 0x01, 0xFF, 0x04, 0x0C, 0x30, 0x0A, 0x06, 0x08, 
 0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x06, 0x08, 0x30, 0x17, 
 0x06, 0x03, 0x55, 0x1D, 0x20, 0x04, 0x10, 0x30, 0x0E, 0x30, 
 0x0C, 0x06, 0x0A, 0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x02, 
 0x01, 0x03, 0x11, 0x30, 0x81, 0x86, 0x06, 0x03, 0x55, 0x1D, 
 0x1F, 0x04, 0x7F, 0x30, 0x7D, 0x30, 0x7B, 0xA0, 0x79, 0xA0, 
 0x77, 0x86, 0x1B, 0x68, 0x74, 0x74, 0x70, 0x3A, 0x2F, 0x2F, 
 0x6C, 0x6F, 0x63, 0x61, 0x6C, 0x68, 0x6F, 0x73, 0x74, 0x2F, 
 0x63, 0x72, 0x6C, 0x2F, 0x63, 0x61, 0x2E, 0x63, 0x72, 0x6C, 
 0x86, 0x58, 0x6C, 0x64, 0x61, 0x70, 0x3A, 0x2F, 0x2F, 0x73, 
 0x6D, 0x69, 0x6D, 0x65, 0x32, 0x2E, 0x6E, 0x69, 0x73, 0x74, 
 0x2E, 0x67, 0x6F, 0x76, 0x2F, 0x63, 0x6E, 0x3D, 0x47, 0x6F, 
 0x6F, 0x64, 0x25, 0x32, 0x30, 0x43, 0x41, 0x2C, 0x6F, 0x3D, 
 0x54, 0x65, 0x73, 0x74, 0x25, 0x32, 0x30, 0x43, 0x65, 0x72, 
 0x74, 0x69, 0x66, 0x69, 0x63, 0x61, 0x74, 0x65, 0x73, 0x2C, 
 0x63, 0x3D, 0x55, 0x53, 0x3F, 0x63, 0x65, 0x72, 0x74, 0x69, 
 0x66, 0x69, 0x63, 0x61, 0x74, 0x65, 0x52, 0x65, 0x76, 0x6F, 
 0x63, 0x61, 0x74, 0x69, 0x6F, 0x6E, 0x4C, 0x69, 0x73, 0x74, 
 0x30, 0x82, 0x01, 0x21, 0x06, 0x08, 0x2B, 0x06, 0x01, 0x05, 
 0x05, 0x07, 0x01, 0x01, 0x04, 0x82, 0x01, 0x13, 0x30, 0x82, 
 0x01, 0x0F, 0x30, 0x3E, 0x06, 0x08, 0x2B, 0x06, 0x01, 0x05, 
 0x05, 0x07, 0x30, 0x01, 0x86, 0x32, 0x68, 0x74, 0x74, 0x70, 
 0x3A, 0x2F, 0x2F, 0x66, 0x69, 0x63, 0x74, 0x69, 0x74, 0x69, 
 0x6F, 0x75, 0x73, 0x2E, 0x6E, 0x69, 0x73, 0x74, 0x2E, 0x67, 
 0x6F, 0x76, 0x2F, 0x66, 0x69, 0x63, 0x74, 0x69, 0x74, 0x69, 
 0x6F, 0x75, 0x73, 0x4F, 0x43, 0x53, 0x50, 0x4C, 0x6F, 0x63, 
 0x61, 0x74, 0x69, 0x6F, 0x6E, 0x2F, 0x30, 0x5E, 0x06, 0x08, 
 0x2B, 0x06, 0x01, 0x05, 0x05, 0x07, 0x30, 0x02, 0x86, 0x52, 
 0x68, 0x74, 0x74, 0x70, 0x3A, 0x2F, 0x2F, 0x66, 0x69, 0x63, 
 0x74, 0x69, 0x74, 0x69, 0x6F, 0x75, 0x73, 0x2E, 0x6E, 0x69, 
 0x73, 0x74, 0x2E, 0x67, 0x6F, 0x76, 0x2F, 0x66, 0x69, 0x63, 
 0x74, 0x69, 0x74, 0x69, 0x6F, 0x75, 0x73, 0x43, 0x65, 0x72, 
 0x74, 0x73, 0x4F, 0x6E, 0x6C, 0x79, 0x43, 0x4D, 0x53, 0x64, 
 0x69, 0x72, 0x65, 0x63, 0x74, 0x6F, 0x72, 0x79, 0x2F, 0x63, 
 0x65, 0x72, 0x74, 0x73, 0x49, 0x73, 0x73, 0x75, 0x65, 0x64, 
 0x54, 0x6F, 0x47, 0x6F, 0x6F, 0x64, 0x43, 0x41, 0x2E, 0x70, 
 0x37, 0x63, 0x30, 0x6D, 0x06, 0x08, 0x2B, 0x06, 0x01, 0x05, 
 0x05, 0x07, 0x30, 0x02, 0x86, 0x61, 0x6C, 0x64, 0x61, 0x70, 
 0x3A, 0x2F, 0x2F, 0x73, 0x6D, 0x69, 0x6D, 0x65, 0x32, 0x2E, 
 0x6E, 0x69, 0x73, 0x74, 0x2E, 0x67, 0x6F, 0x76, 0x2F, 0x63, 
 0x6E, 0x3D, 0x47, 0x6F, 0x6F, 0x64, 0x25, 0x32, 0x30, 0x43, 
 0x41, 0x2C, 0x6F, 0x3D, 0x54, 0x65, 0x73, 0x74, 0x25, 0x32, 
 0x30, 0x43, 0x65, 0x72, 0x74, 0x69, 0x66, 0x69, 0x63, 0x61, 
 0x74, 0x65, 0x73, 0x2C, 0x63, 0x3D, 0x55, 0x53, 0x3F, 0x63, 
 0x41, 0x43, 0x65, 0x72, 0x74, 0x69, 0x66, 0x69, 0x63, 0x61, 
 0x74, 0x65, 0x2C, 0x63, 0x72, 0x6F, 0x73, 0x73, 0x43, 0x65, 
 0x72, 0x74, 0x69, 0x66, 0x69, 0x63, 0x61, 0x74, 0x65, 0x50, 
 0x61, 0x69, 0x72, 0x30, 0x32, 0x06, 0x03, 0x55, 0x1D, 0x11, 
 0x04, 0x2B, 0x30, 0x29, 0xA0, 0x27, 0x06, 0x08, 0x60, 0x86, 
 0x48, 0x01, 0x65, 0x03, 0x06, 0x06, 0xA0, 0x1B, 0x04, 0x19, 
 0xD6, 0x50, 0x18, 0x58, 0x21, 0x0C, 0x2D, 0x31, 0x71, 0xB5, 
 0x25, 0xA1, 0x68, 0x5A, 0x08, 0xC9, 0x2A, 0xDE, 0x0A, 0x61, 
 0x86, 0x50, 0x18, 0x43, 0xE2, 0x30, 0x10, 0x06, 0x09, 0x60, 
 0x86, 0x48, 0x01, 0x65, 0x03, 0x06, 0x09, 0x01, 0x04, 0x03, 
 0x01, 0x01, 0x00, 0x30, 0x0D, 0x06, 0x09, 0x2A, 0x86, 0x48, 
 0x86, 0xF7, 0x0D, 0x01, 0x01, 0x05, 0x05, 0x00, 0x03, 0x82, 
 0x01, 0x01, 0x00, 0x81, 0x3C, 0x10, 0xF4, 0x39, 0x83, 0x15, 
 0xA1, 0xDF, 0x0B, 0x1E, 0x1F, 0xA9, 0x75, 0x12, 0xBE, 0x3D, 
 0xCD, 0x27, 0x97, 0xAD, 0xD6, 0xDA, 0x38, 0xCD, 0xF8, 0x25, 
 0xD5, 0xF7, 0xED, 0xE1, 0x07, 0x3A, 0x93, 0x2D, 0xED, 0x8F, 
 0xFD, 0x64, 0x37, 0xB2, 0x58, 0x3E, 0x1F, 0xB9, 0x00, 0xA3, 
 0xCD, 0x52, 0x85, 0xEF, 0x07, 0xD5, 0xBD, 0xE7, 0x04, 0x29, 
 0xD0, 0x71, 0xBD, 0x0F, 0x7F, 0xD0, 0x0C, 0xBE, 0x73, 0x67, 
 0x8E, 0xBD, 0x52, 0x65, 0x35, 0x9B, 0xA4, 0x4E, 0x44, 0xB1, 
 0x2C, 0x5F, 0xB0, 0xA5, 0xEB, 0x12, 0xBF, 0xC7, 0x4F, 0xD4, 
 0xB7, 0x41, 0x63, 0x70, 0xCA, 0x51, 0x8D, 0x84, 0x51, 0x86, 
 0x09, 0xCE, 0x3C, 0x14, 0x32, 0xD0, 0x8F, 0x42, 0xC8, 0x87, 
 0x46, 0xDA, 0x03, 0xD6, 0x9A, 0x51, 0x4C, 0x58, 0x8C, 0x64, 
 0x3B, 0x36, 0x98, 0x95, 0xD8, 0xD9, 0xA3, 0x53, 0xCC, 0x9D, 
 0x99, 0x77, 0xB2, 0x85, 0x54, 0xBC, 0x04, 0x57, 0xB0, 0x7F, 
 0x7C, 0xEE, 0x04, 0x8B, 0x1E, 0xC8, 0x47, 0x00, 0x35, 0xCF, 
 0x0A, 0xE1, 0xE9, 0xBD, 0x1A, 0x9E, 0xEB, 0xDF, 0xA1, 0xF6, 
 0x0C, 0x2B, 0xBB, 0xBC, 0x1C, 0x85, 0x88, 0xF9, 0xE0, 0x80, 
 0xAF, 0xD6, 0xA6, 0x36, 0x92, 0x52, 0xFB, 0x73, 0x71, 0x35, 
 0xF6, 0x61, 0x64, 0x91, 0x4E, 0xFA, 0x53, 0xF1, 0xFE, 0x8A, 
 0x66, 0xFC, 0x18, 0xBF, 0x41, 0x99, 0x05, 0x87, 0x53, 0xEA, 
 0x25, 0xF5, 0xEE, 0x10, 0xC1, 0x84, 0xC2, 0x16, 0xCB, 0xBB, 
 0x24, 0x8B, 0x25, 0x9C, 0xEB, 0x00, 0xD8, 0xA8, 0x88, 0x39, 
 0xAD, 0xF5, 0x65, 0x90, 0x08, 0xAB, 0xEC, 0x0B, 0x47, 0x33, 
 0x09, 0x65, 0x83, 0xC0, 0x7C, 0xBD, 0xAE, 0x77, 0xC2, 0x91, 
 0xCA, 0x02, 0x2D, 0x45, 0x8E, 0xFF, 0x2D, 0x8B, 0x93, 0xC8, 
 0xD7, 0x98, 0x5D, 0x82, 0x5E, 0xBC, 0x4C, 0x34, 0xD8, 0x71, 
 0x01, 0x00, 0xFE, 0x00
}
;

// BER-TLV Tag 5FC102
static Octet CHUID_DATA [ ] = 
{ 0xEE, 0x02, 0xF9, 0x05, 0x30, 0x19, 0xD6, 0x50, 0x18, 0x58, 
 0x21, 0x0C, 0x2D, 0x31, 0x71, 0xB5, 0x25, 0xA1, 0x68, 0x5A, 
 0x08, 0xC9, 0x2A, 0xDE, 0x0A, 0x61, 0x86, 0x50, 0x18, 0x43, 
 0xE2, 0x34, 0x10, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 
 0x38, 0x39, 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x35, 
 0x08, 0x32, 0x30, 0x30, 0x39, 0x30, 0x38, 0x32, 0x34, 0x3D, 
 0x00, 0x3E, 0x82, 0x05, 0xB8, 0x30, 0x82, 0x05, 0xB4, 0x06, 
 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x07, 0x02, 
 0xA0, 0x82, 0x05, 0xA5, 0x30, 0x82, 0x05, 0xA1, 0x02, 0x01, 
 0x03, 0x31, 0x0B, 0x30, 0x09, 0x06, 0x05, 0x2B, 0x0E, 0x03, 
 0x02, 0x1A, 0x05, 0x00, 0x30, 0x0A, 0x06, 0x08, 0x60, 0x86, 
 0x48, 0x01, 0x65, 0x03, 0x06, 0x01, 0xA0, 0x82, 0x03, 0x71, 
 0x30, 0x82, 0x03, 0x6D, 0x30, 0x82, 0x02, 0x55, 0xA0, 0x03, 
 0x02, 0x01, 0x02, 0x02, 0x02, 0x27, 0x10, 0x30, 0x0D, 0x06, 
 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x01, 0x05, 
 0x05, 0x00, 0x30, 0x32, 0x31, 0x0B, 0x30, 0x09, 0x06, 0x03, 
 0x55, 0x04, 0x06, 0x13, 0x02, 0x55, 0x53, 0x31, 0x0D, 0x30, 
 0x0B, 0x06, 0x03, 0x55, 0x04, 0x0A, 0x13, 0x04, 0x4E, 0x49, 
 0x53, 0x54, 0x31, 0x14, 0x30, 0x12, 0x06, 0x03, 0x55, 0x04, 
 0x03, 0x13, 0x0B, 0x50, 0x49, 0x56, 0x20, 0x54, 0x65, 0x73, 
 0x74, 0x20, 0x43, 0x41, 0x30, 0x1E, 0x17, 0x0D, 0x30, 0x37, 
 0x30, 0x34, 0x31, 0x39, 0x31, 0x35, 0x32, 0x32, 0x33, 0x33, 
 0x5A, 0x17, 0x0D, 0x31, 0x35, 0x30, 0x34, 0x31, 0x39, 0x31, 
 0x35, 0x32, 0x32, 0x33, 0x33, 0x5A, 0x30, 0x3E, 0x31, 0x0B, 
 0x30, 0x09, 0x06, 0x03, 0x55, 0x04, 0x06, 0x13, 0x02, 0x55, 
 0x53, 0x31, 0x0D, 0x30, 0x0B, 0x06, 0x03, 0x55, 0x04, 0x0A, 
 0x13, 0x04, 0x4E, 0x49, 0x53, 0x54, 0x31, 0x20, 0x30, 0x1E, 
 0x06, 0x03, 0x55, 0x04, 0x03, 0x13, 0x17, 0x50, 0x49, 0x56, 
 0x20, 0x54, 0x65, 0x73, 0x74, 0x20, 0x43, 0x6F, 0x6E, 0x74, 
 0x65, 0x6E, 0x74, 0x20, 0x53, 0x69, 0x67, 0x6E, 0x65, 0x72, 
 0x30, 0x82, 0x01, 0x22, 0x30, 0x0D, 0x06, 0x09, 0x2A, 0x86, 
 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x01, 0x01, 0x05, 0x00, 0x03, 
 0x82, 0x01, 0x0F, 0x00, 0x30, 0x82, 0x01, 0x0A, 0x02, 0x82, 
 0x01, 0x01, 0x00, 0x97, 0xB6, 0xB1, 0x24, 0xDF, 0x0B, 0x63, 
 0x7F, 0x1D, 0xE5, 0x8F, 0xA6, 0xE3, 0xED, 0x1F, 0x9A, 0x40, 
 0xCC, 0x01, 0x08, 0xE8, 0x7B, 0x63, 0x22, 0x6D, 0xA0, 0x9D, 
 0xB4, 0x7C, 0x5F, 0xD1, 0xFE, 0xA1, 0xC0, 0x6A, 0xD8, 0x85, 
 0x1A, 0x76, 0x09, 0xC3, 0x5A, 0x6E, 0xD0, 0xA7, 0x8E, 0x6D, 
 0x18, 0x43, 0xF0, 0xD0, 0xD9, 0xF2, 0xE0, 0x05, 0xBD, 0x5C, 
 0x65, 0x9C, 0x24, 0xCE, 0x79, 0xBE, 0x32, 0x48, 0x9C, 0xF5, 
 0xC8, 0x30, 0x90, 0xD4, 0x86, 0x35, 0x0F, 0xE1, 0x79, 0x84, 
 0x2E, 0xE1, 0xAF, 0x28, 0xEB, 0x0B, 0x96, 0x8F, 0x68, 0x66, 
 0x50, 0x85, 0xA7, 0x55, 0x14, 0xA1, 0xC8, 0x23, 0x02, 0xDC, 
 0x85, 0xE5, 0x0D, 0x8B, 0x85, 0x7E, 0xF1, 0xEC, 0xC7, 0x60, 
 0xB1, 0xE2, 0xFA, 0xAC, 0x23, 0xC8, 0x14, 0xF1, 0x7E, 0xF4, 
 0x08, 0x68, 0x3B, 0x24, 0xD4, 0x57, 0x91, 0xB4, 0x42, 0xFC, 
 0xE5, 0xB9, 0x0D, 0xFB, 0x22, 0x77, 0xF4, 0x23, 0x04, 0x99, 
 0xB4, 0x59, 0xF8, 0x06, 0xB8, 0xAB, 0xE0, 0x12, 0x73, 0x6B, 
 0xC7, 0xDD, 0xE4, 0xF3, 0x28, 0x88, 0x0A, 0x12, 0x52, 0xDF, 
 0x6E, 0xE3, 0x58, 0x1B, 0x72, 0xA8, 0x75, 0x6C, 0xB1, 0xDB, 
 0xEA, 0xD8, 0x91, 0x7F, 0x9C, 0xBD, 0xB1, 0xAB, 0xD1, 0x4C, 
 0xF5, 0x24, 0xBD, 0x5E, 0x79, 0x32, 0xD8, 0x9D, 0x98, 0x63, 
 0x13, 0x7C, 0x21, 0xC9, 0x33, 0xB7, 0x49, 0x21, 0x30, 0xFE, 
 0x60, 0x52, 0xA7, 0xB5, 0xEA, 0x79, 0xB3, 0x14, 0x98, 0x6A, 
 0xA5, 0x49, 0x47, 0x2E, 0x1F, 0xBE, 0x47, 0x66, 0xEB, 0xA6, 
 0x7C, 0xA3, 0x4D, 0x94, 0x2C, 0x47, 0x16, 0x80, 0x53, 0x01, 
 0xE7, 0x85, 0x8A, 0x46, 0x8C, 0x6E, 0xB7, 0xB0, 0xB0, 0x50, 
 0xE8, 0xCB, 0x82, 0x69, 0x1E, 0x6E, 0x3E, 0xD3, 0x70, 0x16, 
 0x93, 0x5B, 0x55, 0x23, 0x9A, 0x23, 0xED, 0x69, 0x77, 0x02, 
 0x03, 0x01, 0x00, 0x01, 0xA3, 0x81, 0x80, 0x30, 0x7E, 0x30, 
 0x1F, 0x06, 0x03, 0x55, 0x1D, 0x23, 0x04, 0x18, 0x30, 0x16, 
 0x80, 0x14, 0xEB, 0xDA, 0x19, 0xD2, 0x08, 0x42, 0x8D, 0xF4, 
 0xDE, 0x25, 0x87, 0x69, 0xC9, 0xBB, 0xAB, 0x0C, 0xD3, 0x96, 
 0x30, 0x01, 0x30, 0x1D, 0x06, 0x03, 0x55, 0x1D, 0x0E, 0x04, 
 0x16, 0x04, 0x14, 0x26, 0x45, 0xAF, 0x29, 0xE8, 0x7C, 0x9A, 
 0xD7, 0x1A, 0x17, 0xB3, 0xDC, 0x79, 0xE2, 0xD2, 0xFF, 0x99, 
 0x9E, 0x33, 0x6E, 0x30, 0x17, 0x06, 0x03, 0x55, 0x1D, 0x20, 
 0x04, 0x10, 0x30, 0x0E, 0x30, 0x0C, 0x06, 0x0A, 0x60, 0x86, 
 0x48, 0x01, 0x65, 0x03, 0x02, 0x01, 0x03, 0x08, 0x30, 0x13, 
 0x06, 0x03, 0x55, 0x1D, 0x25, 0x04, 0x0C, 0x30, 0x0A, 0x06, 
 0x08, 0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x06, 0x07, 0x30, 
 0x0E, 0x06, 0x03, 0x55, 0x1D, 0x0F, 0x01, 0x01, 0xFF, 0x04, 
 0x04, 0x03, 0x02, 0x07, 0x80, 0x30, 0x0D, 0x06, 0x09, 0x2A, 
 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x01, 0x05, 0x05, 0x00, 
 0x03, 0x82, 0x01, 0x01, 0x00, 0x79, 0x88, 0xCC, 0x1E, 0x4B, 
 0xEA, 0x88, 0xA3, 0x17, 0x6E, 0x48, 0x61, 0xA9, 0x81, 0xD3, 
 0xE3, 0x8A, 0x69, 0x93, 0xC9, 0x00, 0xCB, 0x43, 0x72, 0xDF, 
 0x02, 0x3E, 0xCD, 0x66, 0xBF, 0x05, 0x58, 0x61, 0xC8, 0x51, 
 0xF9, 0x73, 0x9D, 0xB2, 0xD4, 0x64, 0xDC, 0xF2, 0x3F, 0x1A, 
 0xD3, 0x8D, 0x55, 0xE7, 0x6F, 0x78, 0xAA, 0x9C, 0x14, 0x45, 
 0x7E, 0x6A, 0x8C, 0xA3, 0x0D, 0x64, 0x2F, 0xCD, 0x23, 0xC1, 
 0x60, 0xEE, 0x35, 0x29, 0x5C, 0xBD, 0x3A, 0xD0, 0xAE, 0x51, 
 0x13, 0xBF, 0xE4, 0x4E, 0xEE, 0xC0, 0x98, 0x3B, 0x5F, 0x07, 
 0x2C, 0x2E, 0x41, 0xC1, 0xF1, 0x46, 0x89, 0xF4, 0xD1, 0x36, 
 0xA9, 0xFE, 0x85, 0xC9, 0x65, 0xA2, 0x8C, 0x68, 0xD4, 0x0D, 
 0x15, 0xB2, 0xBA, 0x2A, 0x64, 0xD4, 0x37, 0xF5, 0xDE, 0xEE, 
 0xC4, 0xA6, 0x63, 0x1C, 0x2F, 0xCE, 0xFD, 0xDB, 0x39, 0xB0, 
 0xB7, 0x17, 0x77, 0x24, 0x9C, 0x0D, 0x92, 0x4D, 0x80, 0xEB, 
 0x24, 0xFF, 0xA4, 0xC1, 0x60, 0x32, 0xDC, 0x94, 0x3C, 0x5A, 
 0x4A, 0xA5, 0x63, 0x15, 0x12, 0xAB, 0x71, 0x1A, 0x57, 0xA9, 
 0x04, 0x9A, 0xA1, 0x1A, 0xA6, 0x7F, 0x15, 0x50, 0x85, 0x04, 
 0x39, 0xAF, 0x3F, 0xE8, 0xA5, 0x55, 0xEA, 0x7A, 0xE2, 0x3A, 
 0x89, 0x6F, 0xF9, 0x9E, 0xC7, 0x2E, 0x12, 0xF1, 0x1B, 0x81, 
 0x88, 0x16, 0x93, 0x5E, 0x04, 0x45, 0x6C, 0xF7, 0x1F, 0x2D, 
 0x3B, 0x52, 0x2E, 0xB2, 0xE5, 0x31, 0xE9, 0x47, 0x5F, 0xC7, 
 0xE5, 0x9D, 0xB3, 0x68, 0x4D, 0x76, 0x65, 0x35, 0xAE, 0xA6, 
 0x45, 0xE4, 0xAD, 0x78, 0x0F, 0xF5, 0xEA, 0xC0, 0xEA, 0x9A, 
 0xCD, 0xB4, 0x01, 0x61, 0xBA, 0x67, 0xF5, 0xAC, 0xA1, 0xE6, 
 0x8A, 0xE0, 0x9D, 0x03, 0x2A, 0x49, 0xD7, 0xFC, 0x32, 0x21, 
 0x33, 0x29, 0x66, 0x50, 0xB1, 0x79, 0xD0, 0xA0, 0xD3, 0xEB, 
 0x91, 0x31, 0x82, 0x02, 0x0C, 0x30, 0x82, 0x02, 0x08, 0x02, 
 0x01, 0x01, 0x30, 0x38, 0x30, 0x32, 0x31, 0x0B, 0x30, 0x09, 
 0x06, 0x03, 0x55, 0x04, 0x06, 0x13, 0x02, 0x55, 0x53, 0x31, 
 0x0D, 0x30, 0x0B, 0x06, 0x03, 0x55, 0x04, 0x0A, 0x13, 0x04, 
 0x4E, 0x49, 0x53, 0x54, 0x31, 0x14, 0x30, 0x12, 0x06, 0x03, 
 0x55, 0x04, 0x03, 0x13, 0x0B, 0x50, 0x49, 0x56, 0x20, 0x54, 
 0x65, 0x73, 0x74, 0x20, 0x43, 0x41, 0x02, 0x02, 0x27, 0x10, 
 0x30, 0x09, 0x06, 0x05, 0x2B, 0x0E, 0x03, 0x02, 0x1A, 0x05, 
 0x00, 0xA0, 0x81, 0xAA, 0x30, 0x17, 0x06, 0x09, 0x2A, 0x86, 
 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x09, 0x03, 0x31, 0x0A, 0x06, 
 0x08, 0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x06, 0x01, 0x30, 
 0x1C, 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 
 0x09, 0x05, 0x31, 0x0F, 0x17, 0x0D, 0x30, 0x37, 0x30, 0x35, 
 0x31, 0x37, 0x32, 0x31, 0x30, 0x34, 0x35, 0x30, 0x5A, 0x30, 
 0x23, 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 
 0x09, 0x04, 0x31, 0x16, 0x04, 0x14, 0x59, 0x40, 0x25, 0x85, 
 0xB8, 0x80, 0x5A, 0x8B, 0x78, 0x7A, 0x47, 0xF8, 0x79, 0x77, 
 0x86, 0x11, 0xCA, 0x16, 0xD0, 0x9F, 0x30, 0x4C, 0x06, 0x08, 
 0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x06, 0x05, 0x31, 0x40, 
 0x30, 0x3E, 0x31, 0x0D, 0x30, 0x0B, 0x06, 0x03, 0x55, 0x04, 
 0x0A, 0x13, 0x04, 0x4E, 0x49, 0x53, 0x54, 0x31, 0x0B, 0x30, 
 0x09, 0x06, 0x03, 0x55, 0x04, 0x06, 0x13, 0x02, 0x55, 0x53, 
 0x31, 0x20, 0x30, 0x1E, 0x06, 0x03, 0x55, 0x04, 0x03, 0x13, 
 0x17, 0x50, 0x49, 0x56, 0x20, 0x54, 0x65, 0x73, 0x74, 0x20, 
 0x43, 0x6F, 0x6E, 0x74, 0x65, 0x6E, 0x74, 0x20, 0x53, 0x69, 
 0x67, 0x6E, 0x65, 0x72, 0x30, 0x0D, 0x06, 0x09, 0x2A, 0x86, 
 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x01, 0x01, 0x05, 0x00, 0x04, 
 0x82, 0x01, 0x00, 0x95, 0x97, 0x0D, 0xB3, 0x61, 0x33, 0x3D, 
 0x10, 0xEF, 0x2C, 0xAA, 0x9B, 0x46, 0xE0, 0x68, 0x55, 0xCA, 
 0xCC, 0xD2, 0x74, 0xE2, 0xB2, 0x66, 0x43, 0xB6, 0xBA, 0xEE, 
 0xAB, 0x14, 0xCE, 0xB2, 0xA2, 0x95, 0x19, 0x4B, 0x4F, 0x83, 
 0xC5, 0x0D, 0x08, 0xAA, 0x80, 0xF0, 0x85, 0xDD, 0x16, 0xE0, 
 0x8E, 0x69, 0x17, 0x0A, 0xF4, 0xB6, 0xE6, 0x58, 0xCC, 0xEA, 
 0xDD, 0x2D, 0x56, 0xDE, 0x24, 0xB8, 0x1A, 0xF7, 0xE1, 0xC7, 
 0x22, 0x24, 0x78, 0x7E, 0x7F, 0x9F, 0xBD, 0x5E, 0x6D, 0x16, 
 0x2F, 0xCB, 0xEC, 0xC3, 0x0E, 0x4D, 0xA3, 0x8A, 0xEB, 0xAF, 
 0xD3, 0xF5, 0xD3, 0xD9, 0x3A, 0xCE, 0x09, 0x9A, 0xE8, 0xE9, 
 0x2D, 0x0A, 0x0B, 0xE4, 0xA4, 0xEA, 0xD5, 0xBB, 0xC8, 0x19, 
 0x1E, 0x1F, 0xB8, 0xF5, 0xE3, 0x28, 0x92, 0x1B, 0x03, 0xCB, 
 0x84, 0x90, 0xD3, 0xCF, 0xE1, 0x25, 0x40, 0x8A, 0x85, 0x84, 
 0x7D, 0x89, 0xFE, 0x55, 0x5F, 0x42, 0x17, 0xB0, 0x9C, 0x42, 
 0xC1, 0x2D, 0xA0, 0x16, 0x27, 0x0A, 0xDD, 0x11, 0x70, 0xB1, 
 0x2D, 0xF0, 0x93, 0xAC, 0xD3, 0x3A, 0x60, 0xF9, 0x96, 0xF5, 
 0x5D, 0x41, 0x5E, 0x5C, 0xFE, 0xB4, 0x64, 0xA6, 0xAE, 0x76, 
 0x05, 0xE0, 0xD9, 0x03, 0x3E, 0x60, 0xA0, 0x89, 0x59, 0x92, 
 0xB3, 0x0C, 0x5F, 0xE0, 0xB7, 0x53, 0x1B, 0x98, 0x65, 0x50, 
 0x14, 0xA0, 0xAC, 0xD8, 0x2A, 0xBD, 0x86, 0xC5, 0x83, 0x07, 
 0x7C, 0xF5, 0x57, 0x6B, 0xEB, 0x53, 0x95, 0xDC, 0x2B, 0x3A, 
 0x77, 0x29, 0x2A, 0xA9, 0x79, 0x22, 0x1B, 0x7D, 0xB0, 0xDA, 
 0xF2, 0x9A, 0x27, 0xC9, 0x3D, 0x9E, 0xF9, 0x0C, 0xDF, 0x8A, 
 0xCC, 0xE0, 0x17, 0xF4, 0x9A, 0xFC, 0xDB, 0xD0, 0x6B, 0x7B, 
 0x1A, 0xD7, 0x08, 0xC4, 0xBE, 0xBB, 0xF7, 0x4C, 0x70, 0xB1, 
 0x19, 0xA7, 0x51, 0x4D, 0x87, 0x15, 0xBD, 0xE3, 0x69, 0xFE, 
 0x00
}
;

// BER-TLV Tag 5FC103
static Octet FINGER_1_DATA [ ] = 
{ 0xBC, 0x82, 0x05, 0x0C, 0x03, 0x0D, 0x00, 0x00, 0x02, 0x48, 
 0x02, 0x6C, 0x00, 0x1B, 0x02, 0x01, 0x14, 0x07, 0x04, 0x13, 
 0x0B, 0x16, 0x21, 0x5A, 0x14, 0x07, 0x04, 0x13, 0x0B, 0x16, 
 0x21, 0x5A, 0x14, 0x0B, 0x04, 0x13, 0x0B, 0x16, 0x21, 0x5A, 
 0x00, 0x00, 0x08, 0x80, 0xFE, 0x4E, 0x49, 0x53, 0x54, 0x20, 
 0x43, 0x72, 0x65, 0x61, 0x74, 0x6F, 0x72, 0x00, 0x00, 0x00, 
 0x00, 0x00, 0x00, 0xD6, 0x50, 0x18, 0x58, 0x21, 0x0C, 0x2D, 
 0x31, 0x71, 0xB5, 0x25, 0xA1, 0x68, 0x5A, 0x08, 0xC9, 0x2A, 
 0xDE, 0x0A, 0x61, 0x86, 0x50, 0x18, 0x43, 0xE2, 0x00, 0x00, 
 0x00, 0x00, 0x46, 0x4D, 0x52, 0x00, 0x20, 0x32, 0x30, 0x00, 
 0x02, 0x48, 0x00, 0x01, 0x00, 0x01, 0x80, 0x01, 0x02, 0x00, 
 0x01, 0xE0, 0x00, 0xC5, 0x00, 0xC5, 0x02, 0x00, 0x07, 0x00, 
 0x42, 0x29, 0x41, 0x35, 0x00, 0x51, 0x04, 0x00, 0x41, 0x21, 
 0x00, 0x7A, 0x04, 0x00, 0x40, 0xC2, 0x00, 0x7B, 0x6D, 0x00, 
 0x41, 0x3C, 0x00, 0x80, 0x5B, 0x00, 0x41, 0x2D, 0x00, 0x90, 
 0x01, 0x00, 0x80, 0xD1, 0x00, 0xA5, 0x0B, 0x00, 0x41, 0x6B, 
 0x00, 0xB0, 0x4D, 0x00, 0x41, 0x21, 0x00, 0xBF, 0x62, 0x00, 
 0x40, 0xEB, 0x00, 0xC6, 0x10, 0x00, 0x40, 0xFB, 0x00, 0xDF, 
 0x0B, 0x00, 0x41, 0x33, 0x00, 0xE5, 0xAD, 0x00, 0x40, 0xA8, 
 0x00, 0xE8, 0x73, 0x00, 0x81, 0x57, 0x00, 0xEB, 0x98, 0x00, 
 0x81, 0x00, 0x00, 0xF1, 0x07, 0x00, 0x81, 0x16, 0x00, 0xF2, 
 0x62, 0x00, 0x81, 0x4C, 0x00, 0xF3, 0x4C, 0x00, 0x41, 0x20, 
 0x00, 0xF7, 0x68, 0x00, 0x41, 0x02, 0x00, 0xF9, 0x6B, 0x00, 
 0x81, 0x43, 0x00, 0xFD, 0x56, 0x00, 0x81, 0x68, 0x01, 0x09, 
 0xA3, 0x00, 0x81, 0x7C, 0x01, 0x0F, 0x49, 0x00, 0x80, 0xB8, 
 0x01, 0x2F, 0x1D, 0x00, 0x40, 0x9E, 0x01, 0x49, 0x1D, 0x00, 
 0x41, 0x25, 0x01, 0x51, 0x82, 0x00, 0x80, 0xA9, 0x01, 0x53, 
 0x66, 0x00, 0x80, 0x9C, 0x01, 0x54, 0x6B, 0x00, 0x80, 0xC0, 
 0x01, 0x5B, 0x1A, 0x00, 0x41, 0x3B, 0x01, 0x61, 0x9C, 0x00, 
 0x81, 0x12, 0x01, 0x69, 0x22, 0x00, 0x41, 0x14, 0x01, 0x76, 
 0x1A, 0x00, 0x41, 0x27, 0x01, 0x79, 0xAC, 0x00, 0x80, 0xB3, 
 0x01, 0x7F, 0x12, 0x00, 0x81, 0x3B, 0x01, 0x82, 0x53, 0x00, 
 0x81, 0x65, 0x01, 0x86, 0x4C, 0x00, 0x80, 0xE1, 0x01, 0x90, 
 0x11, 0x00, 0x80, 0xE0, 0x01, 0x9E, 0x0B, 0x00, 0x41, 0x65, 
 0x01, 0xA5, 0x51, 0x00, 0x40, 0xC3, 0x01, 0xB0, 0x08, 0x00, 
 0x40, 0xF6, 0x01, 0xBB, 0x04, 0x00, 0x80, 0xEC, 0x01, 0xC7, 
 0x01, 0x00, 0x41, 0x38, 0x01, 0xC8, 0x58, 0x00, 0x00, 0x00, 
 0x02, 0x10, 0x42, 0x32, 0x41, 0x31, 0x00, 0x15, 0xA4, 0x00, 
 0x80, 0xEF, 0x00, 0x1F, 0xAD, 0x00, 0x41, 0x3C, 0x00, 0x39, 
 0x4A, 0x00, 0x41, 0x56, 0x00, 0x39, 0x47, 0x00, 0x81, 0x01, 
 0x00, 0x40, 0xAD, 0x00, 0x81, 0x17, 0x00, 0x4D, 0x51, 0x00, 
 0x41, 0x4B, 0x00, 0x4D, 0x9C, 0x00, 0x41, 0x59, 0x00, 0x64, 
 0x44, 0x00, 0x81, 0x4F, 0x00, 0x70, 0x9E, 0x00, 0x40, 0xBA, 
 0x00, 0x81, 0x06, 0x00, 0x80, 0xAE, 0x00, 0x8A, 0x04, 0x00, 
 0x80, 0xB1, 0x00, 0x97, 0x5A, 0x00, 0x41, 0x6A, 0x00, 0x9A, 
 0x41, 0x00, 0x41, 0x19, 0x00, 0xA1, 0x4C, 0x00, 0x81, 0x41, 
 0x00, 0xA5, 0x9D, 0x00, 0x40, 0xA3, 0x00, 0xAD, 0x02, 0x00, 
 0x40, 0xB5, 0x00, 0xB9, 0x68, 0x00, 0x41, 0x46, 0x00, 0xBA, 
 0x42, 0x00, 0x40, 0xB2, 0x00, 0xC1, 0x0B, 0x00, 0x40, 0xE3, 
 0x00, 0xC7, 0x01, 0x00, 0x40, 0xC9, 0x00, 0xC9, 0x0B, 0x00, 
 0x40, 0xA7, 0x00, 0xD3, 0x06, 0x00, 0x81, 0x03, 0x01, 0x0D, 
 0x9B, 0x00, 0x80, 0xFA, 0x01, 0x1B, 0x3F, 0x00, 0x81, 0x30, 
 0x01, 0x1F, 0x79, 0x00, 0x41, 0x11, 0x01, 0x2B, 0x1D, 0x00, 
 0x81, 0x1D, 0x01, 0x2F, 0x1A, 0x00, 0x41, 0x41, 0x01, 0x31, 
 0x36, 0x00, 0x81, 0x2D, 0x01, 0x35, 0x0F, 0x00, 0x81, 0x3F, 
 0x01, 0x3A, 0x59, 0x00, 0x81, 0x1E, 0x01, 0x3F, 0x09, 0x00, 
 0x81, 0x43, 0x01, 0x46, 0x5A, 0x00, 0x81, 0x32, 0x01, 0x4B, 
 0x00, 0x00, 0x40, 0xFF, 0x01, 0x4F, 0x0F, 0x00, 0x41, 0x61, 
 0x01, 0x52, 0xA1, 0x00, 0x81, 0x4D, 0x01, 0x57, 0xA8, 0x00, 
 0x81, 0x1D, 0x01, 0x59, 0x62, 0x00, 0x41, 0x7E, 0x01, 0x5A, 
 0x44, 0x00, 0x41, 0x66, 0x01, 0x5D, 0x4C, 0x00, 0x41, 0x69, 
 0x01, 0x5E, 0x9B, 0x00, 0x80, 0xCB, 0x01, 0x61, 0x0F, 0x00, 
 0x81, 0x00, 0x01, 0x63, 0x0A, 0x00, 0x81, 0x5F, 0x01, 0x67, 
 0x4D, 0x00, 0x81, 0x2B, 0x01, 0x6E, 0x5F, 0x00, 0x80, 0xC0, 
 0x01, 0x79, 0x0E, 0x00, 0x81, 0x7F, 0x01, 0x7A, 0x45, 0x00, 
 0x81, 0x70, 0x01, 0x81, 0x4D, 0x00, 0x81, 0x35, 0x01, 0x87, 
 0x62, 0x00, 0x81, 0x18, 0x01, 0x98, 0x05, 0x00, 0x81, 0x2A, 
 0x01, 0x9B, 0x5E, 0x00, 0x00, 0x00, 0x30, 0x82, 0x02, 0x68, 
 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x07, 
 0x02, 0xA0, 0x82, 0x02, 0x59, 0x30, 0x82, 0x02, 0x55, 0x02, 
 0x01, 0x03, 0x31, 0x0B, 0x30, 0x09, 0x06, 0x05, 0x2B, 0x0E, 
 0x03, 0x02, 0x1A, 0x05, 0x00, 0x30, 0x0A, 0x06, 0x08, 0x60, 
 0x86, 0x48, 0x01, 0x65, 0x03, 0x06, 0x02, 0x31, 0x82, 0x02, 
 0x35, 0x30, 0x82, 0x02, 0x31, 0x02, 0x01, 0x01, 0x30, 0x38, 
 0x30, 0x32, 0x31, 0x0B, 0x30, 0x09, 0x06, 0x03, 0x55, 0x04, 
 0x06, 0x13, 0x02, 0x55, 0x53, 0x31, 0x0D, 0x30, 0x0B, 0x06, 
 0x03, 0x55, 0x04, 0x0A, 0x13, 0x04, 0x4E, 0x49, 0x53, 0x54, 
 0x31, 0x14, 0x30, 0x12, 0x06, 0x03, 0x55, 0x04, 0x03, 0x13, 
 0x0B, 0x50, 0x49, 0x56, 0x20, 0x54, 0x65, 0x73, 0x74, 0x20, 
 0x43, 0x41, 0x02, 0x02, 0x27, 0x10, 0x30, 0x09, 0x06, 0x05, 
 0x2B, 0x0E, 0x03, 0x02, 0x1A, 0x05, 0x00, 0xA0, 0x81, 0xD3, 
 0x30, 0x17, 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 
 0x01, 0x09, 0x03, 0x31, 0x0A, 0x06, 0x08, 0x60, 0x86, 0x48, 
 0x01, 0x65, 0x03, 0x06, 0x02, 0x30, 0x1C, 0x06, 0x09, 0x2A, 
 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x09, 0x05, 0x31, 0x0F, 
 0x17, 0x0D, 0x30, 0x37, 0x30, 0x35, 0x31, 0x37, 0x32, 0x31, 
 0x30, 0x39, 0x32, 0x32, 0x5A, 0x30, 0x23, 0x06, 0x09, 0x2A, 
 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x09, 0x04, 0x31, 0x16, 
 0x04, 0x14, 0xB0, 0x3D, 0x96, 0x4E, 0xC1, 0x3D, 0xF5, 0x4E, 
 0x0E, 0x9A, 0xEA, 0xF9, 0x23, 0xF3, 0xBA, 0x38, 0xBF, 0x25, 
 0xF3, 0x22, 0x30, 0x27, 0x06, 0x08, 0x60, 0x86, 0x48, 0x01, 
 0x65, 0x03, 0x06, 0x06, 0x31, 0x1B, 0x04, 0x19, 0xD6, 0x50, 
 0x18, 0x58, 0x21, 0x0C, 0x2D, 0x31, 0x71, 0xB5, 0x25, 0xA1, 
 0x68, 0x5A, 0x08, 0xC9, 0x2A, 0xDE, 0x0A, 0x61, 0x86, 0x50, 
 0x18, 0x43, 0xE2, 0x30, 0x4C, 0x06, 0x08, 0x60, 0x86, 0x48, 
 0x01, 0x65, 0x03, 0x06, 0x05, 0x31, 0x40, 0x30, 0x3E, 0x31, 
 0x0D, 0x30, 0x0B, 0x06, 0x03, 0x55, 0x04, 0x0A, 0x13, 0x04, 
 0x4E, 0x49, 0x53, 0x54, 0x31, 0x0B, 0x30, 0x09, 0x06, 0x03, 
 0x55, 0x04, 0x06, 0x13, 0x02, 0x55, 0x53, 0x31, 0x20, 0x30, 
 0x1E, 0x06, 0x03, 0x55, 0x04, 0x03, 0x13, 0x17, 0x50, 0x49, 
 0x56, 0x20, 0x54, 0x65, 0x73, 0x74, 0x20, 0x43, 0x6F, 0x6E, 
 0x74, 0x65, 0x6E, 0x74, 0x20, 0x53, 0x69, 0x67, 0x6E, 0x65, 
 0x72, 0x30, 0x0D, 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 
 0x0D, 0x01, 0x01, 0x01, 0x05, 0x00, 0x04, 0x82, 0x01, 0x00, 
 0x4D, 0x48, 0x4F, 0xFC, 0xFE, 0xAC, 0xAF, 0xE4, 0x0C, 0x5D, 
 0x4E, 0x28, 0xA0, 0x8F, 0xCB, 0xFC, 0xBC, 0xA1, 0x5D, 0x21, 
 0xB0, 0x18, 0xFC, 0x45, 0xD6, 0xED, 0x95, 0x2A, 0xDA, 0xDE, 
 0x5C, 0x3E, 0x77, 0xB7, 0x0B, 0xFB, 0xB5, 0xD8, 0x58, 0xE8, 
 0x2E, 0xF4, 0x23, 0xFB, 0x64, 0x31, 0xA9, 0x22, 0x24, 0xF3, 
 0x41, 0x96, 0x7D, 0x9D, 0x6F, 0x65, 0x93, 0xFE, 0x0E, 0xF6, 
 0x80, 0x83, 0x24, 0xB1, 0xAF, 0x34, 0x95, 0x7D, 0x15, 0x5B, 
 0x72, 0xE1, 0x50, 0xE9, 0x24, 0x8E, 0x44, 0x31, 0x8B, 0x27, 
 0xD7, 0xBE, 0x55, 0xE0, 0x3F, 0x89, 0x51, 0x00, 0x22, 0x84, 
 0x7C, 0xA6, 0x84, 0xE8, 0xBA, 0x3B, 0xCC, 0x45, 0x0B, 0xBA, 
 0x20, 0x1E, 0xF9, 0x85, 0xF2, 0xAF, 0x08, 0x21, 0x3F, 0x39, 
 0xC4, 0x67, 0xD0, 0xC0, 0xC5, 0xD3, 0x42, 0xAD, 0x25, 0x1A, 
 0xA5, 0xDE, 0x56, 0xC2, 0x03, 0xF5, 0x65, 0xA8, 0xCB, 0xC6, 
 0x07, 0x3B, 0x48, 0x77, 0x3F, 0xD9, 0xCD, 0xE7, 0x78, 0x5D, 
 0xB1, 0xD6, 0x60, 0xD0, 0x70, 0x51, 0x8F, 0x47, 0x1B, 0xB5, 
 0x96, 0xCE, 0x8E, 0x7B, 0x38, 0x2B, 0x1A, 0x45, 0x5B, 0xE3, 
 0x37, 0x83, 0xA6, 0xE1, 0x5C, 0x3D, 0x26, 0xC4, 0x37, 0xED, 
 0xCB, 0xBD, 0x9E, 0xED, 0x36, 0x20, 0x33, 0x98, 0x1F, 0xF3, 
 0xDF, 0xB4, 0x9C, 0xBC, 0x21, 0xB3, 0xDD, 0x4A, 0x64, 0x2B, 
 0x9F, 0x10, 0x7C, 0x7B, 0x7A, 0x7A, 0xA9, 0x7F, 0x0B, 0xED, 
 0x27, 0x07, 0x34, 0x73, 0x8E, 0xD1, 0xC0, 0x56, 0x1E, 0x63, 
 0x37, 0x39, 0xC5, 0xAF, 0x65, 0x6A, 0xF3, 0xE8, 0x43, 0x9C, 
 0x84, 0x01, 0x16, 0x36, 0x68, 0xCA, 0x60, 0xCD, 0x7A, 0xC9, 
 0x60, 0xD6, 0xC1, 0x77, 0xE9, 0x9C, 0x77, 0x61, 0x3F, 0xC5, 
 0x0E, 0xDA, 0xD9, 0x82, 0x30, 0xFA, 0x5D, 0x6C, 0xC0, 0xA0, 
 0xCF, 0x0B, 0xC6, 0x42, 0x75, 0x1B, 0xFE, 0x00
 }
 ;

// BER-TLV Tag 5FC104
static Octet FINGER_2_DATA [ ] = 
{ 0xBC, 0x82, 0x05, 0x0C, 0x03, 0x0D, 0x00, 0x00, 0x02, 0x48, 
 0x02, 0x6C, 0x00, 0x1B, 0x02, 0x01, 0x14, 0x07, 0x04, 0x13, 
 0x0B, 0x16, 0x21, 0x5A, 0x14, 0x07, 0x04, 0x13, 0x0B, 0x16, 
 0x21, 0x5A, 0x14, 0x0B, 0x04, 0x13, 0x0B, 0x16, 0x21, 0x5A, 
 0x00, 0x00, 0x08, 0x80, 0xFE, 0x4E, 0x49, 0x53, 0x54, 0x20, 
 0x43, 0x72, 0x65, 0x61, 0x74, 0x6F, 0x72, 0x00, 0x00, 0x00, 
 0x00, 0x00, 0x00, 0xD6, 0x50, 0x18, 0x58, 0x21, 0x0C, 0x2D, 
 0x31, 0x71, 0xB5, 0x25, 0xA1, 0x68, 0x5A, 0x08, 0xC9, 0x2A, 
 0xDE, 0x0A, 0x61, 0x86, 0x50, 0x18, 0x43, 0xE2, 0x00, 0x00, 
 0x00, 0x00, 0x46, 0x4D, 0x52, 0x00, 0x20, 0x32, 0x30, 0x00, 
 0x02, 0x48, 0x00, 0x01, 0x00, 0x01, 0x80, 0x01, 0x02, 0x00, 
 0x01, 0xE0, 0x00, 0xC5, 0x00, 0xC5, 0x02, 0x00, 0x07, 0x00, 
 0x42, 0x29, 0x41, 0x35, 0x00, 0x51, 0x04, 0x00, 0x41, 0x21, 
 0x00, 0x7A, 0x04, 0x00, 0x40, 0xC2, 0x00, 0x7B, 0x6D, 0x00, 
 0x41, 0x3C, 0x00, 0x80, 0x5B, 0x00, 0x41, 0x2D, 0x00, 0x90, 
 0x01, 0x00, 0x80, 0xD1, 0x00, 0xA5, 0x0B, 0x00, 0x41, 0x6B, 
 0x00, 0xB0, 0x4D, 0x00, 0x41, 0x21, 0x00, 0xBF, 0x62, 0x00, 
 0x40, 0xEB, 0x00, 0xC6, 0x10, 0x00, 0x40, 0xFB, 0x00, 0xDF, 
 0x0B, 0x00, 0x41, 0x33, 0x00, 0xE5, 0xAD, 0x00, 0x40, 0xA8, 
 0x00, 0xE8, 0x73, 0x00, 0x81, 0x57, 0x00, 0xEB, 0x98, 0x00, 
 0x81, 0x00, 0x00, 0xF1, 0x07, 0x00, 0x81, 0x16, 0x00, 0xF2, 
 0x62, 0x00, 0x81, 0x4C, 0x00, 0xF3, 0x4C, 0x00, 0x41, 0x20, 
 0x00, 0xF7, 0x68, 0x00, 0x41, 0x02, 0x00, 0xF9, 0x6B, 0x00, 
 0x81, 0x43, 0x00, 0xFD, 0x56, 0x00, 0x81, 0x68, 0x01, 0x09, 
 0xA3, 0x00, 0x81, 0x7C, 0x01, 0x0F, 0x49, 0x00, 0x80, 0xB8, 
 0x01, 0x2F, 0x1D, 0x00, 0x40, 0x9E, 0x01, 0x49, 0x1D, 0x00, 
 0x41, 0x25, 0x01, 0x51, 0x82, 0x00, 0x80, 0xA9, 0x01, 0x53, 
 0x66, 0x00, 0x80, 0x9C, 0x01, 0x54, 0x6B, 0x00, 0x80, 0xC0, 
 0x01, 0x5B, 0x1A, 0x00, 0x41, 0x3B, 0x01, 0x61, 0x9C, 0x00, 
 0x81, 0x12, 0x01, 0x69, 0x22, 0x00, 0x41, 0x14, 0x01, 0x76, 
 0x1A, 0x00, 0x41, 0x27, 0x01, 0x79, 0xAC, 0x00, 0x80, 0xB3, 
 0x01, 0x7F, 0x12, 0x00, 0x81, 0x3B, 0x01, 0x82, 0x53, 0x00, 
 0x81, 0x65, 0x01, 0x86, 0x4C, 0x00, 0x80, 0xE1, 0x01, 0x90, 
 0x11, 0x00, 0x80, 0xE0, 0x01, 0x9E, 0x0B, 0x00, 0x41, 0x65, 
 0x01, 0xA5, 0x51, 0x00, 0x40, 0xC3, 0x01, 0xB0, 0x08, 0x00, 
 0x40, 0xF6, 0x01, 0xBB, 0x04, 0x00, 0x80, 0xEC, 0x01, 0xC7, 
 0x01, 0x00, 0x41, 0x38, 0x01, 0xC8, 0x58, 0x00, 0x00, 0x00, 
 0x02, 0x10, 0x42, 0x32, 0x41, 0x31, 0x00, 0x15, 0xA4, 0x00, 
 0x80, 0xEF, 0x00, 0x1F, 0xAD, 0x00, 0x41, 0x3C, 0x00, 0x39, 
 0x4A, 0x00, 0x41, 0x56, 0x00, 0x39, 0x47, 0x00, 0x81, 0x01, 
 0x00, 0x40, 0xAD, 0x00, 0x81, 0x17, 0x00, 0x4D, 0x51, 0x00, 
 0x41, 0x4B, 0x00, 0x4D, 0x9C, 0x00, 0x41, 0x59, 0x00, 0x64, 
 0x44, 0x00, 0x81, 0x4F, 0x00, 0x70, 0x9E, 0x00, 0x40, 0xBA, 
 0x00, 0x81, 0x06, 0x00, 0x80, 0xAE, 0x00, 0x8A, 0x04, 0x00, 
 0x80, 0xB1, 0x00, 0x97, 0x5A, 0x00, 0x41, 0x6A, 0x00, 0x9A, 
 0x41, 0x00, 0x41, 0x19, 0x00, 0xA1, 0x4C, 0x00, 0x81, 0x41, 
 0x00, 0xA5, 0x9D, 0x00, 0x40, 0xA3, 0x00, 0xAD, 0x02, 0x00, 
 0x40, 0xB5, 0x00, 0xB9, 0x68, 0x00, 0x41, 0x46, 0x00, 0xBA, 
 0x42, 0x00, 0x40, 0xB2, 0x00, 0xC1, 0x0B, 0x00, 0x40, 0xE3, 
 0x00, 0xC7, 0x01, 0x00, 0x40, 0xC9, 0x00, 0xC9, 0x0B, 0x00, 
 0x40, 0xA7, 0x00, 0xD3, 0x06, 0x00, 0x81, 0x03, 0x01, 0x0D, 
 0x9B, 0x00, 0x80, 0xFA, 0x01, 0x1B, 0x3F, 0x00, 0x81, 0x30, 
 0x01, 0x1F, 0x79, 0x00, 0x41, 0x11, 0x01, 0x2B, 0x1D, 0x00, 
 0x81, 0x1D, 0x01, 0x2F, 0x1A, 0x00, 0x41, 0x41, 0x01, 0x31, 
 0x36, 0x00, 0x81, 0x2D, 0x01, 0x35, 0x0F, 0x00, 0x81, 0x3F, 
 0x01, 0x3A, 0x59, 0x00, 0x81, 0x1E, 0x01, 0x3F, 0x09, 0x00, 
 0x81, 0x43, 0x01, 0x46, 0x5A, 0x00, 0x81, 0x32, 0x01, 0x4B, 
 0x00, 0x00, 0x40, 0xFF, 0x01, 0x4F, 0x0F, 0x00, 0x41, 0x61, 
 0x01, 0x52, 0xA1, 0x00, 0x81, 0x4D, 0x01, 0x57, 0xA8, 0x00, 
 0x81, 0x1D, 0x01, 0x59, 0x62, 0x00, 0x41, 0x7E, 0x01, 0x5A, 
 0x44, 0x00, 0x41, 0x66, 0x01, 0x5D, 0x4C, 0x00, 0x41, 0x69, 
 0x01, 0x5E, 0x9B, 0x00, 0x80, 0xCB, 0x01, 0x61, 0x0F, 0x00, 
 0x81, 0x00, 0x01, 0x63, 0x0A, 0x00, 0x81, 0x5F, 0x01, 0x67, 
 0x4D, 0x00, 0x81, 0x2B, 0x01, 0x6E, 0x5F, 0x00, 0x80, 0xC0, 
 0x01, 0x79, 0x0E, 0x00, 0x81, 0x7F, 0x01, 0x7A, 0x45, 0x00, 
 0x81, 0x70, 0x01, 0x81, 0x4D, 0x00, 0x81, 0x35, 0x01, 0x87, 
 0x62, 0x00, 0x81, 0x18, 0x01, 0x98, 0x05, 0x00, 0x81, 0x2A, 
 0x01, 0x9B, 0x5E, 0x00, 0x00, 0x00, 0x30, 0x82, 0x02, 0x68, 
 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x07, 
 0x02, 0xA0, 0x82, 0x02, 0x59, 0x30, 0x82, 0x02, 0x55, 0x02, 
 0x01, 0x03, 0x31, 0x0B, 0x30, 0x09, 0x06, 0x05, 0x2B, 0x0E, 
 0x03, 0x02, 0x1A, 0x05, 0x00, 0x30, 0x0A, 0x06, 0x08, 0x60, 
 0x86, 0x48, 0x01, 0x65, 0x03, 0x06, 0x02, 0x31, 0x82, 0x02, 
 0x35, 0x30, 0x82, 0x02, 0x31, 0x02, 0x01, 0x01, 0x30, 0x38, 
 0x30, 0x32, 0x31, 0x0B, 0x30, 0x09, 0x06, 0x03, 0x55, 0x04, 
 0x06, 0x13, 0x02, 0x55, 0x53, 0x31, 0x0D, 0x30, 0x0B, 0x06, 
 0x03, 0x55, 0x04, 0x0A, 0x13, 0x04, 0x4E, 0x49, 0x53, 0x54, 
 0x31, 0x14, 0x30, 0x12, 0x06, 0x03, 0x55, 0x04, 0x03, 0x13, 
 0x0B, 0x50, 0x49, 0x56, 0x20, 0x54, 0x65, 0x73, 0x74, 0x20, 
 0x43, 0x41, 0x02, 0x02, 0x27, 0x10, 0x30, 0x09, 0x06, 0x05, 
 0x2B, 0x0E, 0x03, 0x02, 0x1A, 0x05, 0x00, 0xA0, 0x81, 0xD3, 
 0x30, 0x17, 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 
 0x01, 0x09, 0x03, 0x31, 0x0A, 0x06, 0x08, 0x60, 0x86, 0x48, 
 0x01, 0x65, 0x03, 0x06, 0x02, 0x30, 0x1C, 0x06, 0x09, 0x2A, 
 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x09, 0x05, 0x31, 0x0F, 
 0x17, 0x0D, 0x30, 0x37, 0x30, 0x35, 0x31, 0x37, 0x32, 0x31, 
 0x30, 0x39, 0x32, 0x32, 0x5A, 0x30, 0x23, 0x06, 0x09, 0x2A, 
 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x09, 0x04, 0x31, 0x16, 
 0x04, 0x14, 0xB0, 0x3D, 0x96, 0x4E, 0xC1, 0x3D, 0xF5, 0x4E, 
 0x0E, 0x9A, 0xEA, 0xF9, 0x23, 0xF3, 0xBA, 0x38, 0xBF, 0x25, 
 0xF3, 0x22, 0x30, 0x27, 0x06, 0x08, 0x60, 0x86, 0x48, 0x01, 
 0x65, 0x03, 0x06, 0x06, 0x31, 0x1B, 0x04, 0x19, 0xD6, 0x50, 
 0x18, 0x58, 0x21, 0x0C, 0x2D, 0x31, 0x71, 0xB5, 0x25, 0xA1, 
 0x68, 0x5A, 0x08, 0xC9, 0x2A, 0xDE, 0x0A, 0x61, 0x86, 0x50, 
 0x18, 0x43, 0xE2, 0x30, 0x4C, 0x06, 0x08, 0x60, 0x86, 0x48, 
 0x01, 0x65, 0x03, 0x06, 0x05, 0x31, 0x40, 0x30, 0x3E, 0x31, 
 0x0D, 0x30, 0x0B, 0x06, 0x03, 0x55, 0x04, 0x0A, 0x13, 0x04, 
 0x4E, 0x49, 0x53, 0x54, 0x31, 0x0B, 0x30, 0x09, 0x06, 0x03, 
 0x55, 0x04, 0x06, 0x13, 0x02, 0x55, 0x53, 0x31, 0x20, 0x30, 
 0x1E, 0x06, 0x03, 0x55, 0x04, 0x03, 0x13, 0x17, 0x50, 0x49, 
 0x56, 0x20, 0x54, 0x65, 0x73, 0x74, 0x20, 0x43, 0x6F, 0x6E, 
 0x74, 0x65, 0x6E, 0x74, 0x20, 0x53, 0x69, 0x67, 0x6E, 0x65, 
 0x72, 0x30, 0x0D, 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 
 0x0D, 0x01, 0x01, 0x01, 0x05, 0x00, 0x04, 0x82, 0x01, 0x00, 
 0x4D, 0x48, 0x4F, 0xFC, 0xFE, 0xAC, 0xAF, 0xE4, 0x0C, 0x5D, 
 0x4E, 0x28, 0xA0, 0x8F, 0xCB, 0xFC, 0xBC, 0xA1, 0x5D, 0x21, 
 0xB0, 0x18, 0xFC, 0x45, 0xD6, 0xED, 0x95, 0x2A, 0xDA, 0xDE, 
 0x5C, 0x3E, 0x77, 0xB7, 0x0B, 0xFB, 0xB5, 0xD8, 0x58, 0xE8, 
 0x2E, 0xF4, 0x23, 0xFB, 0x64, 0x31, 0xA9, 0x22, 0x24, 0xF3, 
 0x41, 0x96, 0x7D, 0x9D, 0x6F, 0x65, 0x93, 0xFE, 0x0E, 0xF6, 
 0x80, 0x83, 0x24, 0xB1, 0xAF, 0x34, 0x95, 0x7D, 0x15, 0x5B, 
 0x72, 0xE1, 0x50, 0xE9, 0x24, 0x8E, 0x44, 0x31, 0x8B, 0x27, 
 0xD7, 0xBE, 0x55, 0xE0, 0x3F, 0x89, 0x51, 0x00, 0x22, 0x84, 
 0x7C, 0xA6, 0x84, 0xE8, 0xBA, 0x3B, 0xCC, 0x45, 0x0B, 0xBA, 
 0x20, 0x1E, 0xF9, 0x85, 0xF2, 0xAF, 0x08, 0x21, 0x3F, 0x39, 
 0xC4, 0x67, 0xD0, 0xC0, 0xC5, 0xD3, 0x42, 0xAD, 0x25, 0x1A, 
 0xA5, 0xDE, 0x56, 0xC2, 0x03, 0xF5, 0x65, 0xA8, 0xCB, 0xC6, 
 0x07, 0x3B, 0x48, 0x77, 0x3F, 0xD9, 0xCD, 0xE7, 0x78, 0x5D, 
 0xB1, 0xD6, 0x60, 0xD0, 0x70, 0x51, 0x8F, 0x47, 0x1B, 0xB5, 
 0x96, 0xCE, 0x8E, 0x7B, 0x38, 0x2B, 0x1A, 0x45, 0x5B, 0xE3, 
 0x37, 0x83, 0xA6, 0xE1, 0x5C, 0x3D, 0x26, 0xC4, 0x37, 0xED, 
 0xCB, 0xBD, 0x9E, 0xED, 0x36, 0x20, 0x33, 0x98, 0x1F, 0xF3, 
 0xDF, 0xB4, 0x9C, 0xBC, 0x21, 0xB3, 0xDD, 0x4A, 0x64, 0x2B, 
 0x9F, 0x10, 0x7C, 0x7B, 0x7A, 0x7A, 0xA9, 0x7F, 0x0B, 0xED, 
 0x27, 0x07, 0x34, 0x73, 0x8E, 0xD1, 0xC0, 0x56, 0x1E, 0x63, 
 0x37, 0x39, 0xC5, 0xAF, 0x65, 0x6A, 0xF3, 0xE8, 0x43, 0x9C, 
 0x84, 0x01, 0x16, 0x36, 0x68, 0xCA, 0x60, 0xCD, 0x7A, 0xC9, 
 0x60, 0xD6, 0xC1, 0x77, 0xE9, 0x9C, 0x77, 0x61, 0x3F, 0xC5, 
 0x0E, 0xDA, 0xD9, 0x82, 0x30, 0xFA, 0x5D, 0x6C, 0xC0, 0xA0, 
 0xCF, 0x0B, 0xC6, 0x42, 0x75, 0x1B, 0xFE, 0x00
 }
;

// BER-TLV Tag 5FC105
static Octet PIV_X509_DATA [ ] = 
{ 0x70, 0x82, 0x05, 0x51, 0x30, 0x82, 0x05, 0x4D, 0x30, 0x82, 
 0x04, 0x35, 0xA0, 0x03, 0x02, 0x01, 0x02, 0x02, 0x01, 0x15, 
 0x30, 0x0D, 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 
 0x01, 0x01, 0x05, 0x05, 0x00, 0x30, 0x32, 0x31, 0x0B, 0x30, 
 0x09, 0x06, 0x03, 0x55, 0x04, 0x06, 0x13, 0x02, 0x55, 0x53, 
 0x31, 0x0D, 0x30, 0x0B, 0x06, 0x03, 0x55, 0x04, 0x0A, 0x13, 
 0x04, 0x4E, 0x49, 0x53, 0x54, 0x31, 0x14, 0x30, 0x12, 0x06, 
 0x03, 0x55, 0x04, 0x03, 0x13, 0x0B, 0x50, 0x49, 0x56, 0x20, 
 0x54, 0x65, 0x73, 0x74, 0x20, 0x43, 0x41, 0x30, 0x1E, 0x17, 
 0x0D, 0x30, 0x37, 0x30, 0x34, 0x31, 0x39, 0x31, 0x35, 0x32, 
 0x32, 0x33, 0x33, 0x5A, 0x17, 0x0D, 0x30, 0x39, 0x30, 0x34, 
 0x31, 0x39, 0x31, 0x35, 0x32, 0x32, 0x33, 0x33, 0x5A, 0x30, 
 0x71, 0x31, 0x0B, 0x30, 0x09, 0x06, 0x03, 0x55, 0x04, 0x06, 
 0x13, 0x02, 0x55, 0x53, 0x31, 0x27, 0x30, 0x25, 0x06, 0x03, 
 0x55, 0x04, 0x0B, 0x13, 0x1E, 0x6F, 0x72, 0x67, 0x61, 0x6E, 
 0x69, 0x7A, 0x61, 0x74, 0x69, 0x6F, 0x6E, 0x61, 0x6C, 0x20, 
 0x55, 0x6E, 0x69, 0x74, 0x20, 0x2D, 0x20, 0x50, 0x49, 0x56, 
 0x20, 0x54, 0x65, 0x73, 0x74, 0x31, 0x18, 0x30, 0x16, 0x06, 
 0x03, 0x55, 0x04, 0x0A, 0x13, 0x0F, 0x55, 0x2E, 0x53, 0x2E, 
 0x20, 0x47, 0x6F, 0x76, 0x65, 0x72, 0x6E, 0x6D, 0x65, 0x6E, 
 0x74, 0x31, 0x1F, 0x30, 0x1D, 0x06, 0x03, 0x55, 0x04, 0x03, 
 0x0C, 0x16, 0x63, 0x6F, 0x6D, 0x6D, 0x6F, 0x6E, 0x5F, 0x6E, 
 0x61, 0x6D, 0x65, 0x20, 0x2D, 0x20, 0x50, 0x49, 0x56, 0x20, 
 0x54, 0x65, 0x73, 0x74, 0x30, 0x81, 0x9F, 0x30, 0x0D, 0x06, 
 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x01, 0x01, 
 0x05, 0x00, 0x03, 0x81, 0x8D, 0x00, 0x30, 0x81, 0x89, 0x02, 
 0x81, 0x81, 0x00, 0xCC, 0xD8, 0x7D, 0xEE, 0x80, 0xF0, 0x7B, 
 0x65, 0x53, 0xB2, 0x16, 0x08, 0xD6, 0xFC, 0xD1, 0xA3, 0x89, 
 0xF7, 0x77, 0x65, 0x18, 0x58, 0x3F, 0xD0, 0x83, 0x6E, 0x07, 
 0x2D, 0xE0, 0xD7, 0x58, 0x3F, 0x5E, 0x11, 0x4D, 0x00, 0x28, 
 0x85, 0x13, 0x50, 0xD1, 0x0E, 0x52, 0xA5, 0x39, 0xD6, 0x51, 
 0xF9, 0x1A, 0x12, 0x1F, 0xBA, 0x17, 0x5E, 0xB1, 0x8F, 0xE2, 
 0xDF, 0xF3, 0x02, 0x67, 0x60, 0x70, 0x76, 0xA1, 0x08, 0x00, 
 0xEF, 0x0A, 0xF4, 0x65, 0xDB, 0xA7, 0xDA, 0xE9, 0xEF, 0xD2, 
 0xC0, 0x4B, 0x9A, 0x80, 0x10, 0xE5, 0x73, 0x5F, 0xFE, 0x5A, 
 0xB0, 0xFA, 0x49, 0xA5, 0xFF, 0x9B, 0x79, 0x3B, 0x83, 0x1E, 
 0x7B, 0xF8, 0x75, 0x8F, 0xE9, 0x5C, 0x8A, 0xD2, 0x71, 0x49, 
 0x18, 0xEC, 0x6E, 0xAB, 0x1C, 0x1D, 0x51, 0x5F, 0x3B, 0x5E, 
 0xDF, 0xF1, 0x6C, 0x2E, 0x68, 0x66, 0xA5, 0x22, 0x75, 0xB8, 
 0x21, 0x02, 0x03, 0x01, 0x00, 0x01, 0xA3, 0x82, 0x02, 0xB1, 
 0x30, 0x82, 0x02, 0xAD, 0x30, 0x1F, 0x06, 0x03, 0x55, 0x1D, 
 0x23, 0x04, 0x18, 0x30, 0x16, 0x80, 0x14, 0xEB, 0xDA, 0x19, 
 0xD2, 0x08, 0x42, 0x8D, 0xF4, 0xDE, 0x25, 0x87, 0x69, 0xC9, 
 0xBB, 0xAB, 0x0C, 0xD3, 0x96, 0x30, 0x01, 0x30, 0x1D, 0x06, 
 0x03, 0x55, 0x1D, 0x0E, 0x04, 0x16, 0x04, 0x14, 0xF8, 0x36, 
 0x17, 0xF6, 0xBA, 0x89, 0x6C, 0x0B, 0xBE, 0xF7, 0x9B, 0xC4, 
 0xF6, 0x10, 0x70, 0x52, 0x64, 0xA1, 0x93, 0xBA, 0x30, 0x0E, 
 0x06, 0x03, 0x55, 0x1D, 0x0F, 0x01, 0x01, 0xFF, 0x04, 0x04, 
 0x03, 0x02, 0x07, 0x80, 0x30, 0x25, 0x06, 0x03, 0x55, 0x1D, 
 0x25, 0x04, 0x1E, 0x30, 0x1C, 0x06, 0x08, 0x2B, 0x06, 0x01, 
 0x05, 0x05, 0x07, 0x03, 0x02, 0x06, 0x0A, 0x2B, 0x06, 0x01, 
 0x04, 0x01, 0x82, 0x37, 0x14, 0x02, 0x02, 0x06, 0x04, 0x55, 
 0x1D, 0x25, 0x00, 0x30, 0x17, 0x06, 0x03, 0x55, 0x1D, 0x20, 
 0x04, 0x10, 0x30, 0x0E, 0x30, 0x0C, 0x06, 0x0A, 0x60, 0x86, 
 0x48, 0x01, 0x65, 0x03, 0x02, 0x01, 0x03, 0x0D, 0x30, 0x81, 
 0x86, 0x06, 0x03, 0x55, 0x1D, 0x1F, 0x04, 0x7F, 0x30, 0x7D, 
 0x30, 0x7B, 0xA0, 0x79, 0xA0, 0x77, 0x86, 0x1B, 0x68, 0x74, 
 0x74, 0x70, 0x3A, 0x2F, 0x2F, 0x6C, 0x6F, 0x63, 0x61, 0x6C, 
 0x68, 0x6F, 0x73, 0x74, 0x2F, 0x63, 0x72, 0x6C, 0x2F, 0x63, 
 0x61, 0x2E, 0x63, 0x72, 0x6C, 0x86, 0x58, 0x6C, 0x64, 0x61, 
 0x70, 0x3A, 0x2F, 0x2F, 0x73, 0x6D, 0x69, 0x6D, 0x65, 0x32, 
 0x2E, 0x6E, 0x69, 0x73, 0x74, 0x2E, 0x67, 0x6F, 0x76, 0x2F, 
 0x63, 0x6E, 0x3D, 0x47, 0x6F, 0x6F, 0x64, 0x25, 0x32, 0x30, 
 0x43, 0x41, 0x2C, 0x6F, 0x3D, 0x54, 0x65, 0x73, 0x74, 0x25, 
 0x32, 0x30, 0x43, 0x65, 0x72, 0x74, 0x69, 0x66, 0x69, 0x63, 
 0x61, 0x74, 0x65, 0x73, 0x2C, 0x63, 0x3D, 0x55, 0x53, 0x3F, 
 0x63, 0x65, 0x72, 0x74, 0x69, 0x66, 0x69, 0x63, 0x61, 0x74, 
 0x65, 0x52, 0x65, 0x76, 0x6F, 0x63, 0x61, 0x74, 0x69, 0x6F, 
 0x6E, 0x4C, 0x69, 0x73, 0x74, 0x30, 0x82, 0x01, 0x21, 0x06, 
 0x08, 0x2B, 0x06, 0x01, 0x05, 0x05, 0x07, 0x01, 0x01, 0x04, 
 0x82, 0x01, 0x13, 0x30, 0x82, 0x01, 0x0F, 0x30, 0x3E, 0x06, 
 0x08, 0x2B, 0x06, 0x01, 0x05, 0x05, 0x07, 0x30, 0x01, 0x86, 
 0x32, 0x68, 0x74, 0x74, 0x70, 0x3A, 0x2F, 0x2F, 0x66, 0x69, 
 0x63, 0x74, 0x69, 0x74, 0x69, 0x6F, 0x75, 0x73, 0x2E, 0x6E, 
 0x69, 0x73, 0x74, 0x2E, 0x67, 0x6F, 0x76, 0x2F, 0x66, 0x69, 
 0x63, 0x74, 0x69, 0x74, 0x69, 0x6F, 0x75, 0x73, 0x4F, 0x43, 
 0x53, 0x50, 0x4C, 0x6F, 0x63, 0x61, 0x74, 0x69, 0x6F, 0x6E, 
 0x2F, 0x30, 0x5E, 0x06, 0x08, 0x2B, 0x06, 0x01, 0x05, 0x05, 
 0x07, 0x30, 0x02, 0x86, 0x52, 0x68, 0x74, 0x74, 0x70, 0x3A, 
 0x2F, 0x2F, 0x66, 0x69, 0x63, 0x74, 0x69, 0x74, 0x69, 0x6F, 
 0x75, 0x73, 0x2E, 0x6E, 0x69, 0x73, 0x74, 0x2E, 0x67, 0x6F, 
 0x76, 0x2F, 0x66, 0x69, 0x63, 0x74, 0x69, 0x74, 0x69, 0x6F, 
 0x75, 0x73, 0x43, 0x65, 0x72, 0x74, 0x73, 0x4F, 0x6E, 0x6C, 
 0x79, 0x43, 0x4D, 0x53, 0x64, 0x69, 0x72, 0x65, 0x63, 0x74, 
 0x6F, 0x72, 0x79, 0x2F, 0x63, 0x65, 0x72, 0x74, 0x73, 0x49, 
 0x73, 0x73, 0x75, 0x65, 0x64, 0x54, 0x6F, 0x47, 0x6F, 0x6F, 
 0x64, 0x43, 0x41, 0x2E, 0x70, 0x37, 0x63, 0x30, 0x6D, 0x06, 
 0x08, 0x2B, 0x06, 0x01, 0x05, 0x05, 0x07, 0x30, 0x02, 0x86, 
 0x61, 0x6C, 0x64, 0x61, 0x70, 0x3A, 0x2F, 0x2F, 0x73, 0x6D, 
 0x69, 0x6D, 0x65, 0x32, 0x2E, 0x6E, 0x69, 0x73, 0x74, 0x2E, 
 0x67, 0x6F, 0x76, 0x2F, 0x63, 0x6E, 0x3D, 0x47, 0x6F, 0x6F, 
 0x64, 0x25, 0x32, 0x30, 0x43, 0x41, 0x2C, 0x6F, 0x3D, 0x54, 
 0x65, 0x73, 0x74, 0x25, 0x32, 0x30, 0x43, 0x65, 0x72, 0x74, 
 0x69, 0x66, 0x69, 0x63, 0x61, 0x74, 0x65, 0x73, 0x2C, 0x63, 
 0x3D, 0x55, 0x53, 0x3F, 0x63, 0x41, 0x43, 0x65, 0x72, 0x74, 
 0x69, 0x66, 0x69, 0x63, 0x61, 0x74, 0x65, 0x2C, 0x63, 0x72, 
 0x6F, 0x73, 0x73, 0x43, 0x65, 0x72, 0x74, 0x69, 0x66, 0x69, 
 0x63, 0x61, 0x74, 0x65, 0x50, 0x61, 0x69, 0x72, 0x30, 0x5B, 
 0x06, 0x03, 0x55, 0x1D, 0x11, 0x04, 0x54, 0x30, 0x52, 0xA0, 
 0x27, 0x06, 0x08, 0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x06, 
 0x06, 0xA0, 0x1B, 0x04, 0x19, 0xD6, 0x50, 0x18, 0x58, 0x21, 
 0x0C, 0x2D, 0x31, 0x71, 0xB5, 0x25, 0xA1, 0x68, 0x5A, 0x08, 
 0xC9, 0x2A, 0xDE, 0x0A, 0x61, 0x86, 0x50, 0x18, 0x43, 0xE2, 
 0xA0, 0x27, 0x06, 0x0A, 0x2B, 0x06, 0x01, 0x04, 0x01, 0x82, 
 0x37, 0x14, 0x02, 0x03, 0xA0, 0x19, 0x0C, 0x17, 0x63, 0x6F, 
 0x6D, 0x6D, 0x6F, 0x6E, 0x5F, 0x6E, 0x61, 0x6D, 0x65, 0x40, 
 0x70, 0x69, 0x76, 0x64, 0x65, 0x6D, 0x6F, 0x2E, 0x6F, 0x72, 
 0x67, 0x30, 0x10, 0x06, 0x09, 0x60, 0x86, 0x48, 0x01, 0x65, 
 0x03, 0x06, 0x09, 0x01, 0x04, 0x03, 0x01, 0x01, 0x00, 0x30, 
 0x0D, 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 
 0x01, 0x05, 0x05, 0x00, 0x03, 0x82, 0x01, 0x01, 0x00, 0x4B, 
 0xA6, 0x08, 0xAE, 0x73, 0x7F, 0x60, 0x2C, 0xEC, 0x57, 0x25, 
 0xA7, 0xC9, 0xF4, 0x2E, 0xE2, 0x57, 0x3D, 0x78, 0x96, 0x84, 
 0xBD, 0x58, 0x8A, 0xE4, 0xD3, 0x0C, 0x04, 0x9A, 0x73, 0xD4, 
 0x66, 0x03, 0xA9, 0xD9, 0x5A, 0xD3, 0x4E, 0x80, 0x12, 0x47, 
 0x47, 0x4D, 0xEA, 0x7E, 0x6A, 0x20, 0x3D, 0x4E, 0x3A, 0xA7, 
 0x67, 0x9C, 0xFD, 0x65, 0x78, 0xD0, 0x87, 0xA0, 0x89, 0x8A, 
 0x27, 0x5A, 0x48, 0x9E, 0x46, 0x55, 0x5F, 0x5A, 0xD7, 0xD5, 
 0x14, 0x15, 0x02, 0x34, 0x67, 0x21, 0x0C, 0xC4, 0x09, 0x1E, 
 0x82, 0x10, 0x9D, 0x64, 0x70, 0x01, 0x94, 0x26, 0x53, 0xF4, 
 0x79, 0xCB, 0x5B, 0x0D, 0xD6, 0xD2, 0x86, 0x2A, 0xCD, 0xFE, 
 0x86, 0xF7, 0xEE, 0x81, 0x33, 0x9B, 0xD8, 0x74, 0xA3, 0xD4, 
 0x70, 0xE2, 0xDC, 0xD1, 0x9C, 0x0E, 0x69, 0x8A, 0x93, 0x30, 
 0xCF, 0xFB, 0xE9, 0x2F, 0x22, 0x0D, 0x36, 0xFF, 0x81, 0x84, 
 0x51, 0xF2, 0xD3, 0x79, 0xE6, 0x13, 0xDD, 0x6A, 0xC1, 0xD9, 
 0x34, 0x5E, 0x42, 0x20, 0x04, 0xC7, 0xCE, 0xD9, 0x28, 0x89, 
 0x30, 0x43, 0xF7, 0x71, 0x28, 0x6E, 0xF8, 0x12, 0x9E, 0x37, 
 0x44, 0x73, 0x90, 0xCB, 0x3B, 0x3C, 0xDE, 0x96, 0xBC, 0x56, 
 0xD4, 0xBB, 0x5C, 0x12, 0xAF, 0x85, 0xE4, 0x63, 0x86, 0x92, 
 0xB5, 0xC4, 0x43, 0x7D, 0xC3, 0xC7, 0x8B, 0xEE, 0xBF, 0x94, 
 0xAA, 0xC4, 0x7F, 0x4A, 0x8A, 0x6C, 0x9A, 0x14, 0x0C, 0x83, 
 0xA4, 0x7F, 0xD5, 0x3E, 0xFA, 0x1B, 0x06, 0xA6, 0x6B, 0xAF, 
 0x12, 0xCD, 0x28, 0x68, 0x71, 0xE2, 0x26, 0x7A, 0xD5, 0x71, 
 0xF1, 0xB8, 0x49, 0x21, 0x31, 0xA5, 0x39, 0x58, 0xB7, 0xD3, 
 0x76, 0xA9, 0x24, 0x49, 0x96, 0x86, 0xD9, 0x9A, 0x74, 0xF8, 
 0x2D, 0x4D, 0x7E, 0x85, 0x5C, 0x9E, 0x3D, 0x68, 0x41, 0xA1, 
 0xB9, 0x54, 0xC3, 0x1D, 0x3F, 0x71, 0x01, 0x00, 0xFE, 0x00
}
;

// BER-TLV Tag 5FC106
static Octet SECURITY_OBJECT_DATA [ ] = 
{ 0xBA, 0x1B, 0x01, 0xDB, 0x00, 0x02, 0x30, 0x00, 0x03, 0x01, 
 0x01, 0x04, 0x60, 0x10, 0x06, 0x30, 0x01, 0x07, 0x60, 0x30, 
 0x08, 0x01, 0x00, 0x09, 0x01, 0x02, 0x0A, 0x05, 0x00, 0xBB, 
 0x82, 0x03, 0x00, 0x30, 0x82, 0x02, 0xFC, 0x06, 0x09, 0x2A, 
 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x07, 0x02, 0xA0, 0x82, 
 0x02, 0xED, 0x30, 0x82, 0x02, 0xE9, 0x02, 0x01, 0x03, 0x31, 
 0x0B, 0x30, 0x09, 0x06, 0x05, 0x2B, 0x0E, 0x03, 0x02, 0x1A, 
 0x05, 0x00, 0x30, 0x82, 0x01, 0x17, 0x06, 0x05, 0x2B, 0x1B, 
 0x01, 0x01, 0x01, 0xA0, 0x82, 0x01, 0x0C, 0x04, 0x82, 0x01, 
 0x08, 0x30, 0x82, 0x01, 0x04, 0x02, 0x01, 0x00, 0x30, 0x09, 
 0x06, 0x05, 0x2B, 0x0E, 0x03, 0x02, 0x1A, 0x05, 0x00, 0x30, 
 0x81, 0xF3, 0x30, 0x19, 0x02, 0x01, 0x01, 0x04, 0x14, 0x36, 
 0x0F, 0xB1, 0x68, 0x82, 0x58, 0xE5, 0x32, 0x0C, 0x83, 0x21, 
 0x8B, 0xED, 0xD4, 0xF5, 0xA1, 0xE4, 0xF5, 0xE8, 0x96, 0x30, 
 0x19, 0x02, 0x01, 0x02, 0x04, 0x14, 0xF6, 0x33, 0x11, 0xF7, 
 0xB1, 0x40, 0xB1, 0x27, 0x86, 0xE1, 0xDF, 0x90, 0x76, 0xBB, 
 0x73, 0xD6, 0xB4, 0x22, 0xED, 0x2C, 0x30, 0x19, 0x02, 0x01, 
 0x03, 0x04, 0x14, 0x35, 0xB9, 0x2E, 0xA7, 0x4F, 0x6E, 0xA2, 
 0xA6, 0x72, 0x0A, 0xAE, 0x7A, 0x12, 0x34, 0xA6, 0xAC, 0x41, 
 0xDB, 0x75, 0xC3, 0x30, 0x19, 0x02, 0x01, 0x04, 0x04, 0x14, 
 0x62, 0x86, 0xF5, 0x03, 0x37, 0x12, 0x50, 0xA5, 0xA9, 0x20, 
 0xB6, 0x79, 0x1B, 0xFF, 0x3C, 0xDA, 0x76, 0xAB, 0xF1, 0x1C, 
 0x30, 0x19, 0x02, 0x01, 0x06, 0x04, 0x14, 0xCA, 0x7B, 0xA5, 
 0x89, 0x5D, 0x8D, 0x0D, 0x09, 0xD6, 0xE5, 0x89, 0x06, 0x0E, 
 0x92, 0x48, 0x58, 0x03, 0x23, 0xEC, 0x86, 0x30, 0x19, 0x02, 
 0x01, 0x07, 0x04, 0x14, 0xD0, 0xCA, 0x3E, 0x80, 0x8C, 0xDF, 
 0x49, 0x2C, 0xDD, 0x46, 0x6A, 0xF5, 0xB4, 0x2F, 0x7F, 0x68, 
 0x1E, 0x60, 0xA8, 0xC3, 0x30, 0x19, 0x02, 0x01, 0x08, 0x04, 
 0x14, 0x12, 0x77, 0xD5, 0x5F, 0x84, 0xDE, 0xCF, 0xE3, 0x0C, 
 0xE2, 0xDC, 0xFC, 0x8D, 0x8D, 0x83, 0xB6, 0xBF, 0xCB, 0x0C, 
 0x64, 0x30, 0x19, 0x02, 0x01, 0x09, 0x04, 0x14, 0x17, 0x67, 
 0x43, 0xE6, 0x2A, 0x36, 0xE4, 0x39, 0xA1, 0x2C, 0xBE, 0x4E, 
 0xAA, 0x6E, 0x2C, 0x69, 0xB6, 0x72, 0x04, 0x77, 0x30, 0x19, 
 0x02, 0x01, 0x0A, 0x04, 0x14, 0x3D, 0x0C, 0xCE, 0x43, 0xD0, 
 0x1F, 0xF5, 0x44, 0x17, 0xC0, 0x57, 0xCA, 0x53, 0xD2, 0x98, 
 0x40, 0xAA, 0x22, 0x41, 0xCB, 0x31, 0x82, 0x01, 0xBA, 0x30, 
 0x82, 0x01, 0xB6, 0x02, 0x01, 0x01, 0x30, 0x38, 0x30, 0x32, 
 0x31, 0x0B, 0x30, 0x09, 0x06, 0x03, 0x55, 0x04, 0x06, 0x13, 
 0x02, 0x55, 0x53, 0x31, 0x0D, 0x30, 0x0B, 0x06, 0x03, 0x55, 
 0x04, 0x0A, 0x13, 0x04, 0x4E, 0x49, 0x53, 0x54, 0x31, 0x14, 
 0x30, 0x12, 0x06, 0x03, 0x55, 0x04, 0x03, 0x13, 0x0B, 0x50, 
 0x49, 0x56, 0x20, 0x54, 0x65, 0x73, 0x74, 0x20, 0x43, 0x41, 
 0x02, 0x02, 0x27, 0x10, 0x30, 0x09, 0x06, 0x05, 0x2B, 0x0E, 
 0x03, 0x02, 0x1A, 0x05, 0x00, 0xA0, 0x59, 0x30, 0x14, 0x06, 
 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x09, 0x03, 
 0x31, 0x07, 0x06, 0x05, 0x2B, 0x1B, 0x01, 0x01, 0x01, 0x30, 
 0x1C, 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 
 0x09, 0x05, 0x31, 0x0F, 0x17, 0x0D, 0x30, 0x37, 0x30, 0x35, 
 0x31, 0x37, 0x32, 0x31, 0x34, 0x30, 0x33, 0x39, 0x5A, 0x30, 
 0x23, 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 
 0x09, 0x04, 0x31, 0x16, 0x04, 0x14, 0x99, 0xB6, 0xF5, 0x0B, 
 0x4E, 0x3A, 0x1D, 0xB9, 0xF9, 0x4E, 0xC3, 0x9F, 0x05, 0x07, 
 0x44, 0xB8, 0x18, 0x31, 0x8C, 0x8C, 0x30, 0x0D, 0x06, 0x09, 
 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x01, 0x01, 0x05, 
 0x00, 0x04, 0x82, 0x01, 0x00, 0x14, 0x6D, 0x66, 0x18, 0xD9, 
 0xD4, 0x23, 0xF7, 0x78, 0x28, 0xFF, 0xDB, 0x1F, 0x30, 0x80, 
 0x53, 0xC3, 0xAB, 0xB2, 0xDC, 0x4E, 0xB9, 0x41, 0x1F, 0x9D, 
 0x3A, 0xC6, 0x16, 0xBF, 0x68, 0xA7, 0x4D, 0xF0, 0x1C, 0x48, 
 0xC5, 0x91, 0xF4, 0x97, 0xDC, 0x84, 0xE5, 0x43, 0xC7, 0x51, 
 0x9B, 0x65, 0x9D, 0x86, 0xB5, 0xF8, 0x2A, 0x60, 0x99, 0x3C, 
 0x84, 0x68, 0x2F, 0xCA, 0x14, 0xCA, 0x42, 0xAA, 0x29, 0xC1, 
 0x05, 0xD8, 0xD9, 0x47, 0x2F, 0x7C, 0x5F, 0x2E, 0x55, 0x12, 
 0x6B, 0x42, 0xDA, 0x5A, 0x93, 0x36, 0x5C, 0xBE, 0x4D, 0x48, 
 0x51, 0x4F, 0x15, 0xD9, 0x9D, 0x9B, 0x06, 0xF2, 0x33, 0x53, 
 0x33, 0x89, 0x61, 0xD8, 0xFF, 0xB3, 0x5A, 0x76, 0xC4, 0x36, 
 0x96, 0x1E, 0x4A, 0x81, 0xC5, 0x9D, 0x8C, 0xF8, 0xA7, 0x9E, 
 0x4A, 0x5F, 0xA4, 0xD4, 0x2F, 0x69, 0x90, 0xAD, 0x28, 0x0B, 
 0xB7, 0xE1, 0x0F, 0x3F, 0xFD, 0x00, 0x1B, 0xCC, 0xCA, 0xB8, 
 0x2E, 0x20, 0xC3, 0x31, 0x6F, 0x64, 0xCB, 0xE5, 0x01, 0xCF, 
 0x2A, 0xE8, 0xED, 0xBA, 0xE6, 0x86, 0xE7, 0xA3, 0x98, 0x99, 
 0xEC, 0xF1, 0xA3, 0xD3, 0x65, 0x5A, 0x36, 0x81, 0x63, 0xCE, 
 0x3C, 0x35, 0xC1, 0xEE, 0xEC, 0xC1, 0x08, 0x30, 0xED, 0xA2, 
 0x95, 0x07, 0xDF, 0x92, 0x93, 0x37, 0x33, 0x41, 0x82, 0xD5, 
 0x8D, 0xC2, 0xB6, 0xB6, 0x36, 0x33, 0x6B, 0x85, 0xB2, 0x71, 
 0x26, 0xAE, 0x1A, 0x16, 0xA0, 0x67, 0x9D, 0x57, 0xAB, 0x61, 
 0x61, 0xA6, 0xB3, 0x49, 0x91, 0xB7, 0x36, 0x1D, 0xA6, 0xC1, 
 0xBC, 0x24, 0x20, 0xAD, 0x25, 0xD8, 0x0B, 0x55, 0x0A, 0x06, 
 0x3C, 0x06, 0x29, 0xF5, 0x20, 0x77, 0xC2, 0x0E, 0x96, 0xDB, 
 0xE5, 0xC4, 0x0F, 0x2F, 0x3A, 0x1D, 0xD2, 0x46, 0x6E, 0xD6, 
 0x4B, 0xEF, 0x37, 0xD3, 0xCD, 0x79, 0x78, 0xF1, 0x05, 0x45, 
 0x6F, 0xFE, 0x00, 
 }
;
 
// BER-TLV Tag 5FC107
static Octet CCC_DATA [ ] =
{ 0xF0, 0x15, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 
 0x39, 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 
 0x39, 0x30, 0x31, 0xF1, 0x01, 0x21, 0xF2, 0x01, 0x21, 0xF3, 
 0x00, 0xF4, 0x01, 0x11, 0xF5, 0x01, 0x10, 0xF6, 0x11, 0x00, 
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF7, 0x00, 0xFA, 0x00, 
 0xFB, 0x00, 0xFC, 0x00, 0xFD, 0x00, 0xFE, 0x00
}
;

/*
    {
      CCC_CARD_IDENTIFIER, 16,                                                    // 18
          NIST_RID,                                                               //   5
          MFID_NIST,                                                              //   1
          CARD_TYPE_GENERIC_MULTI_APPLICATION,                                    //   1
          CARD_ID_PIV_REF_IMP,                                                    //   9
      CCC_CONTAINER_VERSION, 1,                                                   //  3
          2 << 4 | 1,   // 2.1                                                    //   1
      CCC_GRAMMAR_VERSION, 1,                                                     //  3
          2 << 4 | 1,   // 2.1                                                    //   1
      CCC_PKCS_15, 1,                                                             //  3
          NON_PKCS_15,                                                            //   1
      CCC_DATA_MODEL, 1,                                                          //  3
          1             //                                                        //   1
    } ;
*/

// BER-TLV Tag 5FC108
static Octet FACIAL_IMAGE_DATA [ ] = 
{ 0xBC, 0x82, 0x2F, 0xC4, 0x03, 0x0D, 0x00, 0x00, 0x2D, 0x00, 
 0x02, 0x6C, 0x00, 0x1B, 0x05, 0x01, 0x14, 0x07, 0x04, 0x13, 
 0x0B, 0x16, 0x21, 0x5A, 0x14, 0x07, 0x04, 0x13, 0x0B, 0x16, 
 0x21, 0x5A, 0x14, 0x0B, 0x04, 0x13, 0x0B, 0x16, 0x21, 0x5A, 
 0x00, 0x00, 0x02, 0x20, 0xFE, 0x4E, 0x49, 0x53, 0x54, 0x20, 
 0x43, 0x72, 0x65, 0x61, 0x74, 0x6F, 0x72, 0x00, 0x00, 0x00, 
 0x00, 0x00, 0x00, 0xD6, 0x50, 0x18, 0x58, 0x21, 0x0C, 0x2D, 
 0x31, 0x71, 0xB5, 0x25, 0xA1, 0x68, 0x5A, 0x08, 0xC9, 0x2A, 
 0xDE, 0x0A, 0x61, 0x86, 0x50, 0x18, 0x43, 0xE2, 0x00, 0x00, 
 0x00, 0x00, 0x46, 0x41, 0x43, 0x00, 0x30, 0x31, 0x30, 0x00, 
 0x00, 0x00, 0x2D, 0x00, 0x00, 0x01, 0x00, 0x00, 0x2C, 0xF2, 
 0x00, 0x00, 0x01, 0x02, 0x04, 0x00, 0x00, 0x01, 0x00, 0x01, 
 0x00, 0x00, 0x00, 0x05, 0x05, 0x05, 0x01, 0x00, 0x02, 0x04, 
 0x02, 0x88, 0x01, 0x02, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xD8, 
 0xFF, 0xE0, 0x00, 0x10, 0x4A, 0x46, 0x49, 0x46, 0x00, 0x01, 
 0x01, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0xFF, 0xDB, 
 0x00, 0x43, 0x00, 0x12, 0x0C, 0x0D, 0x10, 0x0D, 0x0B, 0x12, 
 0x10, 0x0E, 0x10, 0x14, 0x13, 0x12, 0x15, 0x1B, 0x2C, 0x1D, 
 0x1B, 0x18, 0x18, 0x1B, 0x36, 0x27, 0x29, 0x20, 0x2C, 0x40, 
 0x39, 0x44, 0x43, 0x3F, 0x39, 0x3E, 0x3D, 0x47, 0x50, 0x66, 
 0x57, 0x47, 0x4B, 0x61, 0x4D, 0x3D, 0x3E, 0x59, 0x79, 0x5A, 
 0x61, 0x69, 0x6D, 0x72, 0x73, 0x72, 0x45, 0x55, 0x7D, 0x86, 
 0x7C, 0x6F, 0x85, 0x66, 0x70, 0x72, 0x6E, 0xFF, 0xDB, 0x00, 
 0x43, 0x01, 0x13, 0x14, 0x14, 0x1B, 0x17, 0x1B, 0x34, 0x1D, 
 0x1D, 0x34, 0x6E, 0x49, 0x3E, 0x49, 0x6E, 0x6E, 0x6E, 0x6E, 
 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 
 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 
 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 
 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 
 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0x6E, 0xFF, 0xC0, 0x00, 0x11, 
 0x08, 0x02, 0x1D, 0x01, 0xA5, 0x03, 0x01, 0x22, 0x00, 0x02, 
 0x11, 0x01, 0x03, 0x11, 0x01, 0xFF, 0xC4, 0x00, 0x1B, 0x00, 
 0x00, 0x02, 0x03, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x02, 0x03, 
 0x04, 0x05, 0x06, 0x07, 0xFF, 0xC4, 0x00, 0x34, 0x10, 0x00, 
 0x02, 0x02, 0x01, 0x03, 0x03, 0x04, 0x01, 0x02, 0x05, 0x04, 
 0x02, 0x03, 0x01, 0x00, 0x00, 0x00, 0x01, 0x02, 0x11, 0x03, 
 0x04, 0x21, 0x31, 0x12, 0x41, 0x51, 0x05, 0x13, 0x22, 0x61, 
 0x71, 0x32, 0x81, 0x14, 0x23, 0x42, 0x91, 0xA1, 0x06, 0x33, 
 0x52, 0xB1, 0x24, 0x62, 0x15, 0xC1, 0xF1, 0xD1, 0xFF, 0xC4, 
 0x00, 0x18, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
 0x01, 0x02, 0x03, 0x04, 0xFF, 0xC4, 0x00, 0x1F, 0x11, 0x01, 
 0x01, 0x01, 0x01, 0x00, 0x03, 0x01, 0x01, 0x01, 0x01, 0x01, 
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x11, 0x02, 0x12, 
 0x21, 0x31, 0x03, 0x41, 0x51, 0x32, 0x22, 0xFF, 0xDA, 0x00, 
 0x0C, 0x03, 0x01, 0x00, 0x02, 0x11, 0x03, 0x11, 0x00, 0x3F, 
 0x00, 0xC2, 0x03, 0x02, 0x3A, 0x00, 0x00, 0x00, 0x18, 0x86, 
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 
 0x01, 0x00, 0xC0, 0x04, 0x03, 0x00, 0x10, 0xC0, 0x00, 0x01, 
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 
 0x00, 0x00, 0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x10, 0x0C, 
 0x40, 0x00, 0x00, 0x00, 0xC0, 0x00, 0x00, 0x43, 0x00, 0x01, 
 0x0C, 0x00, 0x40, 0x31, 0x00, 0x00, 0x00, 0x00, 0x86, 0x00, 
 0x20, 0x00, 0x00, 0xB7, 0xE5, 0x80, 0x00, 0x0C, 0x06, 0x20, 
 0x18, 0x86, 0x00, 0x00, 0x00, 0x03, 0xA0, 0x00, 0x01, 0x00, 
 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x20, 
 0x00, 0x00, 0x00, 0x18, 0x08, 0x60, 0x00, 0x02, 0x18, 0x80, 
 0x62, 0x00, 0x01, 0x80, 0x00, 0x08, 0x62, 0xB1, 0x80, 0x00, 
 0x00, 0x00, 0x98, 0xC0, 0x04, 0x00, 0x00, 0x00, 0x01, 0x40, 
 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0A, 
 0x00, 0x00, 0x00, 0x10, 0x0E, 0x80, 0x04, 0x21, 0x80, 0x08, 
 0x06, 0x01, 0x0C, 0x04, 0x30, 0xA0, 0x00, 0x00, 0x06, 0x20, 
 0x01, 0x80, 0x0C, 0x04, 0x03, 0x10, 0x00, 0xC4, 0x30, 0x10, 
 0xC0, 0x11, 0x40, 0x00, 0x14, 0x40, 0x00, 0x00, 0x00, 0x86, 
 0x16, 0x00, 0x04, 0x5C, 0xBE, 0x8A, 0x9E, 0x7A, 0x5B, 0xAA, 
 0x02, 0xFB, 0x03, 0x16, 0x4D, 0x6A, 0x88, 0xBF, 0x8E, 0xB5, 
 0xB2, 0x1A, 0x37, 0x11, 0x73, 0x8C, 0x7F, 0x53, 0x48, 0xE7, 
 0xE4, 0xD5, 0xCA, 0xB9, 0x4B, 0xF0, 0x64, 0xC9, 0x9D, 0xB7, 
 0xCB, 0x1A, 0x3B, 0x5E, 0xEC, 0x3B, 0x49, 0x07, 0xB9, 0x17, 
 0xFD, 0x47, 0x09, 0x66, 0x7E, 0x49, 0x7B, 0xF2, 0xBE, 0x59, 
 0x34, 0x77, 0x3A, 0x97, 0xFC, 0x90, 0x75, 0x2B, 0x38, 0xDE, 
 0xEB, 0x7C, 0x3A, 0xFC, 0x12, 0x5A, 0xAC, 0x98, 0xE5, 0xFA, 
 0x94, 0x8B, 0xA3, 0xB2, 0x06, 0x1C, 0x1E, 0xA1, 0x19, 0x6D, 
 0x24, 0x6A, 0x8E, 0x68, 0x4B, 0xB8, 0x16, 0x01, 0x57, 0xF1, 
 0x18, 0xFA, 0xA9, 0x49, 0x59, 0x62, 0x92, 0x60, 0x30, 0x00, 
 0x01, 0x00, 0xC0, 0x04, 0x30, 0x00, 0x10, 0x0C, 0x40, 0x00, 
 0x00, 0x00, 0x00, 0x00, 0x02, 0x18, 0x50, 0x08, 0x06, 0x20, 
 0x01, 0x12, 0x10, 0x08, 0x00, 0x0A, 0x87, 0x40, 0x00, 0x45, 
 0x00, 0x00, 0x03, 0x40, 0x00, 0x00, 0x30, 0x00, 0x00, 0x00, 
 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x88, 0x08, 0xB6, 0xD0, 
 0x12, 0x02, 0x3D, 0x45, 0x1A, 0x9D, 0x52, 0xC3, 0x1D, 0x9E, 
 0xE0, 0x69, 0x65, 0x53, 0x72, 0x7C, 0x34, 0xBE, 0xCE, 0x62, 
 0xD6, 0xE4, 0x72, 0xB7, 0x3D, 0x85, 0x93, 0x57, 0x36, 0xB6, 
 0x96, 0xE4, 0x1A, 0x72, 0xEA, 0xA5, 0x85, 0xD6, 0xCD, 0x18, 
 0xF2, 0xEA, 0xE5, 0x2D, 0xB8, 0x2A, 0x9E, 0x47, 0x3D, 0xE5, 
 0xC9, 0x07, 0xCE, 0xC0, 0x4E, 0x59, 0x25, 0x2E, 0xE2, 0x59, 
 0x5A, 0x7C, 0x91, 0xA6, 0xF8, 0x5B, 0x93, 0x8E, 0x07, 0x2E, 
 0x76, 0xFC, 0x90, 0xCA, 0x8B, 0x6E, 0x61, 0xD0, 0xD2, 0xDC, 
 0xB3, 0xF8, 0x7A, 0x76, 0xA7, 0x17, 0xFB, 0x8A, 0x58, 0xA4, 
 0xDF, 0x23, 0x57, 0x15, 0xDD, 0x0F, 0xF5, 0x73, 0x44, 0x9E, 
 0x2D, 0x95, 0xBA, 0x21, 0x49, 0x3F, 0x21, 0x03, 0xBB, 0x13, 
 0x60, 0xE4, 0x24, 0xEC, 0xA8, 0x95, 0xD5, 0x3E, 0xE4, 0xE3, 
 0x9A, 0x51, 0x7F, 0xA8, 0x8B, 0xA2, 0x2D, 0x3F, 0x1B, 0x05, 
 0x68, 0xFE, 0x2A, 0x52, 0x54, 0xEB, 0xFB, 0x17, 0x69, 0xF5, 
 0x33, 0x4D, 0x2E, 0xAD, 0x8E, 0x7D, 0x93, 0x52, 0x71, 0xDF, 
 0x80, 0x8F, 0x43, 0x0C, 0x89, 0xAE, 0x49, 0x9C, 0x25, 0xAB, 
 0xCA, 0x9A, 0x7D, 0x6C, 0xE9, 0x68, 0x75, 0x4F, 0x34, 0x5A, 
 0x97, 0x28, 0xAA, 0xD6, 0x01, 0x43, 0x01, 0x00, 0x00, 0x00, 
 0x00, 0x00, 0x86, 0x00, 0x00, 0x21, 0x88, 0x00, 0x00, 0x00, 
 0x00, 0x00, 0x00, 0x43, 0x10, 0x00, 0x00, 0x00, 0x0C, 0x00, 
 0x00, 0x00, 0x0A, 0x00, 0x00, 0x01, 0x80, 0x00, 0x00, 0x00, 
 0x32, 0x00, 0x06, 0x05, 0x00, 0x00, 0x88, 0x07, 0xB9, 0x19, 
 0x52, 0x5B, 0x86, 0x4C, 0x8A, 0x0B, 0x73, 0x06, 0xA7, 0x53, 
 0xCE, 0xFF, 0x00, 0xB0, 0x16, 0x65, 0xCF, 0x08, 0x3F, 0x8B, 
 0xBF, 0xA3, 0x0E, 0x6C, 0xEE, 0x6D, 0xB6, 0x55, 0x2C, 0xBD, 
 0x77, 0x65, 0x73, 0x95, 0xEC, 0x41, 0x17, 0x2B, 0x63, 0x4E, 
 0xD5, 0x10, 0x1C, 0x13, 0x72, 0x41, 0x16, 0x63, 0x83, 0x94, 
 0xB8, 0x6C, 0xD5, 0x1C, 0x31, 0x8A, 0x5D, 0x7B, 0x3F, 0x08, 
 0x30, 0xE3, 0xE9, 0x56, 0xB9, 0xF2, 0x2C, 0x93, 0xDD, 0xDB, 
 0x32, 0xDC, 0x98, 0xB3, 0xDC, 0x8C, 0x36, 0x8C, 0x52, 0xFB, 
 0x64, 0x1E, 0x79, 0x49, 0xD2, 0x4B, 0xF2, 0x52, 0xE4, 0xE4, 
 0xEA, 0xE9, 0x09, 0xE4, 0xE9, 0xFD, 0x3F, 0xE1, 0x03, 0x5A, 
 0x23, 0x28, 0xAE, 0x6D, 0xB2, 0x39, 0x32, 0x78, 0x5F, 0xD8, 
 0xAD, 0x4A, 0x5D, 0xD6, 0xEC, 0x84, 0xB2, 0x35, 0xE0, 0x1A, 
 0x97, 0xC6, 0x4F, 0xE4, 0xDA, 0xFC, 0x15, 0xC9, 0x2B, 0xA4, 
 0xC4, 0xA5, 0xBD, 0xD5, 0xB2, 0x2D, 0xEF, 0xB7, 0x25, 0xC6, 
 0x75, 0x37, 0x8A, 0x95, 0xD9, 0x5B, 0x8B, 0x5C, 0x34, 0x4A, 
 0x39, 0x1A, 0x64, 0xA7, 0x35, 0x92, 0x3B, 0xA4, 0x9A, 0x28, 
 0x87, 0xE4, 0x92, 0x8E, 0xC4, 0x53, 0xAD, 0x87, 0xFB, 0x90, 
 0x49, 0xC3, 0xBB, 0x4C, 0x8B, 0x5B, 0xEE, 0x17, 0x25, 0xDD, 
 0x8B, 0xA9, 0xDF, 0xC8, 0xA1, 0xA7, 0xE4, 0xD1, 0xA5, 0xCF, 
 0xEC, 0xCE, 0xD7, 0x06, 0x6D, 0xAF, 0x61, 0xC4, 0x0E, 0xF6, 
 0x0D, 0x5E, 0x2C, 0xDB, 0x29, 0x53, 0xF0, 0xCD, 0x07, 0x9B, 
 0x8C, 0x9C, 0x66, 0x9A, 0x7C, 0x1D, 0xAD, 0x16, 0xA7, 0xDF, 
 0x82, 0x52, 0xFD, 0x48, 0xA3, 0x50, 0x86, 0x00, 0x20, 0x18, 
 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x03, 
 0x00, 0x10, 0x86, 0x00, 0x20, 0x00, 0x28, 0x60, 0x00, 0x40, 
 0x00, 0x00, 0x00, 0x00, 0x14, 0x30, 0x00, 0x01, 0x88, 0x00, 
 0x00, 0x60, 0x24, 0x40, 0xC8, 0x64, 0x9A, 0x82, 0xB6, 0xC7, 
 0x39, 0x74, 0xC5, 0xB3, 0x06, 0x7C, 0xEE, 0x4D, 0xF8, 0x44, 
 0xB5, 0x64, 0x3D, 0x46, 0x6B, 0x4E, 0xBB, 0xF0, 0x73, 0x33, 
 0x4A, 0xDB, 0xDC, 0xD3, 0x9B, 0x23, 0xE9, 0x51, 0x5C, 0xBE, 
 0xFE, 0x11, 0x96, 0x49, 0x5D, 0x78, 0x21, 0x51, 0x42, 0xDD, 
 0xEE, 0x59, 0x8E, 0x36, 0xC9, 0x3C, 0x74, 0xC6, 0xA6, 0x2B, 
 0x50, 0xBA, 0x48, 0xB3, 0x14, 0x6A, 0x55, 0x5F, 0x90, 0x7B, 
 0x4B, 0x6E, 0xE5, 0x89, 0x74, 0xC6, 0xEC, 0x6A, 0xC8, 0x9C, 
 0xF2, 0x54, 0x7A, 0x62, 0x67, 0x93, 0xB2, 0x52, 0x9B, 0x7B, 
 0x45, 0x24, 0x1D, 0x14, 0x93, 0x9F, 0xEC, 0x80, 0x84, 0x21, 
 0x29, 0xDF, 0x4F, 0xEE, 0xC9, 0xA8, 0xA8, 0xA1, 0x46, 0x74, 
 0xAA, 0xF9, 0xF0, 0x13, 0xDF, 0x64, 0x04, 0x65, 0x26, 0xF8, 
 0xD8, 0xAD, 0x96, 0x35, 0x51, 0xFB, 0x21, 0xD2, 0x12, 0x94, 
 0x79, 0x63, 0xE3, 0xB0, 0x76, 0xA1, 0xBD, 0xF7, 0x65, 0x09, 
 0xC7, 0xED, 0x02, 0x89, 0x62, 0x5D, 0x5C, 0x44, 0xBE, 0x38, 
 0x3A, 0x96, 0xC8, 0x9A, 0xD4, 0x8C, 0xBD, 0x37, 0xF4, 0x1E, 
 0xDB, 0x8F, 0x28, 0xD7, 0x2D, 0x3B, 0x51, 0x7C, 0x91, 0x58, 
 0xB6, 0x69, 0xF0, 0x4D, 0x5C, 0x51, 0x69, 0x0A, 0x49, 0x53, 
 0x2C, 0xF6, 0x43, 0xD9, 0x6D, 0x70, 0x35, 0x3C, 0x6B, 0x3D, 
 0x13, 0x82, 0xA6, 0x8B, 0x3D, 0xA6, 0x2A, 0xE9, 0x69, 0x17, 
 0x53, 0x31, 0x1C, 0x91, 0xA9, 0x17, 0x69, 0x73, 0x3C, 0x53, 
 0x4D, 0x15, 0x4D, 0xDC, 0xEB, 0xE8, 0x8A, 0x7B, 0xA0, 0x8F, 
 0x45, 0x8B, 0x22, 0xC9, 0x14, 0xD1, 0x33, 0x8D, 0xA6, 0xD4, 
 0xCB, 0x13, 0xBE, 0xDD, 0xCE, 0xB6, 0x2C, 0x91, 0xC9, 0x05, 
 0x28, 0xBE, 0x4B, 0x28, 0x98, 0x86, 0x05, 0x00, 0x86, 0x00, 
 0x20, 0x18, 0x00, 0x08, 0x62, 0x00, 0x00, 0x00, 0x10, 0x00, 
 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x40, 0x03, 0x00, 0x00, 
 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x08, 0x7D, 0x80, 0xA3, 
 0x55, 0x95, 0x62, 0xC7, 0xBB, 0xA0, 0x2B, 0xD5, 0xE5, 0x6A, 
 0x34, 0xB8, 0x30, 0xCD, 0xDF, 0x25, 0xB2, 0x93, 0xC9, 0x1E, 
 0xB6, 0xA9, 0x3E, 0x11, 0x17, 0x18, 0xA8, 0xAB, 0x31, 0x5B, 
 0x91, 0x57, 0x4B, 0xA7, 0x27, 0xE0, 0xA1, 0xAA, 0x8D, 0xD6, 
 0xED, 0x97, 0xEA, 0x1F, 0x8E, 0xE5, 0x0D, 0x84, 0xAB, 0x31, 
 0x45, 0x25, 0x5D, 0xCD, 0x10, 0xC3, 0x76, 0x65, 0x52, 0xDF, 
 0x93, 0x56, 0x09, 0xEF, 0xCA, 0x0B, 0x10, 0xE8, 0x4A, 0x5F, 
 0xA5, 0x7E, 0xC4, 0x66, 0x9D, 0xEE, 0xA8, 0xD0, 0xDC, 0x63, 
 0x2B, 0x93, 0xE9, 0xFC, 0x14, 0x67, 0xCB, 0x04, 0xBE, 0x29, 
 0xFE, 0x58, 0x15, 0x3A, 0x4A, 0xE4, 0xF6, 0xF0, 0x88, 0x4B, 
 0x78, 0xD8, 0xE1, 0x19, 0x66, 0x95, 0x2E, 0x11, 0x6C, 0xB1, 
 0xB4, 0xD2, 0x1A, 0x98, 0xCC, 0x91, 0x7C, 0x23, 0xF1, 0x1B, 
 0xC4, 0xB9, 0x27, 0x18, 0x52, 0xE0, 0x69, 0x8A, 0x64, 0xAE, 
 0x54, 0x97, 0x01, 0x38, 0xED, 0x18, 0xA5, 0xB9, 0x39, 0x26, 
 0x9D, 0xAD, 0x82, 0xBB, 0xF7, 0x06, 0x33, 0xD6, 0xEF, 0xE8, 
 0x4F, 0x67, 0xB1, 0x74, 0xA1, 0x4B, 0x61, 0x74, 0x59, 0x75, 
 0x30, 0xF0, 0xBA, 0x6A, 0xCE, 0x8E, 0x9E, 0x71, 0x8C, 0x53, 
 0xE7, 0x7D, 0x8E, 0x7C, 0x21, 0xB9, 0xA7, 0x1A, 0x92, 0xAB, 
 0x5B, 0x12, 0xB7, 0xCB, 0x5E, 0x7D, 0xE5, 0x69, 0x52, 0xFA, 
 0x2B, 0x82, 0x8D, 0xD3, 0x5B, 0x3F, 0x26, 0x9C, 0x49, 0x4E, 
 0x0A, 0xD7, 0x1D, 0xCB, 0x1E, 0x9A, 0xE4, 0xEF, 0x78, 0xF6, 
 0x33, 0xAE, 0x93, 0x95, 0x38, 0xF0, 0xC6, 0x5D, 0xB6, 0xFA, 
 0x27, 0xFC, 0x2C, 0x5D, 0xD4, 0x77, 0x5E, 0x0B, 0x61, 0x87, 
 0x6B, 0x86, 0xD2, 0x5C, 0xFD, 0xA3, 0x4E, 0x1D, 0xDA, 0x6D, 
 0x53, 0xE0, 0x9A, 0xD4, 0x8E, 0x77, 0xF0, 0x8B, 0x25, 0xD4, 
 0x55, 0xA3, 0x16, 0xA3, 0x4B, 0xD3, 0xBA, 0x5B, 0x9E, 0x81, 
 0xE3, 0xE9, 0xF9, 0x77, 0xBD, 0xCC, 0xDA, 0xAC, 0x1E, 0xE2, 
 0x74, 0xD7, 0xF6, 0x12, 0x97, 0x97, 0x9C, 0xF6, 0xF7, 0xDF, 
 0x9B, 0x2A, 0x97, 0xEB, 0x3A, 0x9A, 0x8D, 0x35, 0x2B, 0x57, 
 0x67, 0x39, 0xC5, 0xA6, 0xD3, 0xE4, 0xDC, 0xAE, 0x1D, 0x73, 
 0x8B, 0x52, 0x6B, 0x7F, 0x25, 0xFA, 0x3C, 0xEF, 0x06, 0x5A, 
 0x93, 0xF8, 0x48, 0x8E, 0x25, 0x78, 0xE8, 0x79, 0x31, 0xFC, 
 0x77, 0xE4, 0x26, 0x3B, 0x09, 0xA6, 0xB6, 0x03, 0x3E, 0x86, 
 0x7D, 0x7A, 0x74, 0x9F, 0x2B, 0x63, 0x41, 0xB8, 0xC8, 0x00, 
 0x00, 0x00, 0x00, 0x01, 0xB5, 0xB5, 0xA1, 0x12, 0x5B, 0x44, 
 0x88, 0x08, 0x18, 0x00, 0x08, 0x06, 0x20, 0x00, 0x00, 0x28, 
 0x62, 0x18, 0x10, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 
 0x65, 0x08, 0x62, 0x18, 0x01, 0xCB, 0xD7, 0x49, 0xE6, 0xD4, 
 0xF4, 0x27, 0xF1, 0x89, 0xD2, 0x93, 0xA8, 0xBA, 0xE4, 0xE4, 
 0xDA, 0x59, 0x5D, 0xBD, 0xDB, 0x33, 0x49, 0xF5, 0x3C, 0x8F, 
 0xE2, 0xBB, 0x52, 0x2A, 0x94, 0xDC, 0xE5, 0x08, 0xAE, 0x17, 
 0x23, 0xD4, 0x4D, 0x75, 0x7C, 0x5E, 0xC5, 0x38, 0xDD, 0xB9, 
 0x3E, 0x4C, 0xB6, 0x96, 0x79, 0xA6, 0xDF, 0x49, 0x08, 0xE3, 
 0x72, 0xAA, 0xDC, 0xB2, 0x30, 0xB6, 0xA2, 0xD6, 0xEC, 0xD3, 
 0x0C, 0x6B, 0x1E, 0xEC, 0x9A, 0xB2, 0x32, 0xCB, 0x04, 0xA1, 
 0xFA, 0x97, 0x3C, 0x13, 0xC7, 0x89, 0x17, 0x4D, 0x4A, 0x72, 
 0xB9, 0x6E, 0x91, 0x28, 0xC6, 0x4D, 0x54, 0x56, 0xC4, 0xD6, 
 0xB1, 0x44, 0xE3, 0x3B, 0xA8, 0xA6, 0x25, 0xA7, 0x72, 0x7E, 
 0x5F, 0xE0, 0xE8, 0xE2, 0xD3, 0xB7, 0xFA, 0xB8, 0x34, 0x61, 
 0xD3, 0xA4, 0x9B, 0x48, 0x9A, 0xDC, 0xE3, 0x58, 0x70, 0x69, 
 0xBD, 0xB8, 0x36, 0xD5, 0x2F, 0xFB, 0x17, 0xB3, 0xD7, 0x23, 
 0xA3, 0x3C, 0x56, 0xA9, 0xF7, 0xEC, 0x4B, 0x0E, 0x9B, 0xF9, 
 0x6F, 0x6A, 0x63, 0x5A, 0xF1, 0x72, 0xF3, 0x63, 0x51, 0x8F, 
 0x1C, 0x14, 0xCB, 0x78, 0xD7, 0x73, 0xA3, 0xAA, 0xC7, 0xD9, 
 0x70, 0x8C, 0x5E, 0xDF, 0x4C, 0xB8, 0xB2, 0xB9, 0xD8, 0xCA, 
 0xD3, 0x94, 0xF7, 0x2F, 0xF6, 0x9B, 0x94, 0x52, 0x5C, 0xB2, 
 0xCC, 0x78, 0x6F, 0x76, 0x6C, 0xC5, 0x8A, 0xFA, 0x2B, 0xFF, 
 0x00, 0xC1, 0x69, 0xCF, 0x2C, 0x79, 0xB4, 0xEE, 0x3D, 0x8A, 
 0xE3, 0x89, 0x77, 0x47, 0x7B, 0x3E, 0x9B, 0xDD, 0xCC, 0x92, 
 0x4B, 0xF4, 0xEE, 0x62, 0xCF, 0xA7, 0xE9, 0xC8, 0xF6, 0xDB, 
 0xB1, 0x35, 0xAB, 0xC3, 0x9E, 0xB1, 0x6F, 0xB1, 0x7C, 0x62, 
 0xD4, 0x5E, 0xC4, 0xE5, 0x8E, 0x93, 0x1D, 0xA5, 0x8E, 0xFB, 
 0x70, 0x54, 0xC5, 0xBA, 0x5C, 0x6D, 0x4A, 0x29, 0xBE, 0x5F, 
 0x07, 0x63, 0xD8, 0x8C, 0x93, 0x57, 0x5E, 0x11, 0xCE, 0xC5, 
 0x06, 0xE0, 0x9A, 0x57, 0xF6, 0x74, 0xE3, 0x1E, 0x3A, 0x5B, 
 0xE3, 0x96, 0x65, 0xD2, 0x45, 0x30, 0xC4, 0xAD, 0x6C, 0xB7, 
 0x14, 0x15, 0x64, 0xAF, 0x06, 0x89, 0xA9, 0x41, 0xA7, 0x28, 
 0xFC, 0x7C, 0xAD, 0xCA, 0xF1, 0xC5, 0xBC, 0xAA, 0x55, 0x49, 
 0xDF, 0x21, 0x71, 0x29, 0x25, 0x44, 0x5C, 0x17, 0x34, 0x59, 
 0x92, 0x2F, 0xA5, 0x91, 0x5B, 0xC7, 0x72, 0x15, 0x87, 0x3E, 
 0x9E, 0x37, 0xC7, 0x27, 0x27, 0xD4, 0x34, 0x9E, 0xDF, 0xCE, 
 0x28, 0xF4, 0x19, 0xA3, 0x71, 0x32, 0x6A, 0x31, 0x7B, 0x98, 
 0x9D, 0x9A, 0x95, 0x8E, 0xA6, 0xB8, 0x78, 0xDA, 0xAD, 0xB9, 
 0x2C, 0x53, 0x8B, 0x85, 0x35, 0xBF, 0x05, 0x2E, 0x2E, 0x19, 
 0x9E, 0xDC, 0x11, 0xCB, 0x2A, 0x6A, 0x5D, 0xB8, 0x34, 0xE2, 
 0xD7, 0xA2, 0x9F, 0xB7, 0x97, 0xA3, 0xB4, 0xB8, 0x3A, 0x07, 
 0x17, 0x14, 0xDB, 0x4E, 0x9F, 0x1B, 0xA3, 0xB1, 0x8A, 0x7D, 
 0x78, 0xE3, 0x25, 0xDD, 0x1B, 0x8C, 0x54, 0x80, 0x62, 0x2A, 
 0x00, 0x01, 0x94, 0x1D, 0x84, 0xC7, 0x7B, 0x08, 0x81, 0x03, 
 0x18, 0x80, 0x04, 0x30, 0x01, 0x00, 0xC0, 0x00, 0x00, 0x0A, 
 0x00, 0x01, 0x80, 0x86, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
 0x04, 0x33, 0x35, 0x1C, 0x72, 0x7E, 0x11, 0xC2, 0x72, 0xBC, 
 0x96, 0x75, 0xB5, 0xF3, 0xE8, 0xC0, 0xCE, 0x35, 0x39, 0x37, 
 0x4B, 0x93, 0x34, 0x89, 0x75, 0x75, 0x49, 0x9A, 0x5C, 0x21, 
 0x8B, 0x12, 0xFF, 0x00, 0x3F, 0x6C, 0xA2, 0x31, 0xE8, 0x7F, 
 0x62, 0x93, 0x96, 0x49, 0xAD, 0xDD, 0x76, 0x32, 0xD4, 0x6B, 
 0xC5, 0x8D, 0xCA, 0x76, 0x6B, 0x58, 0x5C, 0xDE, 0xC2, 0xD1, 
 0x63, 0xBF, 0xBD, 0x8E, 0x96, 0x2C, 0x4B, 0x63, 0x16, 0xBB, 
 0xF3, 0xCB, 0x1E, 0x3D, 0x3A, 0xEA, 0xA9, 0x78, 0x2F, 0x8E, 
 0x28, 0xC6, 0xBA, 0x63, 0x6C, 0xD7, 0x2C, 0x29, 0xAE, 0x05, 
 0x0C, 0x6F, 0xA9, 0x11, 0xD2, 0x42, 0xC5, 0x82, 0x95, 0xC8, 
 0xBF, 0x16, 0x15, 0xD2, 0xEB, 0x6A, 0x2E, 0xC7, 0x04, 0xD1, 
 0x6C, 0x21, 0x44, 0x6D, 0x82, 0x78, 0x6B, 0x2B, 0x6F, 0x72, 
 0x53, 0x84, 0x55, 0xC5, 0xA7, 0xC1, 0xAE, 0x58, 0x97, 0x54, 
 0xA5, 0xDC, 0xAF, 0x34, 0x29, 0xB7, 0xC7, 0xD8, 0x4C, 0x72, 
 0x35, 0x09, 0xBC, 0x8D, 0x22, 0x8F, 0x6A, 0xE0, 0xEB, 0xB1, 
 0xBB, 0x2C, 0x13, 0x8A, 0x7D, 0xED, 0xA2, 0x12, 0xC5, 0xD1, 
 0x89, 0x3A, 0xE7, 0x92, 0xEB, 0x17, 0x96, 0x6C, 0x38, 0xFE, 
 0x2E, 0xF9, 0xEC, 0x6C, 0xD3, 0x45, 0x6D, 0xFF, 0x00, 0x22, 
 0xB8, 0xE3, 0x71, 0xDB, 0x6D, 0xDD, 0x16, 0xC6, 0x12, 0xC5, 
 0x91, 0x3D, 0xFF, 0x00, 0xFB, 0x0B, 0x23, 0x66, 0x2C, 0x7D, 
 0x52, 0x77, 0xB3, 0xEF, 0x66, 0x6D, 0x74, 0x12, 0x9D, 0x2D, 
 0xF8, 0x5B, 0x1A, 0xB1, 0xE4, 0xDA, 0xA9, 0xDB, 0xED, 0xE5, 
 0x99, 0xF3, 0x46, 0x4E, 0x7D, 0x52, 0x5C, 0x70, 0x88, 0xD5, 
 0x73, 0xB3, 0xE3, 0xE8, 0x8F, 0x8B, 0x44, 0x30, 0xE1, 0x73, 
 0x8C, 0x5F, 0x65, 0xBB, 0x34, 0xE5, 0x8C, 0xB3, 0x4B, 0xA6, 
 0x2B, 0xA9, 0x2E, 0x59, 0xAF, 0x4B, 0xA6, 0xF8, 0x28, 0x95, 
 0x9C, 0x2C, 0x18, 0xDF, 0xB5, 0x18, 0xBF, 0xFA, 0x37, 0x25, 
 0x5C, 0xAA, 0xFC, 0x12, 0xC5, 0x8B, 0xDB, 0x92, 0x7E, 0x76, 
 0x2E, 0x71, 0x6D, 0x11, 0xAC, 0x66, 0x6B, 0x6F, 0x94, 0xBA, 
 0xAB, 0x81, 0x53, 0x7F, 0x2E, 0x3C, 0x1A, 0x7D, 0xB5, 0xE0, 
 0x84, 0xD0, 0x55, 0x55, 0x68, 0x84, 0xD5, 0x17, 0x55, 0x22, 
 0xA9, 0xBB, 0x0C, 0xA9, 0x9F, 0x82, 0x97, 0xBD, 0xA6, 0x5D, 
 0x32, 0x96, 0x56, 0x6B, 0x8F, 0xEA, 0x18, 0x7A, 0x72, 0x5C, 
 0x76, 0x31, 0x4E, 0x3D, 0x58, 0xDB, 0xEE, 0xB9, 0x47, 0x6F, 
 0x5B, 0x8B, 0xDC, 0xC4, 0xDA, 0x39, 0x19, 0x2B, 0xA1, 0xF6, 
 0x6B, 0x94, 0x6E, 0x38, 0xF5, 0x19, 0x31, 0xCB, 0xA6, 0x5B, 
 0xF0, 0x76, 0x34, 0x13, 0xEA, 0xC3, 0x5E, 0x0E, 0x27, 0x73, 
 0xA7, 0xE9, 0x59, 0x6E, 0xE0, 0xCD, 0x47, 0x27, 0x48, 0x43, 
 0x11, 0xA4, 0x31, 0x0C, 0x00, 0x40, 0x00, 0x00, 0x21, 0x80, 
 0x08, 0x00, 0x18, 0x08, 0x00, 0x02, 0x18, 0x00, 0x15, 0x4C, 
 0x40, 0x00, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 
 0x9F, 0xEA, 0x8E, 0xFA, 0x23, 0xE4, 0xC3, 0x29, 0x28, 0xB7, 
 0x5C, 0x9A, 0x7D, 0x42, 0x6A, 0x5A, 0x86, 0xBB, 0xC5, 0x51, 
 0x9B, 0xDB, 0x4D, 0x26, 0xD9, 0x8A, 0xB1, 0x5B, 0x6F, 0xA6, 
 0xFB, 0x1A, 0x34, 0xF8, 0xFA, 0xDA, 0x4B, 0xC1, 0x0C, 0x90, 
 0xEA, 0xE9, 0x48, 0xE9, 0x7A, 0x66, 0x9F, 0xE4, 0xAF, 0x72, 
 0x5F, 0x8D, 0xF3, 0x36, 0xB4, 0x68, 0xF1, 0xB8, 0x2A, 0x68, 
 0xE8, 0x62, 0xFD, 0x44, 0x25, 0x89, 0x2E, 0x09, 0xE3, 0xE4, 
 0xE6, 0xF4, 0x45, 0xFD, 0x81, 0x44, 0x17, 0x05, 0x89, 0x59, 
 0x1B, 0x3C, 0x37, 0xBD, 0x9A, 0x62, 0xAC, 0xA6, 0x05, 0xC8, 
 0x8A, 0x6E, 0x37, 0x1A, 0x20, 0xF1, 0x29, 0x46, 0x9A, 0x2C, 
 0x24, 0x8A, 0x9A, 0xE6, 0x6A, 0x74, 0x53, 0xBB, 0xC4, 0x42, 
 0x78, 0xE4, 0xF1, 0x74, 0xCB, 0x1B, 0x4E, 0x8E, 0xC5, 0x58, 
 0xDC, 0x23, 0x25, 0xBA, 0xB1, 0x89, 0xAE, 0x0C, 0x21, 0x3E, 
 0x1F, 0x67, 0x68, 0xD6, 0xA0, 0xF2, 0x2E, 0x29, 0xAF, 0x26, 
 0xAC, 0x9A, 0x65, 0xD6, 0xE4, 0xB6, 0x12, 0xC5, 0xE5, 0x30, 
 0xD3, 0x17, 0x4E, 0x47, 0x25, 0xD9, 0xF6, 0x69, 0x13, 0x5A, 
 0x57, 0x3F, 0xF7, 0x65, 0x26, 0xBF, 0xE2, 0x91, 0xBF, 0x14, 
 0x29, 0xDB, 0x45, 0xF4, 0x86, 0x33, 0x6E, 0x39, 0xD1, 0xD2, 
 0x37, 0x4A, 0x31, 0xE8, 0x89, 0xAA, 0x18, 0x54, 0x12, 0xA4, 
 0x68, 0x6B, 0x62, 0x17, 0x7B, 0x22, 0xE2, 0x79, 0x6A, 0xA9, 
 0x47, 0x6E, 0x09, 0x12, 0x97, 0x02, 0x61, 0x75, 0x17, 0xC1, 
 0x54, 0xF7, 0x2D, 0x65, 0x52, 0x22, 0xAB, 0x65, 0x33, 0xF0, 
 0x5B, 0x2D, 0x93, 0x29, 0x90, 0x4A, 0xAD, 0xFD, 0x94, 0xBD, 
 0xEC, 0xBE, 0x5D, 0xCA, 0x1E, 0xCC, 0xA9, 0x49, 0xC7, 0xAA, 
 0x0D, 0x1C, 0x5D, 0x4E, 0x35, 0x1C, 0x92, 0x5C, 0x33, 0xBA, 
 0x96, 0xC7, 0x2B, 0xD4, 0xB1, 0xD4, 0xBA, 0x91, 0x63, 0x97, 
 0x71, 0xC3, 0xC8, 0x9C, 0x72, 0x34, 0xCD, 0x7E, 0x9B, 0x93, 
 0xA3, 0x52, 0xBC, 0x49, 0x51, 0x4E, 0xA6, 0x36, 0xFA, 0x91, 
 0x0D, 0x3C, 0xFD, 0xBC, 0xB0, 0x97, 0x86, 0x74, 0x70, 0x7A, 
 0x30, 0x14, 0x64, 0xA5, 0x14, 0xD7, 0x70, 0x34, 0x86, 0x20, 
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 
 0x01, 0x40, 0x00, 0x04, 0x0C, 0x00, 0x0A, 0x00, 0x00, 0x00, 
 0x00, 0x00, 0x01, 0x3E, 0x06, 0x1C, 0x20, 0x38, 0xFA, 0x84, 
 0x96, 0xA6, 0x57, 0xCB, 0xDC, 0xAA, 0x4D, 0xD2, 0x7D, 0xAC, 
 0xB7, 0x2D, 0xBD, 0x44, 0xA4, 0xFB, 0x99, 0xF2, 0xCB, 0x75, 
 0x15, 0xC2, 0x30, 0xAD, 0x31, 0xAB, 0x5B, 0x73, 0xDC, 0xED, 
 0x7A, 0x66, 0x35, 0x18, 0xB9, 0x79, 0x38, 0x5A, 0x77, 0xD7, 
 0x35, 0x7B, 0x51, 0xE8, 0xB4, 0x51, 0xAC, 0x48, 0xC7, 0x4E, 
 0xDC, 0x34, 0x3E, 0x08, 0xC3, 0xF5, 0x13, 0x22, 0xB6, 0x66, 
 0x1D, 0x96, 0xDF, 0x82, 0xC8, 0x95, 0x45, 0x96, 0xC3, 0x72, 
 0x35, 0x17, 0x43, 0x7B, 0x2C, 0x89, 0x52, 0x74, 0xCB, 0x62, 
 0xD3, 0x41, 0x4D, 0x32, 0x4A, 0xC8, 0xAD, 0x89, 0x26, 0x0A, 
 0x9A, 0xFC, 0x92, 0xE4, 0x82, 0x74, 0x58, 0x91, 0xA8, 0xC5, 
 0x46, 0x87, 0xD2, 0x1C, 0x31, 0xDE, 0xE1, 0x0A, 0x83, 0x70, 
 0x6C, 0x0A, 0x13, 0xBF, 0x22, 0x7C, 0xF2, 0x36, 0x27, 0xC1, 
 0x16, 0x16, 0xE2, 0x63, 0x13, 0x64, 0x58, 0x8B, 0x2B, 0x65, 
 0x8D, 0x59, 0x5C, 0x88, 0xD2, 0xB9, 0xF0, 0x50, 0xD1, 0x7C, 
 0xD5, 0x15, 0xB4, 0x11, 0x4C, 0xD6, 0xCF, 0xC9, 0x43, 0xE4, 
 0xD3, 0x93, 0x83, 0x3F, 0x0F, 0x72, 0xB3, 0x52, 0x46, 0x3D, 
 0x7C, 0x6F, 0x19, 0xA6, 0xCC, 0xDA, 0xA9, 0x7C, 0x1E, 0xC6, 
 0xA3, 0x9F, 0x5F, 0x1C, 0x3C, 0xD1, 0x51, 0x72, 0x8B, 0x76, 
 0x99, 0x8F, 0x86, 0x69, 0xD4, 0x4B, 0xE6, 0xCC, 0xCF, 0x93, 
 0xA4, 0x79, 0xEB, 0xBF, 0xA0, 0x9F, 0x5E, 0x96, 0x0D, 0xBB, 
 0xD8, 0xD0, 0x60, 0xF4, 0x86, 0xDE, 0x06, 0x9F, 0x66, 0x6F, 
 0x35, 0x10, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x04, 0x00, 
 0x00, 0x00, 0x00, 0x00, 0x00, 0x31, 0x0C, 0x00, 0x00, 0x00, 
 0x00, 0x00, 0xA0, 0x00, 0x02, 0x00, 0x1F, 0x00, 0x29, 0x6D, 
 0x16, 0x07, 0x23, 0x3E, 0x45, 0xD7, 0x2A, 0xF2, 0x62, 0x6E, 
 0xE6, 0x5B, 0xA8, 0x9F, 0xCD, 0xAF, 0xB3, 0x3D, 0xEE, 0x41, 
 0xBB, 0x4D, 0x5D, 0x49, 0x77, 0x3D, 0x1E, 0x9D, 0xA5, 0x89, 
 0x23, 0xCD, 0x68, 0x9D, 0xCE, 0xD9, 0xDE, 0xD3, 0xE4, 0xB8, 
 0xD1, 0xCF, 0xA7, 0x6E, 0x2B, 0x6A, 0x76, 0x34, 0xB6, 0x2B, 
 0x8E, 0xC9, 0x16, 0x2E, 0x0C, 0x3B, 0xA5, 0x14, 0x5F, 0x0E, 
 0x11, 0x44, 0x56, 0xE6, 0x88, 0xF9, 0x32, 0xDC, 0x48, 0xB2, 
 0x2A, 0x97, 0x24, 0x2B, 0xA8, 0xB2, 0x31, 0x0A, 0x93, 0x1A, 
 0x17, 0x4B, 0x25, 0x45, 0x43, 0xA4, 0xF9, 0x26, 0x9A, 0xF2, 
 0x45, 0x22, 0x49, 0x6E, 0x6A, 0x31, 0x4E, 0xC2, 0xD2, 0xEE, 
 0x03, 0x2A, 0x23, 0x68, 0x17, 0x1D, 0xC6, 0x30, 0x17, 0xEC, 
 0xC8, 0xBE, 0x49, 0x09, 0x90, 0x88, 0x91, 0x64, 0x9D, 0x09, 
 0x91, 0xA4, 0x59, 0x09, 0x70, 0x49, 0xF2, 0x29, 0xC7, 0x66, 
 0xAC, 0x8D, 0x2A, 0x94, 0x5C, 0x8A, 0xDD, 0xD1, 0x6B, 0xB8, 
 0xAF, 0x25, 0x53, 0xDC, 0x0A, 0x66, 0x53, 0x22, 0xD9, 0xB2, 
 0x89, 0xB2, 0xB3, 0x51, 0x96, 0xC6, 0x2D, 0x4C, 0xFE, 0x2D, 
 0x59, 0xAA, 0x4F, 0xE2, 0xEC, 0xE7, 0x6B, 0x65, 0xB3, 0x35, 
 0x1C, 0xBA, 0x72, 0x75, 0x12, 0xB9, 0xB2, 0x9B, 0x2C, 0xCC, 
 0xEE, 0x4D, 0x95, 0x1D, 0x23, 0xCD, 0x5D, 0x8F, 0x47, 0xAF, 
 0x66, 0x7E, 0x6C, 0xE8, 0x9C, 0xBF, 0x45, 0x6F, 0xE6, 0x8E, 
 0xA1, 0xA8, 0x00, 0x00, 0x00, 0x10, 0xC4, 0x00, 0x00, 0x00, 
 0x20, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x00, 0x00, 0x01, 
 0x40, 0x00, 0x00, 0x30, 0x00, 0x00, 0x23, 0x37, 0x51, 0x6F, 
 0xE8, 0x91, 0x1C, 0x9F, 0xA2, 0x5F, 0x80, 0x3C, 0xE6, 0x77, 
 0xFC, 0xD6, 0xCA, 0x89, 0xE7, 0x6F, 0xDC, 0x76, 0x40, 0xCA, 
 0x35, 0x69, 0x67, 0xD3, 0x23, 0xB3, 0xA3, 0xC9, 0x6B, 0x73, 
 0x81, 0x09, 0x53, 0x54, 0x76, 0x3D, 0x36, 0xE4, 0x63, 0xA7, 
 0x5E, 0x1D, 0x68, 0xBB, 0xA3, 0x44, 0x57, 0xC4, 0xCF, 0x17, 
 0x51, 0xA2, 0xE8, 0x3F, 0x89, 0xCE, 0xBD, 0x31, 0x6C, 0x4B, 
 0xE0, 0x8A, 0x60, 0x8D, 0x10, 0x44, 0x6E, 0x24, 0x8B, 0x22, 
 0x46, 0x31, 0x26, 0x90, 0xC0, 0xD0, 0x07, 0x60, 0x6C, 0xB8, 
 0x86, 0x99, 0x2E, 0xA4, 0x9E, 0xE5, 0x62, 0x69, 0x49, 0xAB, 
 0x7C, 0x14, 0xC5, 0xD7, 0x4A, 0xC6, 0x9D, 0xF0, 0x57, 0x76, 
 0xA9, 0x8D, 0x3A, 0x5C, 0x95, 0x9C, 0x4C, 0x62, 0xEA, 0xBE, 
 0x04, 0xE5, 0x41, 0x12, 0x7B, 0x10, 0x6C, 0x1C, 0xC8, 0x39, 
 0x05, 0x91, 0x27, 0x49, 0x0B, 0x91, 0x37, 0x60, 0x88, 0xD6, 
 0x00, 0x75, 0x54, 0x16, 0x0C, 0x82, 0xB9, 0x2D, 0x8C, 0xF3, 
 0x46, 0x99, 0x22, 0x9C, 0x91, 0x18, 0xAC, 0x93, 0x5B, 0x94, 
 0xCB, 0x93, 0x44, 0xD1, 0x9E, 0x7B, 0x58, 0x62, 0xAB, 0x6B, 
 0xE0, 0x72, 0x35, 0xCD, 0xC6, 0x4E, 0xCE, 0xB3, 0x6D, 0xEC, 
 0x73, 0x3D, 0x4E, 0x1D, 0xD1, 0xA8, 0xE7, 0xDF, 0xC7, 0x1F, 
 0x2E, 0xF2, 0x64, 0x09, 0xCF, 0x92, 0x08, 0xEA, 0xF3, 0x57, 
 0x63, 0xD1, 0xE2, 0x96, 0x39, 0x4B, 0xCB, 0x3A, 0x26, 0x3F, 
 0x4B, 0x8F, 0x4E, 0x99, 0x5F, 0x7D, 0xCD, 0x85, 0x00, 0x00, 
 0x00, 0x80, 0x62, 0x00, 0x00, 0x02, 0x84, 0x30, 0x02, 0x04, 
 0x00, 0x01, 0x0C, 0x04, 0x30, 0xA0, 0x00, 0x00, 0x00, 0x00, 
 0xA0, 0x18, 0x08, 0x06, 0x27, 0xC0, 0xC0, 0x0F, 0x3B, 0xAD, 
 0x8D, 0x6A, 0x67, 0xF9, 0x33, 0x9B, 0xBD, 0x56, 0x1D, 0x3A, 
 0x8B, 0xEC, 0xCC, 0x24, 0x44, 0xA0, 0x77, 0xBD, 0x2E, 0x35, 
 0x8F, 0xEC, 0xE1, 0xE2, 0x57, 0x34, 0x8F, 0x47, 0xA4, 0xC7, 
 0xD1, 0x86, 0x35, 0xC9, 0xCF, 0xA7, 0x5F, 0xCD, 0xAF, 0xFA, 
 0x4B, 0xB1, 0x70, 0x8A, 0x2F, 0x62, 0xDC, 0x73, 0x50, 0x5B, 
 0x98, 0x7A, 0x23, 0x64, 0x52, 0x2C, 0x52, 0x51, 0x39, 0xB9, 
 0x35, 0xCA, 0x3B, 0x2F, 0xF0, 0x55, 0xFC, 0x64, 0xFB, 0x47, 
 0x66, 0x4C, 0x6B, 0x5D, 0xA8, 0xE4, 0x54, 0x37, 0x91, 0x1C, 
 0x55, 0xAD, 0x92, 0xE5, 0x34, 0x42, 0x7E, 0xA1, 0xE5, 0xB2, 
 0x9E, 0x4E, 0xEF, 0xBD, 0x1E, 0x44, 0xF3, 0x47, 0xC9, 0xE7, 
 0xA5, 0xEA, 0x12, 0xFE, 0x96, 0x52, 0xF5, 0xD2, 0x6F, 0x9B, 
 0x18, 0x9E, 0x4F, 0x4A, 0xF3, 0xC5, 0xED, 0x62, 0x59, 0x53, 
 0xEE, 0x79, 0xF8, 0x6A, 0xA6, 0xFB, 0x9B, 0x71, 0x6A, 0x2D, 
 0x6E, 0xC3, 0x53, 0xA7, 0x56, 0x33, 0x4F, 0xB9, 0x3E, 0xAE, 
 0xC6, 0x0C, 0x79, 0x2F, 0x7B, 0x35, 0xE3, 0xB6, 0x46, 0xD6, 
 0xA9, 0x30, 0xEA, 0x12, 0xAA, 0x23, 0x20, 0x98, 0x6E, 0x64, 
 0x7D, 0xC4, 0x9E, 0xE5, 0x19, 0x67, 0xD3, 0xDC, 0xC7, 0x9B, 
 0x54, 0xD5, 0xD0, 0x2D, 0x91, 0xD1, 0x96, 0xA2, 0x11, 0xE6, 
 0x49, 0x11, 0xFE, 0x33, 0x1B, 0x7B, 0x49, 0x1C, 0x1C, 0xBA, 
 0x89, 0x35, 0xBB, 0x33, 0xFF, 0x00, 0x10, 0xE3, 0xCB, 0xFF, 
 0x00, 0x25, 0xC7, 0x3B, 0xD3, 0xD4, 0x2D, 0x54, 0x1F, 0x0C, 
 0x7E, 0xFC, 0x7C, 0x9E, 0x62, 0x1A, 0xC9, 0xAE, 0x0B, 0xF1, 
 0xEA, 0xB2, 0xBE, 0x06, 0x27, 0x95, 0x77, 0xE5, 0x99, 0x14, 
 0xCF, 0x3C, 0x57, 0x2C, 0xE6, 0x7F, 0x11, 0x9A, 0x8A, 0xDE, 
 0x49, 0xB9, 0x6F, 0x6B, 0xEA, 0xC6, 0x2F, 0x93, 0xAA, 0xE7, 
 0x19, 0x2D, 0x99, 0x9B, 0x27, 0x0C, 0xCB, 0xEF, 0x38, 0xD7, 
 0x51, 0x28, 0xE6, 0xBD, 0x9B, 0x09, 0x6E, 0xA4, 0x8C, 0xBA, 
 0xE8, 0x5E, 0x17, 0x66, 0x98, 0x3D, 0xD9, 0x5E, 0xAD, 0x7F, 
 0x22, 0x45, 0x9F, 0x58, 0xBF, 0x1E, 0x6B, 0x2F, 0xEA, 0x65, 
 0x6B, 0x92, 0xDC, 0xCB, 0xE6, 0xC8, 0x42, 0x2E, 0x73, 0x49, 
 0x2B, 0x6C, 0xEA, 0xF3, 0x5F, 0xAF, 0x41, 0xA2, 0x8D, 0x69, 
 0xA0, 0x9A, 0xEC, 0x68, 0x2A, 0xC1, 0x17, 0x1C, 0x31, 0x8B, 
 0xE5, 0x22, 0xC2, 0x80, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 
 0x00, 0x02, 0x18, 0x80, 0x00, 0x00, 0x06, 0x00, 0x05, 0x00, 
 0x00, 0x00, 0x0C, 0x40, 0x03, 0x00, 0x10, 0x0C, 0x00, 0x00, 
 0xE5, 0x7A, 0xC4, 0x7F, 0x44, 0x8E, 0x5F, 0x73, 0xB5, 0xEA, 
 0xAB, 0xAB, 0x0A, 0xA5, 0x7B, 0xF2, 0x71, 0x9A, 0x33, 0x45, 
 0xDA, 0x55, 0x79, 0x51, 0xE9, 0xB0, 0xC7, 0xF9, 0x51, 0xFC, 
 0x1E, 0x6F, 0x46, 0xAF, 0x34, 0x6B, 0xC9, 0xE9, 0xF1, 0xAA, 
 0x82, 0x39, 0xF4, 0xED, 0xF9, 0xA3, 0x37, 0x45, 0x32, 0x9B, 
 0x93, 0xAB, 0xA3, 0x46, 0x48, 0xD9, 0x9F, 0xA1, 0xA9, 0x5D, 
 0x11, 0xD0, 0x47, 0x1D, 0xF2, 0xD3, 0x64, 0xD5, 0x41, 0x0F, 
 0x74, 0xB7, 0x5F, 0xD8, 0xCF, 0xA9, 0x93, 0x6F, 0xA5, 0x3A, 
 0x5D, 0xD8, 0x53, 0xC9, 0x99, 0x37, 0xD3, 0x08, 0x75, 0x3F, 
 0xA2, 0x1F, 0xC2, 0xE6, 0xCD, 0xCC, 0x94, 0x7E, 0x92, 0xB1, 
 0xC3, 0x51, 0x18, 0x2E, 0x8C, 0x30, 0xEA, 0x97, 0x92, 0x8D, 
 0x5E, 0x5D, 0x4E, 0x39, 0x2B, 0x9F, 0x4C, 0xAA, 0xE9, 0x15, 
 0x7C, 0xA4, 0x4E, 0x5E, 0x95, 0x27, 0xCE, 0x59, 0x15, 0xBF, 
 0x48, 0x9F, 0x6C, 0x84, 0x23, 0x9B, 0x59, 0x1C, 0x0F, 0x37, 
 0xC9, 0xC3, 0xAB, 0xA7, 0xAF, 0xB5, 0xF8, 0x3A, 0x3A, 0x1D, 
 0x56, 0x5D, 0x46, 0x36, 0xA7, 0x15, 0x26, 0xBC, 0x72, 0x09, 
 0xDC, 0xAE, 0x7A, 0xD1, 0x6A, 0xB0, 0xBB, 0xDE, 0x4B, 0xE9, 
 0x96, 0xC2, 0x79, 0x23, 0xFA, 0x93, 0x5F, 0x93, 0xA9, 0x1D, 
 0xF8, 0x63, 0xCB, 0xA7, 0xF7, 0x22, 0xDA, 0x5B, 0x91, 0xD2, 
 0xF3, 0xFE, 0x33, 0xE9, 0xB3, 0xB5, 0x24, 0xA4, 0x75, 0xF0, 
 0x4B, 0xA9, 0x23, 0x8B, 0x18, 0x53, 0xA7, 0xD8, 0xEA, 0x68, 
 0x25, 0x71, 0xA7, 0xC9, 0x9A, 0x73, 0x5D, 0x08, 0xA4, 0xD1, 
 0x4E, 0x5D, 0x9D, 0x9A, 0x63, 0x54, 0x51, 0xA8, 0xA4, 0x98, 
 0x25, 0xF6, 0xE6, 0x6B, 0x33, 0x74, 0xEC, 0x73, 0xB2, 0x39, 
 0x3F, 0x2D, 0xBE, 0xC6, 0xBC, 0xED, 0xB9, 0xB6, 0xFB, 0x0B, 
 0x0E, 0x27, 0x37, 0x68, 0xAC, 0xFD, 0xAC, 0x1F, 0xC0, 0xE7, 
 0xCC, 0xFF, 0x00, 0x52, 0x8A, 0x2D, 0xC7, 0xE8, 0xF8, 0xBF, 
 0xAA, 0x52, 0x9C, 0xBC, 0x23, 0xA3, 0x91, 0x28, 0x2A, 0xBA, 
 0x46, 0x3D, 0x7E, 0x4C, 0xF8, 0xF4, 0xF1, 0x70, 0xF8, 0x29, 
 0x71, 0xE5, 0x96, 0x2D, 0xCE, 0x62, 0xB5, 0xA0, 0xD3, 0xC5, 
 0xD3, 0xF8, 0xB5, 0xFF, 0x00, 0xB1, 0x25, 0x82, 0x09, 0x7F, 
 0x2F, 0x2F, 0xF9, 0x39, 0xCA, 0x33, 0x9E, 0x9F, 0x2C, 0xA7, 
 0x9E, 0x2B, 0xA1, 0xA6, 0xE3, 0x29, 0x7C, 0x9D, 0xF8, 0x27, 
 0xA3, 0xC6, 0xB2, 0x65, 0x51, 0x6D, 0xD4, 0xB6, 0x5B, 0xF0, 
 0x6B, 0x1C, 0xBC, 0xF5, 0xB6, 0x5E, 0xE6, 0x2F, 0xD6, 0xAD, 
 0x79, 0x43, 0x8C, 0x94, 0x95, 0xC5, 0xD9, 0x4E, 0x6C, 0x79, 
 0xF4, 0x72, 0xE7, 0xAA, 0x0F, 0xC8, 0xF4, 0xF5, 0x39, 0xB7, 
 0x1D, 0xAF, 0x94, 0x4A, 0xB2, 0xEA, 0xD6, 0x9B, 0xE6, 0x88, 
 0x35, 0xD2, 0xCD, 0x4B, 0x15, 0xAE, 0x08, 0xBC, 0x4E, 0xF6, 
 0x44, 0x2C, 0x47, 0x1B, 0xF9, 0x0F, 0x55, 0xFE, 0xC4, 0xBF, 
 0x04, 0xA3, 0x0A, 0x61, 0x9E, 0x37, 0x85, 0xAF, 0xA1, 0x19, 
 0xBF, 0x1E, 0x5F, 0x27, 0xEB, 0x65, 0xBA, 0x15, 0x7A, 0x98, 
 0xEC, 0x57, 0x99, 0x56, 0x49, 0x2F, 0xB3, 0xAB, 0xE8, 0x1A, 
 0x37, 0x97, 0x37, 0x5C, 0xB8, 0x5E, 0x4D, 0xDB, 0x91, 0xC7, 
 0x9E, 0x7C, 0xAE, 0x3A, 0x50, 0xC1, 0x39, 0x47, 0xAA, 0xA9, 
 0x7D, 0x90, 0x69, 0xC7, 0x66, 0x74, 0x35, 0x2E, 0x38, 0x30, 
 0x36, 0xDD, 0x24, 0x8E, 0x74, 0x72, 0xAC, 0xD1, 0xEA, 0x8B, 
 0x13, 0xAB, 0xAE, 0xBD, 0xFE, 0x53, 0x99, 0xE8, 0xC4, 0x00, 
 0x6D, 0xE7, 0x02, 0x18, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 
 0x40, 0x30, 0x00, 0x00, 0x02, 0x80, 0x00, 0x08, 0x18, 0x08, 
 0x60, 0x00, 0x00, 0x02, 0x25, 0x04, 0x9C, 0x92, 0x7C, 0x31, 
 0x04, 0xA2, 0xDE, 0x29, 0x4A, 0x3C, 0xA2, 0x75, 0x7D, 0x35, 
 0xC4, 0xDA, 0xDB, 0xA8, 0xD1, 0x62, 0xCF, 0xA6, 0x71, 0xE9, 
 0x5C, 0x76, 0x3C, 0x8E, 0xAB, 0x4F, 0x2C, 0x19, 0x5C, 0x65, 
 0xD9, 0x9E, 0xAB, 0xD3, 0xF5, 0xD1, 0xCF, 0x8A, 0x9E, 0xD2, 
 0x5B, 0x34, 0x73, 0x7D, 0x73, 0x14, 0x64, 0xD6, 0x48, 0xAE, 
 0xFC, 0x9C, 0xF9, 0xAF, 0x4F, 0xEB, 0xC4, 0xCD, 0x8E, 0x6F, 
 0xA7, 0xC7, 0xF9, 0xF1, 0xFC, 0x9E, 0x93, 0x1A, 0xF8, 0xA3, 
 0x81, 0xE9, 0xD0, 0xFE, 0x6A, 0x3D, 0x06, 0x3E, 0x07, 0x4C, 
 0x7E, 0x73, 0xD2, 0x4E, 0x36, 0x2F, 0x6D, 0x17, 0xC6, 0x16, 
 0x37, 0x85, 0xF8, 0x31, 0xAE, 0xB8, 0xCD, 0x49, 0x71, 0xC9, 
 0x87, 0x5B, 0x0A, 0x4A, 0x31, 0xDE, 0x4F, 0x93, 0xA8, 0xF1, 
 0xBF, 0x04, 0x27, 0xA6, 0x4D, 0x36, 0xF9, 0x29, 0x8C, 0xFA, 
 0x1D, 0x1A, 0xC2, 0xFA, 0x9A, 0xBB, 0xEE, 0x63, 0xF5, 0x6C, 
 0x33, 0x59, 0xBA, 0x9F, 0x12, 0xE0, 0xE9, 0x62, 0xCB, 0x2C, 
 0x6B, 0xA5, 0xAE, 0x0B, 0x67, 0x2C, 0x79, 0xA3, 0xD3, 0x97, 
 0x1A, 0x92, 0xF0, 0x68, 0xBC, 0x6F, 0xB7, 0x98, 0xE9, 0xCA, 
 0xD3, 0x8F, 0x5C, 0x9C, 0x1B, 0xEA, 0x71, 0xBD, 0xAC, 0xEF, 
 0x7A, 0x0E, 0x06, 0x9C, 0xB2, 0x3D, 0xA3, 0x54, 0x8D, 0x50, 
 0xC3, 0xA6, 0x84, 0x1C, 0x56, 0x9E, 0x2D, 0x3E, 0x6C, 0x9F, 
 0xBB, 0x18, 0x2A, 0x84, 0x14, 0x23, 0xE1, 0x04, 0x9F, 0x9A, 
 0x3A, 0x8D, 0x2A, 0x94, 0xE5, 0x3C, 0x73, 0x51, 0x69, 0x5B, 
 0xBE, 0xE3, 0xC3, 0x2D, 0x94, 0x72, 0xC5, 0x26, 0xF8, 0x69, 
 0xEC, 0xC1, 0x64, 0x52, 0x7F, 0xA6, 0xD1, 0x6F, 0x4C, 0x7A, 
 0x6F, 0xA6, 0x28, 0x8E, 0xD3, 0xD4, 0xC6, 0x1C, 0xB8, 0x5A, 
 0xCE, 0xDD, 0x6C, 0xF8, 0x2F, 0xD1, 0xFC, 0x66, 0xC9, 0x3B, 
 0x92, 0x4D, 0xF6, 0x23, 0x89, 0xD3, 0xFD, 0xC9, 0x59, 0x9E, 
 0xEB, 0xA9, 0x19, 0x6C, 0x51, 0xA8, 0x76, 0x98, 0xE3, 0x26, 
 0xD2, 0xEC, 0x57, 0x99, 0xBA, 0x22, 0xCE, 0x5C, 0xEC, 0x90, 
 0xEA, 0x6D, 0x2F, 0x26, 0x88, 0x28, 0xE0, 0xC0, 0x92, 0x8D, 
 0xE4, 0x91, 0x05, 0xFE, 0xE3, 0x34, 0x42, 0x4B, 0xBA, 0xB2, 
 0xB3, 0x3D, 0x28, 0xC5, 0x81, 0x49, 0xA9, 0xE5, 0x9F, 0x54, 
 0xAF, 0x78, 0xA5, 0xC7, 0xFF, 0x00, 0xD0, 0xF5, 0x6D, 0x3F, 
 0xBD, 0x82, 0x2E, 0x0A, 0xDC, 0x7B, 0x24, 0x5F, 0x92, 0x6E, 
 0x3C, 0x45, 0x51, 0x5A, 0xD4, 0x4B, 0xB9, 0x7E, 0x2D, 0xE7, 
 0xCB, 0xDB, 0xCD, 0xCF, 0x44, 0xDB, 0xEA, 0x70, 0x95, 0x5D, 
 0x3D, 0x8D, 0xDE, 0x9B, 0xA4, 0x9C, 0xB3, 0xA9, 0x38, 0x35, 
 0x18, 0xF7, 0x6B, 0x93, 0xAE, 0xF2, 0x4E, 0x4A, 0xBE, 0x35, 
 0xE6, 0x85, 0x93, 0x23, 0x7C, 0x3A, 0x5F, 0x43, 0x18, 0xF0, 
 0x8A, 0xF5, 0x18, 0x61, 0x35, 0xFC, 0xCA, 0xA5, 0xD8, 0xC1, 
 0x83, 0x07, 0x4E, 0x69, 0x4A, 0x2B, 0xE2, 0xD9, 0xA7, 0x2C, 
 0xEE, 0x54, 0xB7, 0x6F, 0xC1, 0x7E, 0x9B, 0x0D, 0x43, 0x74, 
 0x2A, 0xFA, 0x88, 0x36, 0xEA, 0xAA, 0xFE, 0xC3, 0xA7, 0x6D, 
 0xCD, 0x3E, 0xDA, 0xBD, 0x90, 0x38, 0xD7, 0x64, 0x64, 0xC6, 
 0x49, 0x42, 0x8A, 0x72, 0xFE, 0x96, 0x8D, 0x99, 0x23, 0xB6, 
 0xE6, 0x4C, 0xBD, 0xCB, 0x19, 0xB1, 0xE6, 0xB5, 0x2A, 0xB5, 
 0x12, 0xFC, 0x9E, 0x83, 0xD1, 0xE6, 0xA1, 0x85, 0xEC, 0xB7, 
 0x5C, 0xD1, 0xC5, 0xD5, 0x63, 0x52, 0xCF, 0x2F, 0x36, 0x74, 
 0xB1, 0x39, 0x63, 0xD1, 0xC2, 0x2B, 0xF5, 0x33, 0x7D, 0x39, 
 0x7E, 0x7E, 0xAA, 0xCF, 0x51, 0xCD, 0x2D, 0x56, 0x58, 0xE1, 
 0x83, 0xF8, 0xDE, 0xFF, 0x00, 0x66, 0xAC, 0x7A, 0x65, 0x8B, 
 0x48, 0xE9, 0x70, 0x43, 0x49, 0xA4, 0xE8, 0x94, 0x5C, 0xB9, 
 0xE4, 0xDF, 0x96, 0x35, 0xA3, 0x91, 0x98, 0xEF, 0x66, 0xF2, 
 0xE6, 0x80, 0x01, 0xD9, 0xE1, 0x21, 0x80, 0x80, 0x00, 0x00, 
 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 
 0x10, 0x00, 0x03, 0x28, 0x00, 0x43, 0x00, 0x34, 0xE9, 0x31, 
 0xFB, 0x91, 0x9A, 0xFA, 0x33, 0x1B, 0x7D, 0x33, 0x79, 0xC9, 
 0x7D, 0x18, 0xEF, 0xE3, 0xA7, 0xE5, 0xFF, 0x00, 0x4E, 0x3C, 
 0xB1, 0x4F, 0x49, 0xAB, 0x72, 0x8D, 0xF4, 0xF7, 0x2E, 0xF5, 
 0x1F, 0x9E, 0x96, 0xD6, 0xFC, 0x1D, 0x5C, 0xBA, 0x78, 0xE4, 
 0x6D, 0x35, 0xD8, 0xE5, 0xE7, 0xC6, 0xD6, 0x19, 0x63, 0x7C, 
 0xC5, 0x9C, 0xE3, 0xD3, 0xDF, 0xF8, 0xC5, 0xA0, 0x8B, 0x79, 
 0x94, 0xA3, 0xC1, 0xDA, 0xC4, 0x73, 0xF4, 0x58, 0xD4, 0x23, 
 0xB2, 0xDD, 0x9B, 0xA0, 0xF7, 0x15, 0x8E, 0x3D, 0x46, 0xDC, 
 0x46, 0x85, 0x13, 0x3E, 0x0E, 0xC6, 0xA8, 0x98, 0x75, 0x43, 
 0xA3, 0x72, 0x33, 0x85, 0x33, 0x52, 0x8D, 0xA2, 0x13, 0x85, 
 0x96, 0x25, 0x61, 0xC9, 0x85, 0x4B, 0x75, 0xC9, 0x18, 0xE0, 
 0x9F, 0x29, 0xD9, 0xB5, 0x42, 0xFB, 0x16, 0x46, 0x09, 0x1A, 
 0x35, 0x96, 0x38, 0xB2, 0x49, 0x6F, 0xB0, 0xD6, 0x99, 0x77, 
 0xB6, 0x6C, 0xD9, 0x11, 0x7C, 0x85, 0x95, 0x9F, 0xDB, 0x4B, 
 0xB0, 0xB2, 0x45, 0xA5, 0x48, 0xD1, 0xD3, 0x5B, 0xB4, 0x55, 
 0x93, 0xCB, 0x16, 0xE2, 0xEE, 0xA8, 0xC9, 0xF1, 0x85, 0x22, 
 0x98, 0x3F, 0x9A, 0x2D, 0x9E, 0xE5, 0x70, 0x5F, 0xCC, 0x32, 
 0xB3, 0xD3, 0x7E, 0x3F, 0x94, 0x0A, 0xF3, 0x2A, 0x89, 0x6E, 
 0x05, 0x68, 0x59, 0x57, 0xC6, 0x8A, 0xBB, 0xED, 0xCE, 0xBF, 
 0x99, 0xA2, 0x2F, 0x87, 0xE4, 0xCF, 0x35, 0x59, 0x0B, 0x71, 
 0x4A, 0x9D, 0x30, 0xCD, 0x8D, 0x11, 0x85, 0xA2, 0x2F, 0x4E, 
 0xA5, 0xBD, 0x51, 0x6E, 0x3A, 0x75, 0x7C, 0x16, 0x38, 0xF7, 
 0xEC, 0x5F, 0xA9, 0xAC, 0x92, 0xD3, 0x4A, 0xB6, 0x5F, 0xD8, 
 0xAA, 0x5A, 0x79, 0xBF, 0x34, 0x74, 0x3F, 0x28, 0x52, 0x56, 
 0xE8, 0x26, 0xB9, 0xF0, 0xD3, 0x28, 0xBD, 0xCB, 0xE3, 0x1A, 
 0xD9, 0x17, 0x74, 0x78, 0x25, 0x18, 0xA4, 0x41, 0x05, 0x0D, 
 0x88, 0xCD, 0x51, 0x7D, 0x14, 0xE5, 0x22, 0xC6, 0x5C, 0xBC, 
 0x18, 0xB2, 0xF2, 0xCD, 0x99, 0x5E, 0xC6, 0x2C, 0xBC, 0x88, 
 0xCF, 0x4E, 0x76, 0x6C, 0x5D, 0x5A, 0x94, 0xFC, 0x9D, 0x0D, 
 0x26, 0x25, 0x3C, 0xCB, 0xFE, 0x30, 0x32, 0xE4, 0x6A, 0x2D, 
 0xCB, 0xBF, 0x63, 0xA1, 0xA1, 0xC6, 0xE1, 0x85, 0x4A, 0x5B, 
 0x37, 0xB9, 0xAA, 0xCF, 0x11, 0xB2, 0x71, 0x49, 0xC6, 0x48, 
 0x5A, 0x89, 0xD6, 0x8E, 0x8B, 0x12, 0x72, 0xC6, 0xCA, 0xB5, 
 0xF1, 0xE8, 0xD3, 0xC7, 0x7E, 0x49, 0x1D, 0x3A, 0xB9, 0xCD, 
 0x73, 0x44, 0x31, 0x1D, 0xDE, 0x00, 0x00, 0x00, 0x00, 0x00, 
 0x02, 0x01, 0x88, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x18, 
 0x80, 0x81, 0x88, 0x00, 0xA1, 0x80, 0x80, 0x81, 0x9A, 0xFD, 
 0x39, 0xFF, 0x00, 0xE4, 0xA5, 0x75, 0x66, 0x42, 0xCD, 0x3C, 
 0xBA, 0x33, 0x45, 0xFD, 0x93, 0xA9, 0xB1, 0xBE, 0x2E, 0x75, 
 0x1D, 0x57, 0x0E, 0x99, 0x49, 0xF3, 0xB9, 0xCB, 0xF5, 0x04, 
 0xA3, 0x9A, 0xD7, 0x12, 0xD9, 0x9D, 0x95, 0x07, 0x2C, 0x09, 
 0xF9, 0x31, 0x6A, 0x34, 0xF1, 0xC9, 0x5D, 0x4B, 0x74, 0xCE, 
 0x2F, 0x65, 0x9B, 0x1C, 0xE8, 0x47, 0xA5, 0xD1, 0x7C, 0x3F, 
 0x52, 0x2B, 0xC9, 0xB6, 0xA2, 0x4B, 0xEC, 0x9C, 0x5F, 0xC9, 
 0x16, 0xB9, 0x46, 0xDC, 0x4E, 0x8D, 0x31, 0x76, 0x63, 0xC6, 
 0xF6, 0x34, 0x41, 0xEC, 0x61, 0xDA, 0x35, 0xC1, 0xEC, 0x26, 
 0xB7, 0x21, 0x09, 0x6C, 0x39, 0x3B, 0x5B, 0x14, 0xC4, 0x90, 
 0xE8, 0x8E, 0x3E, 0x0B, 0x11, 0x75, 0x33, 0x0B, 0xA7, 0x61, 
 0xA4, 0xA3, 0xF6, 0xC3, 0x6B, 0xA0, 0xA0, 0x81, 0xFD, 0x99, 
 0xB3, 0x33, 0x44, 0xB8, 0x33, 0x66, 0x7C, 0x91, 0xA8, 0xCE, 
 0xDE, 0xC2, 0xC6, 0xBE, 0x56, 0x0D, 0xDA, 0x2C, 0xC5, 0x1D, 
 0x82, 0xC6, 0xAC, 0x3C, 0x0F, 0x2A, 0xD8, 0x78, 0x93, 0x44, 
 0xB2, 0x2D, 0x8B, 0xFC, 0x4B, 0x7D, 0xB9, 0x99, 0x97, 0xCA, 
 0xC5, 0x17, 0xBA, 0x27, 0xA9, 0x54, 0xCA, 0x63, 0x2D, 0xC1, 
 0x7E, 0xB7, 0xE2, 0xDD, 0x2B, 0x2F, 0x5B, 0x2A, 0x66, 0x7C, 
 0x0E, 0xD2, 0x34, 0xF6, 0x21, 0x52, 0xA4, 0xF6, 0x23, 0x25, 
 0xBD, 0x02, 0x60, 0x8A, 0xCE, 0x22, 0xD6, 0xFC, 0x00, 0xE9, 
 0xDB, 0x13, 0x74, 0x45, 0xC2, 0x93, 0xD8, 0xA6, 0x6C, 0x9C, 
 0x99, 0x4C, 0xE5, 0xB1, 0x15, 0x9B, 0x2B, 0xAB, 0x31, 0xE5, 
 0xE4, 0xD3, 0x99, 0x99, 0x32, 0x3B, 0x66, 0xA3, 0x1D, 0x51, 
 0x87, 0x0A, 0xCC, 0xDA, 0x7D, 0x9A, 0x67, 0x56, 0x38, 0xED, 
 0x28, 0xAE, 0x11, 0x83, 0x41, 0xBB, 0xC8, 0xCE, 0xD2, 0xE9, 
 0x51, 0x8B, 0x4A, 0xAD, 0x21, 0x4F, 0xCC, 0xA3, 0x05, 0x1C, 
 0x2D, 0x1C, 0xDD, 0x7C, 0xEE, 0x30, 0x8F, 0xD1, 0xD1, 0xD4, 
 0x64, 0xE8, 0xD3, 0xB7, 0xDC, 0xE3, 0x67, 0x97, 0x54, 0xFF, 
 0x00, 0x1B, 0x1A, 0xE6, 0x7B, 0x63, 0xF5, 0xEB, 0xD2, 0xA1, 
 0x0C, 0x0E, 0xAF, 0x29, 0x00, 0x00, 0x08, 0x60, 0x00, 0x02, 
 0x1B, 0x10, 0x08, 0x00, 0x00, 0x60, 0x00, 0x00, 0x00, 0x05, 
 0x00, 0x00, 0x10, 0x03, 0x10, 0xC0, 0x07, 0x17, 0xBA, 0x10, 
 0x20, 0x47, 0xA2, 0xD3, 0xCB, 0xAB, 0x4D, 0x12, 0x8D, 0x44, 
 0x52, 0x69, 0xFD, 0x95, 0x7A, 0x7E, 0xA1, 0x4B, 0x0A, 0x87, 
 0x75, 0xB0, 0xF5, 0xB2, 0x97, 0x47, 0xC5, 0x5D, 0x1C, 0x5E, 
 0xFF, 0x00, 0xE6, 0xB9, 0x7A, 0x8F, 0x8E, 0xAA, 0x68, 0x69, 
 0xEE, 0x88, 0x6A, 0x67, 0xD5, 0x95, 0x4B, 0xCA, 0xDC, 0x71, 
 0xE1, 0x0A, 0xE3, 0x3E, 0xB5, 0xE3, 0x66, 0x88, 0xC8, 0xCD, 
 0x8B, 0xB1, 0x74, 0x4C, 0xBB, 0x45, 0xEA, 0x45, 0x91, 0x91, 
 0x99, 0x37, 0x7B, 0x16, 0xC5, 0xB2, 0x34, 0xBE, 0x2E, 0x8B, 
 0x13, 0x29, 0x8B, 0xB4, 0x59, 0x11, 0x0B, 0x13, 0x43, 0x12, 
 0x1A, 0xE4, 0xD3, 0x04, 0xF9, 0x32, 0xEA, 0x36, 0x89, 0xA9, 
 0xEC, 0x62, 0xD5, 0xE4, 0xF9, 0x24, 0x1A, 0x8A, 0x94, 0x4B, 
 0xF1, 0xA3, 0x32, 0xCA, 0x92, 0x25, 0x8B, 0x50, 0xAE, 0x88, 
 0xAE, 0x96, 0x3A, 0x63, 0xCB, 0x16, 0x91, 0x46, 0x2C, 0xC9, 
 0x13, 0xCB, 0xA8, 0xB8, 0xEE, 0xCD, 0x4B, 0xE9, 0x9C, 0xBA, 
 0xC7, 0xA9, 0x5E, 0x4A, 0x14, 0x36, 0xD8, 0x96, 0x7C, 0xEA, 
 0xE9, 0x10, 0x8C, 0xF6, 0x44, 0x6A, 0xB6, 0xE9, 0x55, 0xC5, 
 0x36, 0x6A, 0x46, 0x2D, 0x1E, 0x44, 0xE4, 0xE2, 0x6C, 0x23, 
 0x27, 0x41, 0x74, 0x0B, 0x82, 0x2C, 0xA0, 0x6D, 0x95, 0xCB, 
 0xB9, 0x36, 0xCA, 0xA4, 0xC8, 0xAA, 0xE4, 0xCA, 0xA6, 0xF6, 
 0x2C, 0x9E, 0xC5, 0x32, 0xDC, 0x8A, 0xA3, 0x29, 0x8B, 0x2C, 
 0xB7, 0x36, 0x66, 0xE0, 0xC1, 0x99, 0xF2, 0x6E, 0x38, 0xF7, 
 0x57, 0xE8, 0xE7, 0x58, 0xE5, 0x5C, 0xC9, 0x9D, 0x9C, 0x53, 
 0xE3, 0xAD, 0xD5, 0x23, 0x9D, 0xE9, 0x18, 0x14, 0xA3, 0xEE, 
 0x4B, 0xB7, 0x06, 0xBD, 0x5C, 0xAD, 0x54, 0x5D, 0x5E, 0xC1, 
 0xAE, 0x7D, 0x45, 0x5A, 0xBD, 0x4F, 0xB8, 0xDA, 0x8F, 0xE9, 
 0x8F, 0x7F, 0xB3, 0x05, 0xD9, 0x66, 0x59, 0x2F, 0xD1, 0x1E, 
 0x11, 0x59, 0xD3, 0x99, 0x8F, 0x3F, 0xEB, 0xD6, 0xD0, 0x00, 
 0x06, 0x9C, 0x80, 0x86, 0x20, 0x00, 0x00, 0x01, 0x00, 0x00, 
 0x08, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 
 0xC0, 0x43, 0x10, 0x10, 0x03, 0x10, 0xC0, 0xBB, 0x4F, 0x29, 
 0xC2, 0x5D, 0x58, 0xF9, 0x5C, 0xAF, 0x27, 0x4F, 0x14, 0xD6, 
 0x55, 0x73, 0x55, 0x67, 0x23, 0x1C, 0xFA, 0x25, 0x67, 0x43, 
 0x0C, 0xED, 0x26, 0x73, 0xEA, 0x3D, 0x3F, 0x97, 0x5B, 0x31, 
 0x8B, 0xD4, 0xB0, 0xAC, 0x59, 0x13, 0x8F, 0x0C, 0xAA, 0x0F, 
 0x64, 0x6F, 0xF5, 0x38, 0xB9, 0xE9, 0xBA, 0xBC, 0x1C, 0xDC, 
 0x72, 0xD8, 0xC9, 0xD7, 0xAA, 0xDD, 0x85, 0x7C, 0x4B, 0xD2, 
 0xD8, 0xCF, 0x83, 0xB1, 0xA6, 0x3C, 0x6C, 0x65, 0xD6, 0x24, 
 0x95, 0x12, 0x5C, 0x89, 0x12, 0xEE, 0x46, 0xA2, 0xC8, 0x32, 
 0xD8, 0xDD, 0x94, 0xC4, 0xB6, 0x3B, 0x85, 0x58, 0xB7, 0x0B, 
 0x4B, 0x61, 0x26, 0x0F, 0x73, 0x51, 0x03, 0x67, 0x1F, 0xD4, 
 0x73, 0xFB, 0x7A, 0x89, 0x23, 0xB0, 0xCE, 0x67, 0xA8, 0xE8, 
 0xDE, 0x67, 0xD7, 0x06, 0xAF, 0xEC, 0x0E, 0x16, 0xA3, 0xD4, 
 0xB2, 0xC2, 0x55, 0x08, 0x5A, 0xFB, 0x25, 0xA4, 0xF5, 0x58, 
 0xCE, 0x6A, 0x39, 0x63, 0xD0, 0xFC, 0xF6, 0x36, 0xAC, 0x4A, 
 0x3F, 0x1C, 0xF8, 0x57, 0xE4, 0xA7, 0x3F, 0xA6, 0xE2, 0xC9, 
 0x07, 0x2C, 0x49, 0x27, 0xE0, 0xAE, 0x75, 0xBA, 0x1A, 0xA4, 
 0x92, 0xDC, 0x9C, 0xB5, 0x1D, 0x51, 0xE4, 0xE1, 0xFB, 0x8F, 
 0x4F, 0x1F, 0x6E, 0x7D, 0x49, 0xA2, 0x2F, 0x57, 0x2C, 0x91, 
 0xE8, 0x8D, 0xDB, 0xF0, 0x31, 0x7C, 0xEB, 0x4E, 0xB3, 0xD4, 
 0xB1, 0xE2, 0x95, 0x2B, 0x94, 0xBE, 0x88, 0x69, 0xFD, 0x4D, 
 0x64, 0x74, 0xD3, 0x8F, 0xE4, 0x58, 0x7D, 0x32, 0x3D, 0x0E, 
 0x59, 0x9E, 0xFE, 0x0B, 0xFD, 0x9C, 0x10, 0x8D, 0x63, 0xC6, 
 0xDC, 0xBF, 0x05, 0xA9, 0x35, 0xD0, 0xD0, 0x66, 0x53, 0xD4, 
 0x45, 0x23, 0xAF, 0x67, 0x1B, 0xD3, 0x34, 0xB3, 0x86, 0x4F, 
 0x72, 0x6B, 0xA5, 0x76, 0x47, 0x61, 0x33, 0x0E, 0x91, 0x3B, 
 0xD8, 0x24, 0x24, 0xC4, 0xC0, 0x84, 0x9D, 0x15, 0xB7, 0xB9, 
 0x64, 0x8A, 0xDB, 0x20, 0xAA, 0x72, 0xF9, 0x6E, 0x42, 0x7B, 
 0x22, 0xC9, 0x24, 0xD9, 0x5C, 0xF6, 0x2A, 0x56, 0x6C, 0xFC, 
 0x1C, 0xEC, 0xCF, 0x73, 0x7E, 0xA2, 0x5B, 0x1C, 0xFC, 0x8E, 
 0xE4, 0xBF, 0x26, 0xA3, 0x8F, 0x6E, 0xBE, 0x8B, 0xF9, 0x7A, 
 0x48, 0xAF, 0xA3, 0x3E, 0xA7, 0x2B, 0x72, 0xA4, 0x59, 0x2C, 
 0xAB, 0x16, 0x9E, 0x2B, 0xE8, 0xC6, 0xA4, 0xE6, 0xDC, 0xDF, 
 0xEC, 0x6B, 0x98, 0xBD, 0xF5, 0x9C, 0xA4, 0x00, 0x07, 0x47, 
 0x94, 0x00, 0x00, 0x08, 0x60, 0x20, 0x00, 0x18, 0x80, 0x40, 
 0x00, 0x02, 0x01, 0x81, 0x40, 0x00, 0x04, 0x00, 0x00, 0x00, 
 0xC0, 0x40, 0x50, 0xC0, 0x40, 0x03, 0x01, 0x00, 0x01, 0xAB, 
 0x4D, 0x97, 0x74, 0x99, 0x98, 0x16, 0xDB, 0xAE, 0x4C, 0xD9, 
 0xAD, 0xF1, 0xD7, 0x8D, 0x74, 0xF3, 0xD6, 0x4C, 0x12, 0x5F, 
 0x47, 0x1B, 0x1B, 0xE5, 0x78, 0x36, 0xC7, 0x57, 0x51, 0xA9, 
 0xF2, 0x73, 0xD3, 0x7E, 0xEC, 0xB6, 0x69, 0x37, 0xB1, 0xCF, 
 0x1D, 0xBB, 0xEA, 0x5F, 0x71, 0xD0, 0xC1, 0x2D, 0x8D, 0x70, 
 0x6E, 0xFE, 0x8C, 0x18, 0x59, 0xAA, 0x12, 0xD8, 0xCD, 0x6F, 
 0x9A, 0xD2, 0x49, 0x14, 0xC6, 0x6C, 0xB2, 0x2F, 0x72, 0x35, 
 0x16, 0xC4, 0x9C, 0x79, 0x2B, 0x8B, 0xBE, 0x09, 0xA7, 0x44, 
 0x6E, 0x26, 0xE5, 0x48, 0x14, 0xAC, 0x56, 0x99, 0x4F, 0x5A, 
 0x53, 0xA4, 0x58, 0x2E, 0x73, 0xA2, 0x8C, 0x93, 0xB7, 0x48, 
 0x53, 0x94, 0xAD, 0x2F, 0x25, 0x72, 0x95, 0xC9, 0xC6, 0xB7, 
 0x2E, 0x33, 0x6A, 0x9C, 0xB0, 0x6E, 0x5B, 0xF0, 0x4B, 0x16, 
 0x25, 0x1B, 0xBE, 0x0B, 0x1C, 0x5B, 0xAD, 0xAD, 0x93, 0x50, 
 0xFA, 0x2B, 0x0C, 0xF9, 0xB4, 0xD8, 0xB2, 0x35, 0xD7, 0x04, 
 0xFC, 0x10, 0xC7, 0xA4, 0xC3, 0x07, 0x70, 0x82, 0x52, 0x36, 
 0x28, 0xA9, 0xCB, 0xC5, 0x77, 0x22, 0xE0, 0xFB, 0x20, 0xB8, 
 0xC7, 0x9B, 0x13, 0xB5, 0x65, 0x98, 0x62, 0xA3, 0x15, 0xB1, 
 0x39, 0xA7, 0x7B, 0xEE, 0x24, 0xDA, 0x5C, 0x71, 0xE4, 0xA9, 
 0xF2, 0xB4, 0xC2, 0x5C, 0x26, 0x5C, 0x99, 0x8A, 0x33, 0xDD, 
 0x53, 0x2F, 0x8C, 0xEF, 0x64, 0x66, 0xC6, 0xE7, 0x4B, 0xD4, 
 0xB6, 0xE0, 0x95, 0xED, 0xB9, 0x54, 0x65, 0x4F, 0x72, 0x5D, 
 0x44, 0x6B, 0x74, 0x4D, 0x95, 0xC9, 0x92, 0x64, 0x24, 0x46, 
 0x50, 0xFC, 0x95, 0x64, 0x75, 0x64, 0xDB, 0xA4, 0x51, 0x9E, 
 0x5C, 0x95, 0x9B, 0x59, 0x75, 0x12, 0xB6, 0x62, 0x9B, 0x7D, 
 0x6B, 0xA5, 0x36, 0xEF, 0x84, 0x68, 0xC8, 0xED, 0xB2, 0x18, 
 0x57, 0xCE, 0x4F, 0xC1, 0xB9, 0x1C, 0x3A, 0xBF, 0xD4, 0xDF, 
 0x5E, 0x5A, 0x73, 0xD9, 0x78, 0x26, 0x00, 0x75, 0x93, 0x1C, 
 0xAD, 0xB7, 0xE8, 0x00, 0x00, 0x80, 0x00, 0x45, 0x0C, 0x40, 
 0x04, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 
 0x00, 0x04, 0x30, 0x02, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 
 0x00, 0x00, 0x06, 0x20, 0x20, 0x65, 0x79, 0x97, 0xC5, 0x3F, 
 0x04, 0xC5, 0x3D, 0xE2, 0xD0, 0x54, 0xF1, 0x3B, 0x48, 0xD3, 
 0x07, 0x5C, 0xF2, 0x61, 0xD3, 0x4B, 0xC9, 0xB1, 0x55, 0x5A, 
 0x38, 0xD7, 0xA2, 0x56, 0x88, 0x32, 0xC8, 0xB3, 0x3C, 0x64, 
 0x5D, 0x0D, 0xCC, 0xB7, 0x2A, 0xE4, 0xC9, 0x75, 0x59, 0x18, 
 0xA2, 0x4F, 0x64, 0x47, 0x43, 0x8E, 0xE5, 0x52, 0xB5, 0x95, 
 0xA6, 0xAB, 0x62, 0x71, 0x9A, 0x4E, 0xD3, 0x0D, 0x44, 0xE3, 
 0x34, 0xA4, 0xB9, 0x48, 0xD4, 0x66, 0xD5, 0x79, 0xF8, 0x83, 
 0xF0, 0x11, 0x85, 0xD3, 0xE7, 0x72, 0xB9, 0xEA, 0x21, 0xED, 
 0xAD, 0xD3, 0xA2, 0x97, 0xEA, 0x11, 0x8F, 0xE9, 0x45, 0x33, 
 0x5B, 0xD4, 0x28, 0xB2, 0x09, 0x53, 0x39, 0x0F, 0xD4, 0x1C, 
 0x9E, 0xCC, 0x94, 0x35, 0xD3, 0x8B, 0xD9, 0xA6, 0x4C, 0x6A, 
 0x72, 0xEA, 0xFB, 0x5D, 0xD3, 0x1F, 0xB7, 0xB1, 0x8F, 0x1F, 
 0xA9, 0xC7, 0xA7, 0xE5, 0x1D, 0xCA, 0xF2, 0x7A, 0x93, 0x96, 
 0xD1, 0xD8, 0x2F, 0x8B, 0x54, 0xF1, 0xAD, 0xCA, 0xA5, 0x8D, 
 0xAD, 0xFB, 0x99, 0x56, 0xB2, 0x7D, 0xD9, 0x25, 0xAF, 0x5C, 
 0x4B, 0xFB, 0x86, 0x6F, 0x29, 0xD3, 0x8A, 0xEC, 0x59, 0x8E, 
 0x69, 0x35, 0xDE, 0xCA, 0x56, 0x68, 0x4D, 0xDA, 0x90, 0xD4, 
 0x93, 0x96, 0xCC, 0xAE, 0x76, 0x34, 0x36, 0xD3, 0x6E, 0x84, 
 0xB2, 0x36, 0xF6, 0x2B, 0x73, 0xEC, 0xB9, 0x61, 0xD7, 0xD9, 
 0x05, 0x95, 0xA2, 0xED, 0x72, 0x42, 0x6E, 0x81, 0x3B, 0x4A, 
 0xF9, 0x23, 0x37, 0xB1, 0x96, 0xFF, 0x00, 0x8A, 0xE5, 0x23, 
 0x2E, 0x69, 0x17, 0xE4, 0x74, 0xB6, 0x32, 0x65, 0xDE, 0x46, 
 0xA3, 0x97, 0x4A, 0x7B, 0x36, 0x18, 0x17, 0xC5, 0xBF, 0x2C, 
 0x59, 0x5D, 0x45, 0x92, 0xC6, 0xBA, 0x60, 0x91, 0xBE, 0x5C, 
 0x7B, 0xAB, 0x00, 0x40, 0x6D, 0xCC, 0x00, 0x00, 0x00, 0x00, 
 0x00, 0x00, 0x00, 0x00, 0x86, 0x00, 0x20, 0x00, 0x01, 0x00, 
 0x01, 0x43, 0x01, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x01, 0x58, 0x59, 
 0x16, 0xC0, 0xAF, 0x1B, 0xE8, 0xCC, 0xD7, 0x6E, 0x4D, 0xD8, 
 0xDD, 0xAA, 0x30, 0x65, 0xD9, 0xA9, 0xF8, 0x35, 0x61, 0x9D, 
 0xC5, 0x1C, 0xFA, 0x9E, 0xDD, 0xB8, 0xBE, 0x9A, 0xA2, 0xE9, 
 0x96, 0x41, 0xF4, 0xB2, 0x98, 0xBB, 0x2C, 0x83, 0x32, 0xE9, 
 0xAD, 0x50, 0x91, 0x39, 0x6F, 0x54, 0x53, 0x07, 0xB1, 0x6C, 
 0x5E, 0xF6, 0xCC, 0xB7, 0xAA, 0xE5, 0xFE, 0x4C, 0xF3, 0x59, 
 0x1B, 0xA4, 0xE8, 0xDB, 0xD3, 0x16, 0xF6, 0x61, 0xED, 0x2A, 
 0xD8, 0x35, 0xCB, 0x93, 0x3F, 0x4F, 0xC9, 0x39, 0x39, 0x7B, 
 0xAD, 0x37, 0xDA, 0x88, 0x47, 0xD3, 0x1F, 0xF5, 0x64, 0x93, 
 0x3B, 0x0E, 0x1B, 0x14, 0xB8, 0xB5, 0xC1, 0x75, 0xBF, 0x4C, 
 0x51, 0xF4, 0xCC, 0x29, 0xEF, 0x6F, 0xED, 0xB2, 0xCF, 0xFE, 
 0x2E, 0x0D, 0x5A, 0x6D, 0x3F, 0xC9, 0xA1, 0x4F, 0xA5, 0xD5, 
 0x59, 0x62, 0xCC, 0x97, 0x62, 0xEA, 0xFA, 0x60, 0x97, 0xA6, 
 0xE4, 0x5F, 0xA7, 0x23, 0xAF, 0xB4, 0x10, 0xF4, 0xD9, 0x3F, 
 0xD5, 0x92, 0x5F, 0xF4, 0x74, 0x1E, 0x7E, 0x2D, 0x2D, 0xC5, 
 0xFC, 0x42, 0xBD, 0x90, 0xD8, 0xAC, 0x6F, 0xD3, 0x20, 0x97, 
 0xCA, 0x52, 0xFE, 0xE5, 0x19, 0x3D, 0x3A, 0x1D, 0xA7, 0x25, 
 0xFB, 0x9D, 0x19, 0xE6, 0xB5, 0xBA, 0x29, 0x94, 0x9B, 0xEC, 
 0x35, 0x2E, 0x39, 0xDF, 0xC0, 0xE7, 0x4F, 0xE1, 0x95, 0x35, 
 0xF6, 0x5B, 0x0D, 0x3E, 0xA7, 0x1E, 0xED, 0xA9, 0x2F, 0xA3, 
 0x74, 0x22, 0xF9, 0x65, 0xF0, 0xC6, 0xA4, 0x4B, 0x58, 0xC6, 
 0x3C, 0x73, 0x6F, 0x69, 0x22, 0xEE, 0x63, 0xB1, 0x6C, 0xB1, 
 0x25, 0xD8, 0x14, 0x03, 0x16, 0x23, 0x14, 0xD2, 0x0C, 0x9C, 
 0x12, 0x97, 0x25, 0x59, 0x25, 0xE4, 0x16, 0xE2, 0x8C, 0xB2, 
 0xAB, 0x32, 0xCD, 0x97, 0x65, 0x7B, 0x99, 0x32, 0xCA, 0xB9, 
 0x2C, 0x72, 0xB5, 0x09, 0xBE, 0xA9, 0xA8, 0x97, 0x26, 0x67, 
 0xC5, 0xBB, 0x72, 0x7F, 0xB1, 0x72, 0x67, 0x5E, 0x63, 0x87, 
 0x57, 0x6A, 0x76, 0x32, 0x08, 0x95, 0x95, 0x0C, 0x04, 0x30, 
 0x00, 0x00, 0x28, 0x00, 0x40, 0x40, 0xC4, 0x00, 0x50, 0x08, 
 0x60, 0x40, 0x80, 0x00, 0xA1, 0x80, 0x80, 0x06, 0x02, 0x18, 
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x01, 0xB0, 
 0x13, 0x01, 0x36, 0x26, 0xC1, 0xB2, 0x2D, 0x90, 0x29, 0x6E, 
 0xA8, 0x8E, 0x9F, 0x23, 0x8C, 0x9C, 0x5F, 0x28, 0x1B, 0x2A, 
 0xC8, 0xFA, 0x5A, 0x92, 0xE4, 0x9D, 0x4F, 0x4B, 0xCD, 0xCA, 
 0xE9, 0xE3, 0x9F, 0x82, 0xC8, 0xB3, 0x0E, 0x0C, 0xB7, 0x5B, 
 0x9A, 0xA3, 0x2F, 0xB3, 0x9B, 0xB6, 0xB6, 0x63, 0x92, 0x2D, 
 0xE5, 0x6C, 0x64, 0xC7, 0x2D, 0x8B, 0xE3, 0x23, 0x2E, 0x91, 
 0x6C, 0x25, 0x52, 0x2D, 0x8C, 0xB7, 0x6A, 0xCA, 0x6E, 0xB7, 
 0x48, 0x23, 0x27, 0xC9, 0x1A, 0x97, 0x17, 0x6F, 0xDC, 0x83, 
 0x5B, 0x59, 0x24, 0xEF, 0xF2, 0x35, 0xC6, 0xE4, 0x6F, 0x75, 
 0x9A, 0x6E, 0x9E, 0xE5, 0x32, 0x9D, 0x3D, 0xD6, 0xE6, 0xC9, 
 0xE3, 0xEA, 0xE1, 0x59, 0x46, 0x4C, 0x12, 0x7B, 0xF4, 0x96, 
 0x25, 0x67, 0x96, 0x6D, 0x95, 0x82, 0xC8, 0xA5, 0xC2, 0x26, 
 0xF0, 0x49, 0xEC, 0xD0, 0x47, 0x4F, 0x24, 0xF8, 0x34, 0x9E, 
 0xCB, 0xAA, 0xF7, 0xDC, 0xB6, 0x11, 0xBE, 0xC4, 0xA1, 0x85, 
 0xAE, 0x4B, 0xA3, 0x0D, 0x8C, 0xAC, 0x88, 0x46, 0x34, 0xCB, 
 0xA1, 0x25, 0x14, 0x45, 0xFC, 0x77, 0x62, 0x6D, 0x6C, 0xC8, 
 0xA9, 0xCE, 0x69, 0xA7, 0x45, 0x6E, 0x54, 0xD7, 0x82, 0x12, 
 0x9D, 0xBD, 0x88, 0xCA, 0x6E, 0xD5, 0x3E, 0x0A, 0xC5, 0x4A, 
 0x53, 0xFD, 0x8C, 0xB9, 0x67, 0x6F, 0x62, 0x79, 0x27, 0x7D, 
 0xCC, 0xB3, 0x9D, 0x3D, 0xD9, 0xA8, 0xC7, 0x55, 0x1C, 0xB2, 
 0xA3, 0x06, 0x69, 0xB9, 0x4A, 0x97, 0x72, 0xED, 0x4E, 0x5A, 
 0x8B, 0x32, 0xC1, 0xDC, 0xBA, 0x99, 0xA8, 0xE5, 0x6B, 0x4C, 
 0x76, 0x49, 0x22, 0x69, 0x95, 0x45, 0x93, 0x4C, 0xE8, 0xE4, 
 0xB1, 0x31, 0xA2, 0x09, 0x92, 0x40, 0x4F, 0xB0, 0x58, 0x80, 
 0xA1, 0x80, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 
 0x82, 0xC8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x28, 
 0x60, 0x00, 0x00, 0x00, 0x00, 0x02, 0x01, 0x30, 0x02, 0x2D, 
 0x8D, 0x91, 0x6C, 0x81, 0x36, 0x41, 0xB1, 0xB6, 0x41, 0xB0, 
 0x84, 0xD9, 0x5C, 0xF7, 0x44, 0x9B, 0x23, 0xCA, 0x64, 0xBF, 
 0x16, 0x7D, 0x47, 0x16, 0x47, 0x8E, 0x75, 0x7B, 0x1B, 0xF1, 
 0x65, 0xB5, 0xE4, 0xE6, 0x4D, 0x13, 0xD3, 0xE7, 0xE8, 0x74, 
 0xD9, 0x87, 0x59, 0x5D, 0x9C, 0x73, 0x34, 0xC3, 0x76, 0x8E, 
 0x7E, 0x2C, 0xDD, 0x55, 0x4C, 0xD3, 0x8F, 0x26, 0xE6, 0x2B, 
 0xA4, 0xAD, 0x8F, 0x75, 0x4C, 0x9A, 0xA5, 0x1F, 0xA2, 0xA8, 
 0x4E, 0xDE, 0xFC, 0x86, 0x49, 0x5A, 0xE1, 0x8C, 0x6B, 0x57, 
 0xC6, 0xAE, 0xAC, 0xB2, 0x29, 0x2E, 0x0C, 0xB0, 0x7D, 0x4D, 
 0x2E, 0xE6, 0x9C, 0x72, 0xAD, 0xBF, 0xB9, 0x31, 0xB9, 0x56, 
 0x47, 0x76, 0xE8, 0x9A, 0xA7, 0xB7, 0x72, 0x10, 0xDA, 0x4D, 
 0x93, 0x6E, 0xE3, 0x7C, 0x05, 0x29, 0x45, 0x73, 0x44, 0x5C, 
 0x52, 0xEC, 0xAC, 0x93, 0x9F, 0xC6, 0x9F, 0xED, 0x6C, 0x8C, 
 0x65, 0x7C, 0xEE, 0x50, 0xDD, 0x77, 0x21, 0x57, 0xC7, 0x03, 
 0xE5, 0x3B, 0x04, 0xD2, 0x7C, 0xEC, 0x4C, 0x35, 0x44, 0xE1, 
 0x27, 0xB1, 0x5D, 0xB4, 0xE9, 0xF0, 0x68, 0xCB, 0x25, 0x16, 
 0xEB, 0x93, 0x2E, 0x49, 0x51, 0x64, 0x66, 0xD3, 0x6D, 0x51, 
 0x09, 0xFC, 0x13, 0x13, 0x6D, 0x2B, 0x6F, 0x92, 0xA9, 0xCF, 
 0x7D, 0xD8, 0x62, 0xD2, 0x9C, 0xB6, 0xB6, 0x63, 0xC9, 0x3E, 
 0x5B, 0x2C, 0xCB, 0x99, 0x56, 0xEC, 0xE7, 0x6A, 0x35, 0x17, 
 0xB2, 0x35, 0x18, 0xB5, 0x0C, 0xD9, 0x3D, 0xC9, 0xD2, 0xE1, 
 0x0E, 0x25, 0x78, 0xD6, 0xE5, 0xFD, 0x15, 0x06, 0xCB, 0xFD, 
 0x73, 0x4A, 0x32, 0x2C, 0x4C, 0xCE, 0x99, 0x6C, 0x59, 0xD1, 
 0xCD, 0x6A, 0x64, 0xD3, 0x2A, 0x4C, 0xB1, 0x01, 0x34, 0xC6, 
 0x45, 0x12, 0x2A, 0x98, 0x08, 0x60, 0x00, 0x00, 0x40, 0x86, 
 0x20, 0x28, 0x00, 0x00, 0x80, 0x00, 0x02, 0x84, 0x31, 0x0C, 
 0x80, 0x00, 0x02, 0x80, 0x62, 0x00, 0x18, 0x08, 0x00, 0x19, 
 0x16, 0xC6, 0xC4, 0x02, 0x64, 0x1B, 0x24, 0xC8, 0x32, 0x21, 
 0x32, 0xB9, 0x32, 0x4D, 0x95, 0xC9, 0x81, 0x16, 0xCB, 0x34, 
 0xF1, 0xEA, 0x6D, 0x15, 0x36, 0x5F, 0xA1, 0xDF, 0x23, 0x27, 
 0x5F, 0x1A, 0xE7, 0xEA, 0xAC, 0xF8, 0x9C, 0x59, 0x91, 0xEC, 
 0xCE, 0xDE, 0x7C, 0x0A, 0x6B, 0x83, 0x95, 0xA9, 0xC2, 0xE0, 
 0xFE, 0x8E, 0x71, 0xD3, 0xA9, 0x87, 0x87, 0x33, 0x83, 0xAE, 
 0xC6, 0xE8, 0x6A, 0x6D, 0x7D, 0x9C, 0xA5, 0xE0, 0x9C, 0x32, 
 0x38, 0x3F, 0xA2, 0xD8, 0x93, 0xA7, 0x6B, 0x0E, 0xA5, 0xF7, 
 0x66, 0xA5, 0x96, 0xF7, 0x38, 0x51, 0xD4, 0x53, 0x37, 0xE0, 
 0xD4, 0x29, 0x46, 0x93, 0x26, 0x35, 0x3A, 0x6F, 0x8C, 0x95, 
 0xDA, 0x65, 0xB8, 0xF2, 0xBB, 0x31, 0xC2, 0x75, 0xBB, 0xEF, 
 0xC1, 0x64, 0x66, 0xBB, 0xF7, 0x18, 0xDC, 0xAE, 0x84, 0x33, 
 0x71, 0xB5, 0xA2, 0xE5, 0x91, 0x38, 0xD5, 0x1C, 0xF8, 0xCD, 
 0xAD, 0x97, 0x04, 0xD6, 0x56, 0x4C, 0x74, 0x95, 0xA9, 0xB4, 
 0xDD, 0x0E, 0x34, 0x9E, 0xC8, 0xCD, 0xD7, 0xBA, 0x64, 0x96, 
 0x4A, 0x44, 0x5D, 0x5F, 0x39, 0xA8, 0x2D, 0xB9, 0x29, 0x79, 
 0x6D, 0xF9, 0x2A, 0x9E, 0x67, 0x65, 0x52, 0xC9, 0x4B, 0x9F, 
 0xEC, 0x5C, 0x66, 0xD4, 0xE5, 0x36, 0xDB, 0xEE, 0x8A, 0xE5, 
 0x35, 0xD4, 0xEC, 0xAD, 0xE4, 0xDB, 0x77, 0x6C, 0xAA, 0x52, 
 0xAB, 0xB2, 0xE3, 0x1A, 0xBB, 0x26, 0x45, 0x18, 0xA6, 0xD9, 
 0x87, 0x36, 0xA5, 0x24, 0xF7, 0xDC, 0x86, 0xA7, 0x50, 0xA2, 
 0xA8, 0xE7, 0x64, 0xC8, 0xE6, 0xDB, 0xBD, 0x8B, 0x23, 0x17, 
 0xA5, 0xB9, 0xB5, 0x17, 0x65, 0x0A, 0xE5, 0x2B, 0x64, 0x2E, 
 0xCB, 0xF0, 0x63, 0x73, 0x92, 0x49, 0x06, 0x3E, 0xAE, 0xD3, 
 0xE2, 0xEA, 0x66, 0x9D, 0x44, 0x3A, 0x30, 0x32, 0xFD, 0x3E, 
 0x0E, 0x98, 0xAD, 0x8A, 0xF5, 0xFB, 0x62, 0x64, 0x9F, 0x5A, 
 0xCC, 0x8C, 0x09, 0x96, 0x45, 0x94, 0xA6, 0x4E, 0x2C, 0xEA, 
 0xE2, 0xBE, 0x2C, 0xB1, 0x32, 0x98, 0xB2, 0xC4, 0xC0, 0xB5, 
 0x12, 0x4C, 0xAD, 0x32, 0x49, 0x81, 0x31, 0x91, 0x43, 0x0A, 
 0x62, 0x1F, 0x61, 0x00, 0xC4, 0x02, 0x28, 0x62, 0x00, 0x22, 
 0x00, 0x00, 0x28, 0x00, 0x00, 0x28, 0x18, 0x86, 0x00, 0x00, 
 0x00, 0x00, 0x02, 0x60, 0x26, 0x26, 0x36, 0x45, 0x80, 0x9B, 
 0x20, 0xD9, 0x26, 0x41, 0xB2, 0x22, 0x12, 0x65, 0x72, 0x64, 
 0xE4, 0xCA, 0xDB, 0x02, 0x2D, 0x9A, 0x7D, 0x3B, 0x7C, 0xAF, 
 0xF0, 0x64, 0x91, 0xB3, 0xD3, 0x17, 0xCE, 0x4C, 0x9D, 0x7C, 
 0x6B, 0x8F, 0xFA, 0x74, 0xEA, 0xD7, 0xE0, 0xCF, 0xA9, 0xD3, 
 0x29, 0xC5, 0xB4, 0x8D, 0x51, 0x43, 0x69, 0xF1, 0xD8, 0xE5, 
 0x1E, 0x8B, 0x1E, 0x7B, 0x51, 0xA7, 0x96, 0x29, 0x5D, 0x6C, 
 0x54, 0x9A, 0x7C, 0x9D, 0xED, 0x46, 0x99, 0x64, 0x89, 0xC9, 
 0xD4, 0x69, 0x5C, 0x1B, 0x71, 0x46, 0xA5, 0x72, 0xB3, 0x14, 
 0xF4, 0xDF, 0x0E, 0x82, 0x19, 0x65, 0x86, 0x7B, 0xF0, 0x46, 
 0xDA, 0x7B, 0xEC, 0x39, 0x54, 0xD5, 0x3F, 0xEE, 0x54, 0x74, 
 0xB0, 0x6A, 0xA3, 0x25, 0xCE, 0xE5, 0xDE, 0xF5, 0x3D, 0x8E, 
 0x0A, 0x94, 0xF1, 0x4B, 0xE2, 0xCB, 0xF1, 0xEB, 0x5F, 0x13, 
 0xE7, 0xC8, 0xC5, 0xF2, 0x77, 0x23, 0x9B, 0x6D, 0x9F, 0x3E, 
 0x49, 0xC7, 0x37, 0x83, 0x91, 0x0D, 0x5C, 0x5D, 0x6E, 0x5C, 
 0xB5, 0x51, 0xBE, 0x49, 0x8D, 0xCE, 0x9D, 0x58, 0xE4, 0xD8, 
 0x25, 0x9A, 0x95, 0x79, 0x39, 0xEB, 0x56, 0x92, 0xAB, 0x21, 
 0x2D, 0x5A, 0xF2, 0x31, 0x7C, 0x9B, 0xA5, 0x95, 0x5E, 0xEC, 
 0x8C, 0xF2, 0xEF, 0xB6, 0xE7, 0x36, 0x5A, 0xBF, 0x2E, 0x8A, 
 0xDE, 0xB5, 0x2D, 0x9B, 0xB4, 0x5C, 0x66, 0xF4, 0xE8, 0x3C, 
 0xD1, 0x8E, 0xEC, 0xC9, 0x9F, 0x59, 0xB3, 0xA6, 0x62, 0xC9, 
 0xAA, 0x94, 0xF8, 0xBA, 0x20, 0x95, 0xEF, 0x20, 0xCE, 0xA7, 
 0x29, 0xBC, 0x8E, 0xDB, 0xD8, 0x84, 0x9D, 0xEC, 0x85, 0x29, 
 0x5E, 0xCB, 0x82, 0xCC, 0x18, 0x25, 0x96, 0x49, 0x24, 0x19, 
 0x3C, 0x38, 0x9E, 0x49, 0x52, 0x3A, 0xFA, 0x5D, 0x2A, 0x82, 
 0xBA, 0x27, 0xA4, 0xD1, 0xAC, 0x50, 0x4D, 0xAD, 0xCD, 0x91, 
 0x82, 0x48, 0xCD, 0xAE, 0x9C, 0xF2, 0x8A, 0x49, 0x23, 0x0F, 
 0xA8, 0xED, 0x81, 0xBF, 0x26, 0xF6, 0xAD, 0x98, 0x3D, 0x53, 
 0xFD, 0x9F, 0xDC, 0x4F, 0xAB, 0xD7, 0xC7, 0x2E, 0x2C, 0xB1, 
 0x32, 0x98, 0x96, 0x44, 0xEA, 0xF3, 0x2E, 0x8B, 0x2C, 0x4C, 
 0xA6, 0x25, 0xB1, 0x0A, 0xB1, 0x32, 0x68, 0xAD, 0x13, 0x4C, 
 0x09, 0xA1, 0xA2, 0x28, 0x90, 0x0C, 0x00, 0x02, 0x80, 0x10, 
 0x00, 0x00, 0x08, 0x21, 0x80, 0x80, 0xAA, 0x60, 0x00, 0x03, 
 0x01, 0x00, 0x0C, 0x00, 0x40, 0x31, 0x0C, 0x40, 0x22, 0x2C, 
 0x6C, 0xAB, 0x2C, 0xD4, 0x53, 0xB0, 0x86, 0xCA, 0xE4, 0xCA, 
 0x1E, 0xAA, 0xF8, 0x2B, 0xC9, 0x99, 0xBB, 0xAB, 0x2E, 0x1A, 
 0xBE, 0x52, 0x5E, 0x4A, 0xDC, 0x97, 0x93, 0x2C, 0xA6, 0xEE, 
 0xDB, 0x3B, 0xFF, 0x00, 0xE9, 0x9F, 0x44, 0x5E, 0xA9, 0x93, 
 0xDE, 0xCE, 0xBF, 0x91, 0x07, 0x55, 0xFF, 0x00, 0x26, 0x4F, 
 0x88, 0x8F, 0xA4, 0xFA, 0x1E, 0x7F, 0x53, 0x6A, 0x7F, 0xED, 
 0xE1, 0x4F, 0x79, 0xBF, 0xFE, 0x8E, 0x9E, 0xB7, 0x47, 0xA3, 
 0xD1, 0x2C, 0x78, 0x74, 0x9F, 0x29, 0x2F, 0xD7, 0x27, 0xCB, 
 0x67, 0x6F, 0xD5, 0x3F, 0xF1, 0xB4, 0x0B, 0x16, 0x99, 0x28, 
 0x71, 0x14, 0x97, 0x63, 0xCF, 0xE6, 0x8F, 0x4B, 0x51, 0xE6, 
 0x97, 0x27, 0x3E, 0xAF, 0xF1, 0xD7, 0x8E, 0x7F, 0xA7, 0x0D, 
 0xD1, 0x34, 0xBA, 0x88, 0xC3, 0xB3, 0x26, 0xD1, 0xCD, 0xE8, 
 0x55, 0x25, 0x7C, 0xF6, 0x33, 0xE5, 0xC4, 0xA4, 0x9D, 0x1A, 
 0xE4, 0xBA, 0x93, 0xAD, 0x99, 0x44, 0x95, 0xDA, 0xEE, 0x56, 
 0x6C, 0x73, 0x33, 0xE8, 0xD4, 0x95, 0xAE, 0x4E, 0x7E, 0x4C, 
 0x73, 0xC4, 0xE9, 0xAD, 0x8F, 0x40, 0xE3, 0x7C, 0xA2, 0xB9, 
 0xE1, 0x8C, 0xD5, 0x49, 0x23, 0x5A, 0xC5, 0xE5, 0xC0, 0x75, 
 0x24, 0x41, 0xE3, 0xBE, 0x0E, 0x9E, 0x6F, 0x4C, 0xBB, 0x78, 
 0xF6, 0x31, 0xCF, 0x4D, 0x9B, 0x1F, 0x31, 0x6D, 0x17, 0x59, 
 0xB1, 0x9D, 0x63, 0x7D, 0x98, 0xFA, 0x66, 0x89, 0xB6, 0xE0, 
 0xFE, 0x51, 0x68, 0x5E, 0xEC, 0x46, 0xA6, 0x23, 0xD5, 0x35, 
 0xE4, 0x4E, 0x53, 0x7E, 0x49, 0xFB, 0xB1, 0x17, 0xBA, 0xBC, 
 0x14, 0x43, 0xE6, 0xFC, 0x92, 0x58, 0xDF, 0x76, 0x0F, 0x2B, 
 0xED, 0xB1, 0x17, 0x26, 0xC2, 0x27, 0x71, 0x8A, 0xDB, 0x70, 
 0xB7, 0x22, 0x31, 0x8B, 0x6C, 0xD7, 0xA7, 0xD2, 0xCA, 0x6F, 
 0x75, 0xB1, 0x17, 0xEA, 0x18, 0x30, 0x3C, 0xB2, 0x54, 0x8E, 
 0xE6, 0x8B, 0x4B, 0x1C, 0x51, 0xB6, 0xB7, 0x16, 0x8F, 0x4D, 
 0x18, 0x56, 0xC7, 0x46, 0x18, 0x92, 0x56, 0x66, 0xD7, 0x4E, 
 0x79, 0x46, 0x38, 0xE9, 0x5C, 0x84, 0xF7, 0x7F, 0x45, 0xB2, 
 0x7F, 0x1D, 0xF6, 0x21, 0xCF, 0x3C, 0x11, 0xB4, 0x1A, 0xA4, 
 0x57, 0x8B, 0x26, 0x3C, 0x7A, 0x85, 0x2C, 0xD0, 0x53, 0xC7, 
 0x55, 0x24, 0xD5, 0xEC, 0x59, 0x2D, 0xFF, 0x00, 0x05, 0x58, 
 0xD5, 0xEA, 0x15, 0xF0, 0x23, 0x37, 0xD9, 0x7A, 0xCF, 0xA1, 
 0xE3, 0x8E, 0x15, 0xAC, 0xD0, 0x6F, 0x8A, 0x4A, 0xDC, 0x57, 
 0x63, 0x82, 0xB6, 0x3D, 0xD7, 0xA5, 0xB5, 0xED, 0x4F, 0x49, 
 0x2D, 0xD7, 0x31, 0xBF, 0x1E, 0x0F, 0x3D, 0xEB, 0x9E, 0x90, 
 0xF4, 0xB9, 0x1E, 0x6C, 0x29, 0xBC, 0x6D, 0xEE, 0xBC, 0x1D, 
 0xB9, 0xBB, 0x35, 0xC3, 0xAE, 0x72, 0xB9, 0x31, 0x2C, 0x8B, 
 0x28, 0x59, 0x12, 0xE5, 0x92, 0x86, 0x68, 0xD9, 0x59, 0x69, 
 0x44, 0xD1, 0x54, 0x26, 0x9F, 0x0C, 0xB1, 0x30, 0x2C, 0x43, 
 0x44, 0x50, 0xD0, 0x54, 0x86, 0x20, 0x20, 0x00, 0x00, 0xA0, 
 0x10, 0x00, 0x40, 0x00, 0x04, 0x53, 0x01, 0x0C, 0xA0, 0x00, 
 0x00, 0x00, 0x00, 0xB0, 0x01, 0x37, 0x48, 0x86, 0x5C, 0xB1, 
 0xC6, 0xB7, 0x66, 0x2C, 0xBA, 0xED, 0x9A, 0x82, 0x09, 0xAD, 
 0x79, 0x72, 0xA8, 0xAB, 0x39, 0xF9, 0xF3, 0x39, 0xBE, 0x4A, 
 0xA5, 0x96, 0x53, 0xBB, 0x64, 0x1D, 0xBF, 0xC1, 0xAC, 0x4D, 
 0x5B, 0x8F, 0xBD, 0x96, 0xE1, 0xD3, 0x66, 0xD4, 0xE4, 0x50, 
 0xC3, 0x8D, 0xCE, 0x4F, 0xB2, 0x16, 0x96, 0x9C, 0xE2, 0x9A, 
 0xD9, 0xBA, 0x3E, 0x83, 0xE9, 0x9E, 0x99, 0x83, 0x4F, 0xA7, 
 0x8C, 0xF1, 0x42, 0x9B, 0x5B, 0xBF, 0x22, 0xD3, 0x1E, 0x77, 
 0x45, 0xFE, 0x91, 0x9C, 0xE2, 0xB2, 0xEB, 0x32, 0x74, 0xAF, 
 0xF8, 0x44, 0xF5, 0xFE, 0x9F, 0xA3, 0xC5, 0xA1, 0xD2, 0xC7, 
 0x0E, 0x08, 0xF4, 0xC1, 0x12, 0xCA, 0xA3, 0xD1, 0x14, 0x97, 
 0x72, 0xD8, 0xF0, 0x64, 0xBF, 0x1C, 0x9D, 0x7E, 0x5F, 0x73, 
 0x24, 0xA3, 0xFF, 0x00, 0x06, 0xCE, 0x36, 0x6D, 0xF2, 0x33, 
 0xA9, 0xAA, 0x77, 0x97, 0x23, 0xFF, 0x00, 0xD9, 0x9C, 0xBC, 
 0xBF, 0xEE, 0xB3, 0x85, 0xFB, 0x5E, 0xAC, 0xC9, 0x12, 0xC7, 
 0xB1, 0x65, 0x52, 0x2B, 0x87, 0x05, 0xD1, 0x7D, 0xC8, 0xDC, 
 0x53, 0xE5, 0xD1, 0x56, 0x58, 0x56, 0xE8, 0xD5, 0x28, 0x56, 
 0xEB, 0x82, 0x8C, 0x91, 0xD8, 0x0A, 0x13, 0x4D, 0xFD, 0x87, 
 0x1C, 0xF2, 0x26, 0xB7, 0xB4, 0x35, 0xF2, 0x2B, 0x26, 0xAE, 
 0xC9, 0x47, 0x14, 0x65, 0xD8, 0x57, 0xE7, 0xB1, 0x6C, 0x76, 
 0xE4, 0x2C, 0x57, 0x2D, 0x1E, 0x2C, 0x89, 0xF5, 0x42, 0x2C, 
 0xCD, 0x3F, 0x48, 0xC1, 0x27, 0xB4, 0x68, 0xE9, 0xC5, 0x2A, 
 0x24, 0xD2, 0xEC, 0xAC, 0x69, 0xE3, 0x1C, 0x69, 0xFA, 0x26, 
 0x1B, 0xDA, 0xFF, 0x00, 0xB9, 0x53, 0xF4, 0x6C, 0x7D, 0xAC, 
 0xEE, 0x38, 0xF3, 0xB3, 0x2A, 0x9B, 0x7C, 0x28, 0xED, 0xF6, 
 0x5D, 0x4F, 0x08, 0xE2, 0x4B, 0xD2, 0xA0, 0xB6, 0x40, 0xBD, 
 0x31, 0x1D, 0x77, 0x0D, 0xF7, 0x74, 0x12, 0xA4, 0xBF, 0x03, 
 0x53, 0xC6, 0x39, 0xB8, 0xB4, 0x31, 0x4E, 0xEB, 0x64, 0x6C, 
 0xC5, 0x81, 0x47, 0x64, 0x8B, 0x54, 0x5B, 0x96, 0xC8, 0xB6, 
 0x09, 0x2F, 0xB2, 0x5A, 0xB2, 0x27, 0x0C, 0x71, 0x8C, 0x56, 
 0xDB, 0xA2, 0x74, 0x46, 0x37, 0x64, 0xEE, 0xDA, 0x8A, 0xD9, 
 0x91, 0xAC, 0x42, 0x74, 0xDA, 0x88, 0x38, 0xEC, 0x58, 0xA0, 
 0x93, 0xB6, 0x42, 0x6C, 0x0A, 0x66, 0xCA, 0xF1, 0x7F, 0xBE, 
 0x89, 0xCC, 0x30, 0xAF, 0xE7, 0x06, 0x5D, 0x5D, 0x1C, 0x6F, 
 0x55, 0x85, 0xAE, 0x6C, 0xE8, 0xEA, 0xB4, 0xF1, 0xCA, 0x9A, 
 0x92, 0x4D, 0x3D, 0x99, 0x8B, 0xD3, 0x95, 0xEA, 0x61, 0xF4, 
 0x9B, 0x3A, 0xB3, 0x56, 0x99, 0xD3, 0xF3, 0xF8, 0xE3, 0xFA, 
 0xDF, 0xFD, 0x3C, 0x2F, 0xAB, 0xFF, 0x00, 0xA7, 0x32, 0x63, 
 0xCC, 0xE7, 0xA5, 0x8F, 0x54, 0x1E, 0xFD, 0x3D, 0xCE, 0x24, 
 0xF0, 0xE4, 0xC5, 0x91, 0xC7, 0x24, 0x5C, 0x1A, 0xE5, 0x33, 
 0xE9, 0xB9, 0x71, 0x29, 0x47, 0xEC, 0xF3, 0x1F, 0xEA, 0x98, 
 0x63, 0x8E, 0x9E, 0x33, 0x71, 0x5E, 0xE5, 0xD5, 0xFD, 0x1D, 
 0xA3, 0x9E, 0x3C, 0xB2, 0xCA, 0xE0, 0xCD, 0x1A, 0x7D, 0x4D, 
 0xCB, 0xA5, 0x99, 0x66, 0xF7, 0x44, 0x5F, 0xC5, 0xDF, 0x04, 
 0x47, 0x66, 0x32, 0x4F, 0xB9, 0x24, 0xF7, 0x39, 0x58, 0xB5, 
 0x32, 0x8B, 0xDF, 0x83, 0x6E, 0x2D, 0x42, 0x94, 0x88, 0xAD, 
 0x43, 0x23, 0x17, 0x68, 0x92, 0x01, 0x00, 0x00, 0x00, 0x00, 
 0x00, 0x00, 0x00, 0x00, 0x0A, 0xC8, 0xCB, 0x2C, 0x61, 0xCB, 
 0x0A, 0x9D, 0x83, 0x75, 0xC9, 0x8B, 0x2E, 0xBA, 0x31, 0x55, 
 0x1D, 0xD9, 0x96, 0x5A, 0xCC, 0x93, 0x4F, 0x71, 0x89, 0xAE, 
 0x9B, 0xD4, 0x46, 0x2F, 0x76, 0x65, 0xCB, 0xAD, 0xDF, 0xE2, 
 0xB8, 0x39, 0xFD, 0x6D, 0xBB, 0x6C, 0x4D, 0xEC, 0x6B, 0x13, 
 0x56, 0xE5, 0xCD, 0x2C, 0x92, 0xB6, 0xCA, 0xDF, 0x1B, 0x95, 
 0xA9, 0x3B, 0xB2, 0x4A, 0xC2, 0x04, 0xFC, 0x12, 0x5B, 0x3D, 
 0xC5, 0x5B, 0x03, 0x60, 0x5F, 0x83, 0x37, 0xB7, 0x38, 0xCA, 
 0xB6, 0xB3, 0xE9, 0x9E, 0x8B, 0xAB, 0xC7, 0xAD, 0xF4, 0xEC, 
 0x79, 0x31, 0xBE, 0x15, 0x35, 0xE1, 0x9F, 0x2B, 0xEB, 0xBE, 
 0xD6, 0x77, 0xBF, 0xD3, 0x9E, 0xB7, 0x2F, 0x4C, 0xC8, 0xE3, 
 0x91, 0xB7, 0x8A, 0x7F, 0xD2, 0x9F, 0x0C, 0x95, 0x67, 0xBF, 
 0x4F, 0x78, 0xF7, 0x99, 0x7F, 0x11, 0x6F, 0xC2, 0x31, 0xE8, 
 0xF3, 0xC7, 0x53, 0x86, 0x19, 0x61, 0xC4, 0xF7, 0x46, 0xCA, 
 0xF8, 0x35, 0xF4, 0x42, 0xB8, 0x19, 0x37, 0x4D, 0xF9, 0x6D, 
 0x98, 0x26, 0xAF, 0x23, 0x3A, 0x19, 0x38, 0xA3, 0x0C, 0x97, 
 0xCD, 0x9E, 0x78, 0xF6, 0x54, 0x61, 0xC9, 0x74, 0x78, 0x2A, 
 0x5C, 0x96, 0xC0, 0x2C, 0x58, 0x9A, 0x6A, 0x99, 0x5E, 0x5C, 
 0x7D, 0xD6, 0xE8, 0xB1, 0x6E, 0x0F, 0x62, 0x34, 0xC5, 0x4B, 
 0xF6, 0x21, 0xD3, 0xD3, 0xDA, 0xD1, 0xA3, 0x2E, 0x3A, 0xDE, 
 0x25, 0x6B, 0x75, 0x45, 0x66, 0xC5, 0x6D, 0x5A, 0xB4, 0xC7, 
 0x19, 0x4A, 0x3C, 0x8F, 0xA5, 0xF6, 0x1D, 0x79, 0x2A, 0x2D, 
 0x84, 0xD3, 0x5C, 0xEE, 0x59, 0x0F, 0x8A, 0xE6, 0xD1, 0x9D, 
 0x3A, 0xEC, 0x8B, 0x23, 0x3D, 0x83, 0x6B, 0x25, 0x24, 0xEC, 
 0xA6, 0x52, 0x6D, 0xEC, 0x4A, 0x53, 0x44, 0x62, 0xC2, 0x23, 
 0xD0, 0xF9, 0x61, 0xD3, 0xFF, 0x00, 0xE9, 0x34, 0xAD, 0xA6, 
 0xF8, 0x1C, 0xBF, 0xC0, 0x4C, 0x43, 0x87, 0x48, 0x9C, 0x16, 
 0xD7, 0x42, 0x84, 0x5C, 0xA4, 0xE8, 0xD3, 0x0C, 0x75, 0x54, 
 0xBF, 0x72, 0x2E, 0x23, 0x0C, 0x7B, 0x5D, 0x6E, 0x4D, 0x46, 
 0xAA, 0xF9, 0x2C, 0x4A, 0xB6, 0xB2, 0x35, 0x5B, 0x20, 0x20, 
 0xD9, 0x54, 0xF8, 0x2D, 0x96, 0xC9, 0x94, 0xCC, 0x25, 0x55, 
 0x31, 0xE0, 0x5F, 0xCC, 0xB1, 0x34, 0x5B, 0x82, 0x3B, 0x86, 
 0x5D, 0x7F, 0x4A, 0x8D, 0xE7, 0x94, 0xBC, 0x44, 0xE9, 0x48, 
 0xC9, 0xE9, 0x90, 0xE9, 0xC3, 0x29, 0xFF, 0x00, 0xC9, 0x9A, 
 0xA6, 0xF6, 0x3B, 0x71, 0x3D, 0x3C, 0xDF, 0xA5, 0xDE, 0x95, 
 0xB6, 0x94, 0x5B, 0x7C, 0x24, 0x7C, 0xFB, 0xFD, 0x41, 0xAF, 
 0x96, 0xAF, 0x5B, 0x35, 0xD5, 0xF0, 0x8B, 0xA8, 0xA3, 0xD4, 
 0xFA, 0xEF, 0xAC, 0x62, 0xD0, 0xE2, 0x78, 0xEE, 0xF2, 0x49, 
 0x3D, 0x97, 0x63, 0xC0, 0x65, 0x9B, 0x9E, 0x46, 0xDF, 0x93, 
 0xA2, 0x54, 0x5E, 0xC3, 0x71, 0x55, 0x69, 0x90, 0xB5, 0xD5, 
 0xE1, 0x7D, 0x8F, 0xBB, 0xA6, 0x19, 0x17, 0x5C, 0x8E, 0x33, 
 0x94, 0x5D, 0xA7, 0x4C, 0x8F, 0x2C, 0x72, 0xFA, 0x03, 0xA1, 
 0x87, 0x5C, 0xBA, 0x57, 0x57, 0x26, 0xCC, 0x59, 0x63, 0x91, 
 0x3E, 0x97, 0xC1, 0xC3, 0xF0, 0x6A, 0xC1, 0xAA, 0x78, 0xB6, 
 0xE5, 0x32, 0x62, 0xEB, 0xAC, 0x06, 0x4C, 0x7A, 0xE8, 0xCB, 
 0x9D, 0x8D, 0x11, 0xC8, 0xA4, 0xB6, 0x64, 0x54, 0xC4, 0x00, 
 0x40, 0xC0, 0x40, 0x07, 0x22, 0x7A, 0xDC, 0x8F, 0x6E, 0x0A, 
 0x25, 0x95, 0xC9, 0xFC, 0xB7, 0x20, 0x9E, 0xF6, 0x0B, 0x77, 
 0x48, 0xDB, 0x26, 0xDD, 0xAD, 0x98, 0x5B, 0xE0, 0x3B, 0xA4, 
 0x0F, 0x70, 0x1F, 0x0A, 0xE8, 0x8C, 0x9D, 0x72, 0x34, 0xDA, 
 0xD9, 0x91, 0x6F, 0xFB, 0x95, 0x12, 0x5B, 0x26, 0x38, 0xDD, 
 0xFD, 0x11, 0xF1, 0xE4, 0x12, 0xB6, 0x45, 0x4A, 0x52, 0xBE, 
 0x08, 0x5B, 0x7B, 0x12, 0x12, 0x48, 0x09, 0x28, 0x51, 0x24, 
 0xE9, 0xDA, 0x5B, 0x10, 0xB6, 0x37, 0x2A, 0xDA, 0x3B, 0x81, 
 0xE8, 0x7D, 0x13, 0xFD, 0x45, 0x93, 0x49, 0x28, 0x62, 0xCB, 
 0x4F, 0x15, 0xF7, 0xEC, 0x7B, 0xBD, 0x36, 0x78, 0x6A, 0x30, 
 0xA9, 0xE3, 0x77, 0x16, 0xB6, 0x67, 0xC9, 0x63, 0x2A, 0xE4, 
 0xF4, 0xDF, 0xE9, 0xAF, 0xF5, 0x02, 0xD1, 0xAF, 0x63, 0x53, 
 0x6F, 0x17, 0x67, 0xE0, 0x95, 0xAF, 0xAE, 0xDE, 0x6E, 0x65, 
 0xF9, 0x66, 0x26, 0xB7, 0x65, 0xCB, 0x3C, 0x73, 0x29, 0x4A, 
 0x2E, 0xD3, 0x6C, 0x85, 0x1E, 0x6F, 0xEB, 0xD7, 0xFC, 0x54, 
 0xF9, 0x27, 0x16, 0x46, 0x41, 0x10, 0x2F, 0x8B, 0xB2, 0x6D, 
 0x6C, 0x42, 0x05, 0x89, 0x59, 0x1B, 0x8A, 0xA5, 0x1E, 0xE5, 
 0x32, 0x82, 0xBE, 0x37, 0x34, 0xB5, 0xE5, 0x15, 0xCA, 0x25, 
 0x5A, 0xA1, 0xC5, 0xAF, 0x24, 0x5A, 0xDC, 0xD1, 0x57, 0xCA, 
 0x07, 0x8E, 0x2D, 0x6C, 0x56, 0x71, 0x99, 0xA6, 0x2D, 0xCD, 
 0x1E, 0xCF, 0xEE, 0x35, 0x81, 0xF2, 0x15, 0x9E, 0x29, 0xBE, 
 0x77, 0x2D, 0x8C, 0x55, 0x6E, 0x5B, 0xEC, 0xFD, 0xA2, 0x4A, 
 0x09, 0x72, 0x13, 0x15, 0x53, 0x6F, 0x64, 0x38, 0xE3, 0xB7, 
 0xBE, 0xE5, 0x9F, 0x48, 0x69, 0x5E, 0xC1, 0x70, 0x42, 0x2A, 
 0x3C, 0x2D, 0x8B, 0x52, 0xB4, 0x28, 0xA2, 0x75, 0xB1, 0x15, 
 0x16, 0x88, 0xCB, 0x62, 0x6C, 0xAE, 0x6C, 0x25, 0x42, 0x6C, 
 0xA6, 0x45, 0x92, 0x65, 0x7C, 0x86, 0x2A, 0x34, 0x68, 0xD3, 
 0xC1, 0xB9, 0x24, 0x96, 0xEC, 0xAE, 0x31, 0xB3, 0xA5, 0xE9, 
 0xB8, 0x3A, 0xB3, 0x29, 0x3E, 0x23, 0xBF, 0xEE, 0x59, 0x35, 
 0x9B, 0x72, 0x6B, 0xA7, 0x8E, 0x0B, 0x16, 0x18, 0xC1, 0x76, 
 0x46, 0x2F, 0x53, 0xD6, 0xFF, 0x00, 0x07, 0xA5, 0x9E, 0x5B, 
 0x57, 0x15, 0xC3, 0x2E, 0xD7, 0x6B, 0x31, 0x69, 0x30, 0x4F, 
 0x26, 0x59, 0xA5, 0x4B, 0x6F, 0xB3, 0xE7, 0xDE, 0xA9, 0xEA, 
 0xF9, 0xF5, 0xD9, 0x24, 0xA7, 0x27, 0xD1, 0x76, 0x91, 0xE8, 
 0x91, 0xE5, 0x9F, 0xED, 0x65, 0xD6, 0x6A, 0x67, 0xAB, 0xCF, 
 0x3C, 0x99, 0x25, 0xBC, 0x9D, 0x99, 0xB6, 0x07, 0x2D, 0xF7, 
 0x44, 0x7A, 0xFB, 0x15, 0x03, 0x8E, 0xF7, 0xC8, 0x9E, 0xDC, 
 0x6C, 0x34, 0xC3, 0xF2, 0x04, 0x57, 0x9E, 0xE4, 0x9C, 0xB6, 
 0xA6, 0x85, 0xC7, 0x02, 0x6D, 0x58, 0x0F, 0x9B, 0x7D, 0x81, 
 0x5A, 0x49, 0x8A, 0x3C, 0x0D, 0xA7, 0xE7, 0x60, 0x1B, 0x6D, 
 0x32, 0xD8, 0xEA, 0x27, 0x02, 0x9E, 0x16, 0xCE, 0xC4, 0xED, 
 0xBA, 0x03, 0x7E, 0x3D, 0x73, 0x51, 0x49, 0xA6, 0xDF, 0xD9, 
 0xAB, 0x1E, 0xA6, 0x32, 0xAD, 0xF7, 0x67, 0x1F, 0xA9, 0xAE, 
 0x07, 0x1C, 0x8D, 0x3D, 0x89, 0x8B, 0xAE, 0xEA, 0x92, 0x6B, 
 0x90, 0x39, 0x10, 0xD5, 0xCD, 0x2A, 0xB0, 0x18, 0xBA, 0xA3, 
 0x6F, 0xD8, 0x5D, 0xC1, 0x2B, 0x61, 0xC7, 0x25, 0x64, 0x3E, 
 0x41, 0xBF, 0xF0, 0x1D, 0xC1, 0xCA, 0x97, 0x00, 0x0F, 0x7D, 
 0xC6, 0xD2, 0x42, 0x7B, 0xAE, 0x07, 0xCA, 0x00, 0x75, 0x63, 
 0x7B, 0x2A, 0x40, 0xE5, 0x71, 0x0E, 0xCA, 0x80, 0x6B, 0x87, 
 0x62, 0x9A, 0xE9, 0xE0, 0x8B, 0x96, 0xE1, 0xCB, 0xB0, 0x05, 
 0x2B, 0x54, 0x95, 0x12, 0x85, 0x77, 0x23, 0xD2, 0xD7, 0x04, 
 0xBE, 0x98, 0x05, 0xFF, 0x00, 0x61, 0xC5, 0xDF, 0xF5, 0x51, 
 0x07, 0xCE, 0xDB, 0x89, 0x6D, 0x2D, 0x80, 0xEB, 0xFA, 0x7F, 
 0xA9, 0x4F, 0x4F, 0x71, 0x9F, 0xCA, 0x1D, 0x9A, 0x3D, 0x16, 
 0x9F, 0x32, 0xCD, 0x86, 0x33, 0x5D, 0xD1, 0xE2, 0x6D, 0xF6, 
 0x3A, 0xBE, 0x9B, 0xEA, 0xB2, 0xD2, 0xAE, 0x8C, 0x8A, 0xF1, 
 0xBF, 0xF0, 0x73, 0xEB, 0x9F, 0xF1, 0xDB, 0x8E, 0xFF, 0x00, 
 0x95, 0xE8, 0xA6, 0x88, 0x70, 0x2C, 0x1A, 0x9C, 0x7A, 0x85, 
 0x78, 0xE4, 0x99, 0x27, 0x13, 0x93, 0xB4, 0x59, 0x06, 0x5F, 
 0x17, 0xB1, 0x96, 0x0E, 0x8B, 0xE0, 0xC8, 0xDC, 0x59, 0x4C, 
 0x84, 0x89, 0xEE, 0x26, 0xAF, 0x90, 0xD2, 0xAA, 0xAE, 0xC2, 
 0xA2, 0xC6, 0xA9, 0x91, 0xA0, 0x12, 0xFD, 0xC6, 0x1C, 0x05, 
 0x00, 0x5B, 0xF2, 0x15, 0x6F, 0x91, 0xA4, 0x35, 0xB0, 0x02, 
 0x44, 0xA2, 0xBC, 0x09, 0x7D, 0x93, 0x8A, 0x02, 0x49, 0x0C, 
 0x5C, 0x03, 0xE0, 0x22, 0x32, 0x65, 0x32, 0x7B, 0x96, 0x49, 
 0x94, 0xC9, 0x84, 0xB5, 0x07, 0xBB, 0x1A, 0x42, 0x72, 0x50, 
 0x8B, 0x94, 0x9A, 0x49, 0x77, 0x65, 0x33, 0xF5, 0x0D, 0x36, 
 0x3F, 0xD5, 0x96, 0x3C, 0x79, 0x2E, 0x31, 0xAD, 0xB0, 0x49, 
 0x2D, 0xC9, 0xE7, 0xF5, 0xED, 0x1F, 0xA6, 0xE9, 0x9C, 0x23, 
 0x35, 0x93, 0x3D, 0xEF, 0x04, 0x79, 0x8D, 0x6F, 0xAF, 0x64, 
 0x96, 0x47, 0x1D, 0x3B, 0x4A, 0x2B, 0xBB, 0x47, 0x26, 0x53, 
 0x73, 0x6D, 0xC9, 0xF5, 0x37, 0xB9, 0xD7, 0x8E, 0x73, 0xDB, 
 0x8F, 0x7D, 0xCB, 0xE9, 0xAF, 0xD4, 0xFD, 0x57, 0x3E, 0xBB, 
 0x3B, 0x96, 0x49, 0xBE, 0x96, 0xF6, 0x8F, 0x64, 0x62, 0x72, 
 0x69, 0x72, 0x99, 0x19, 0x11, 0xBE, 0x93, 0xA3, 0x8E, 0xA6, 
 0xF7, 0x22, 0xD7, 0x61, 0x75, 0x2B, 0xBB, 0x24, 0xDD, 0xAF, 
 0x20, 0x45, 0x36, 0x1F, 0x81, 0xA4, 0x2E, 0x1E, 0xE0, 0x37, 
 0xBD, 0x76, 0x13, 0x8F, 0x90, 0x77, 0xFD, 0xC2, 0x5F, 0xDC, 
 0x02, 0xED, 0xD2, 0x06, 0xF8, 0x43, 0x51, 0x6B, 0x70, 0x4F, 
 0xE5, 0xB8, 0x40, 0x01, 0x24, 0xEF, 0xE8, 0x4D, 0x05, 0x3E, 
 0xC1, 0x7F, 0x40, 0xE3, 0x4C, 0x95, 0x2E, 0x9E, 0x40, 0x8C, 
 0x55, 0xA0, 0x1A, 0xFA, 0x40, 0x50, 0x96, 0xDB, 0xB6, 0x36, 
 0xF7, 0x56, 0x47, 0x86, 0x37, 0x0D, 0x93, 0xB2, 0x05, 0x27, 
 0x43, 0x5E, 0x68, 0x52, 0x54, 0x87, 0x16, 0x90, 0x0D, 0xBF, 
 0x02, 0x4F, 0x6D, 0x86, 0xDA, 0x6A, 0x96, 0xC2, 0x8A, 0xA4, 
 0xD7, 0x60, 0x22, 0xB7, 0xB6, 0x34, 0xFB, 0x02, 0x8D, 0xB1, 
 0xB5, 0x4D, 0x50, 0x0A, 0xC4, 0x82, 0xAF, 0x82, 0x51, 0xD8, 
 0x06, 0xAD, 0x11, 0x7B, 0xAD, 0xBF, 0xB8, 0x4A, 0xFC, 0xF2, 
 0x38, 0xAF, 0x20, 0x28, 0xFD, 0x13, 0x5D, 0x2B, 0x6E, 0xFE, 
 0x45, 0x54, 0xC4, 0xEB, 0xF6, 0x02, 0x69, 0xAF, 0xED, 0xD8, 
 0x52, 0x69, 0x3F, 0x93, 0xFD, 0x88, 0x39, 0x3E, 0xC1, 0xD3, 
 0x7B, 0xB0, 0x3A, 0x1E, 0x99, 0xAC, 0x5A, 0x7D, 0x42, 0x77, 
 0xF1, 0xE1, 0x9E, 0x9B, 0x16, 0x68, 0x67, 0x82, 0x96, 0x39, 
 0x26, 0x9F, 0x83, 0xC6, 0x24, 0xEB, 0x63, 0x56, 0x8F, 0x5B, 
 0x93, 0x4B, 0x24, 0xD3, 0x7D, 0x37, 0xBA, 0x39, 0xF5, 0xCE, 
 0xFB, 0x75, 0xE3, 0xBC, 0xF5, 0x5E, 0xAF, 0xB9, 0x6C, 0x19, 
 0x97, 0x4B, 0xA9, 0x86, 0xA7, 0x0C, 0x67, 0x07, 0x77, 0xCA, 
 0xF0, 0x5F, 0x16, 0x72, 0x7A, 0x25, 0x69, 0x8F, 0x03, 0xAD, 
 0x88, 0x41, 0x96, 0xA7, 0x7C, 0x91, 0xA8, 0xAD, 0xC4, 0x8F, 
 0x4E, 0xE5, 0xAF, 0x75, 0xB1, 0x17, 0xF8, 0xDC, 0x34, 0x87, 
 0x48, 0x3F, 0xD8, 0x96, 0xC0, 0x80, 0x8A, 0x25, 0x41, 0x56, 
 0xF9, 0x25, 0xD8, 0x04, 0xA2, 0x4A, 0x28, 0x12, 0xFA, 0x1D, 
 0x00, 0x0A, 0x4F, 0x62, 0x4F, 0x64, 0x57, 0x2A, 0x0C, 0xAB, 
 0x93, 0x29, 0xCD, 0x96, 0x38, 0xE2, 0xE5, 0x27, 0x49, 0x14, 
 0xEA, 0xBD, 0x4B, 0x4F, 0xA7, 0x53, 0xB9, 0xA7, 0x28, 0xFF, 
 0x00, 0x4A, 0xE4, 0xF3, 0xFE, 0xA1, 0xEA, 0x73, 0xD4, 0xFE, 
 0x9B, 0x8C, 0x3C, 0x1B, 0xE7, 0x9B, 0x5C, 0xFB, 0xEE, 0x46, 
 0xAF, 0x51, 0xF5, 0x58, 0xE5, 0xC7, 0xED, 0x63, 0xEE, 0xF7, 
 0x67, 0x1D, 0xB7, 0xD5, 0x6D, 0xD9, 0x15, 0x2B, 0x56, 0x12, 
 0x95, 0xBF, 0x07, 0x69, 0x31, 0xE6, 0xEB, 0xAD, 0x57, 0x2E, 
 0x5D, 0x8D, 0x3B, 0xEF, 0xC2, 0x07, 0xD8, 0x4F, 0xE8, 0xAC, 
 0xA5, 0x76, 0x84, 0xD1, 0x1B, 0x6C, 0x97, 0x6B, 0x01, 0x53, 
 0x68, 0x94, 0x1A, 0xEF, 0xB0, 0x52, 0x4B, 0x90, 0xEC, 0x03, 
 0xEA, 0xE6, 0xC8, 0xB5, 0x5D, 0xC2, 0xB7, 0x61, 0x5D, 0x4F, 
 0xF0, 0x01, 0xFF, 0x00, 0x62, 0xAA, 0xD8, 0x9A, 0xDD, 0xA5, 
 0xDD, 0x09, 0xBD, 0xE8, 0x06, 0xDA, 0xAE, 0x48, 0x35, 0xDD, 
 0x92, 0x6A, 0x84, 0xF7, 0x41, 0x0E, 0x2F, 0xFF, 0x00, 0x61, 
 0xF7, 0xE6, 0xC8, 0xAA, 0x5B, 0xAE, 0xC3, 0x5B, 0xBB, 0x61, 
 0x43, 0xFF, 0x00, 0x02, 0x4D, 0x86, 0xCE, 0x44, 0x92, 0xE0, 
 0x09, 0x3A, 0x01, 0x3D, 0xD8, 0x14, 0x46, 0x4E, 0xF8, 0x40, 
 0xDB, 0xEC, 0x25, 0xB2, 0x1A, 0x74, 0x82, 0x07, 0xBF, 0x28, 
 0x10, 0xAE, 0xAC, 0x22, 0xED, 0xDF, 0x82, 0x29, 0xB5, 0x52, 
 0x12, 0x6D, 0x3D, 0xBB, 0x8D, 0x3E, 0xA9, 0x2B, 0x13, 0x7F, 
 0x20, 0x1D, 0xD6, 0xE3, 0x7B, 0xF7, 0x14, 0xD5, 0x0B, 0x92, 
 0xA2, 0x5D, 0xAD, 0x31, 0x5D, 0xF2, 0x1C, 0x46, 0xC2, 0x1B, 
 0xA2, 0x28, 0xAB, 0x42, 0xB0, 0xBE, 0xC2, 0xFC, 0xF6, 0x02, 
 0x4E, 0x57, 0x15, 0x62, 0xA7, 0xCB, 0x06, 0xEF, 0xB0, 0x30, 
 0x1F, 0x4F, 0x77, 0xC1, 0x2E, 0x9A, 0x49, 0x89, 0x6E, 0x4A, 
 0x7B, 0x47, 0xEC, 0x08, 0xF7, 0xE6, 0x85, 0xD5, 0xBF, 0x91, 
 0x55, 0xEE, 0x34, 0xB7, 0x03, 0x66, 0x83, 0x5B, 0x3D, 0x36, 
 0x65, 0x28, 0xA7, 0xD3, 0xDD, 0x5F, 0x27, 0x77, 0x4F, 0xEA, 
 0xF8, 0x32, 0xCB, 0xA5, 0xBE, 0x97, 0xF6, 0x79, 0x87, 0x2A, 
 0x4A, 0x86, 0x9D, 0x6E, 0x8C, 0xDE, 0x65, 0x6F, 0x9E, 0xEC, 
 0x7B, 0xAC, 0x53, 0x8C, 0xD2, 0x71, 0x69, 0xAF, 0xA3, 0x44, 
 0x5E, 0xC7, 0x8C, 0xF4, 0xEF, 0x52, 0xCD, 0xA6, 0x9D, 0x2F, 
 0x94, 0x7F, 0xE2, 0xCF, 0x57, 0x83, 0x3B, 0xC9, 0xA7, 0x8E, 
 0x46, 0xA9, 0xB5, 0xC1, 0xC7, 0xAE, 0x71, 0xE9, 0xE3, 0xB9, 
 0x63, 0x4D, 0x59, 0x10, 0xE5, 0x09, 0xF2, 0x65, 0xD0, 0x3E, 
 0x38, 0x20, 0x9F, 0x24, 0xDF, 0x16, 0x45, 0xF0, 0x50, 0x91, 
 0x35, 0xF9, 0x12, 0x24, 0x40, 0xD7, 0xF7, 0x1D, 0x91, 0xB7, 
 0x45, 0x5A, 0xAD, 0x43, 0xD3, 0xE0, 0x94, 0xD4, 0x6D, 0xA5, 
 0xE4, 0xA9, 0x6A, 0x79, 0xB2, 0xC7, 0x16, 0x37, 0x39, 0x3A, 
 0x8A, 0x5B, 0x9C, 0x0D, 0x77, 0xAE, 0x75, 0x63, 0x94, 0x70, 
 0x2A, 0x6F, 0xB9, 0xCF, 0xD6, 0xFA, 0xAE, 0xA3, 0x51, 0x09, 
 0xE3, 0x94, 0xAA, 0x2D, 0xF6, 0x39, 0x8E, 0x6D, 0xB3, 0xAF, 
 0x3C, 0x67, 0xD7, 0x9F, 0xBF, 0xD7, 0xF9, 0x16, 0xE4, 0x9F, 
 0x5C, 0x9B, 0x6D, 0xB6, 0xF9, 0x2B, 0x93, 0xBF, 0xC0, 0x93, 
 0x6F, 0xFE, 0x87, 0x2E, 0x1F, 0xD1, 0xD1, 0xC1, 0x0B, 0x49, 
 0xA7, 0xC0, 0x5D, 0xFE, 0x9E, 0x07, 0xDA, 0xC4, 0xB6, 0x76, 
 0x41, 0x29, 0x3B, 0xEC, 0x45, 0x2B, 0x56, 0x37, 0xC5, 0x85, 
 0x94, 0x2A, 0xAE, 0xE1, 0x76, 0x4A, 0x95, 0x06, 0xD6, 0x95, 
 0x77, 0x02, 0x34, 0xF9, 0x0E, 0xFC, 0x8E, 0x48, 0x8A, 0x5B, 
 0x81, 0x29, 0x2A, 0x1A, 0xD9, 0x5B, 0x44, 0x64, 0x34, 0xF6, 
 0x08, 0x13, 0xB7, 0x62, 0xE2, 0x44, 0xA3, 0xC9, 0x2D, 0xAB, 
 0x80, 0xA8, 0x3D, 0xC1, 0xF1, 0x44, 0xA3, 0x14, 0xE4, 0xC5, 
 0x2D, 0x9A, 0x48, 0x21, 0x3D, 0x90, 0x7F, 0x4D, 0xA1, 0xD6, 
 0xC8, 0x24, 0xA9, 0x81, 0x18, 0xDF, 0x23, 0x4D, 0xD8, 0x92, 
 0x25, 0xFD, 0x40, 0x27, 0x36, 0x80, 0x1A, 0xDC, 0x0A, 0x3F, 
 0xFF, 0xD9, 0x30, 0x82, 0x02, 0x68, 0x06, 0x09, 0x2A, 0x86, 
 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x07, 0x02, 0xA0, 0x82, 0x02, 
 0x59, 0x30, 0x82, 0x02, 0x55, 0x02, 0x01, 0x03, 0x31, 0x0B, 
 0x30, 0x09, 0x06, 0x05, 0x2B, 0x0E, 0x03, 0x02, 0x1A, 0x05, 
 0x00, 0x30, 0x0A, 0x06, 0x08, 0x60, 0x86, 0x48, 0x01, 0x65, 
 0x03, 0x06, 0x02, 0x31, 0x82, 0x02, 0x35, 0x30, 0x82, 0x02, 
 0x31, 0x02, 0x01, 0x01, 0x30, 0x38, 0x30, 0x32, 0x31, 0x0B, 
 0x30, 0x09, 0x06, 0x03, 0x55, 0x04, 0x06, 0x13, 0x02, 0x55, 
 0x53, 0x31, 0x0D, 0x30, 0x0B, 0x06, 0x03, 0x55, 0x04, 0x0A, 
 0x13, 0x04, 0x4E, 0x49, 0x53, 0x54, 0x31, 0x14, 0x30, 0x12, 
 0x06, 0x03, 0x55, 0x04, 0x03, 0x13, 0x0B, 0x50, 0x49, 0x56, 
 0x20, 0x54, 0x65, 0x73, 0x74, 0x20, 0x43, 0x41, 0x02, 0x02, 
 0x27, 0x10, 0x30, 0x09, 0x06, 0x05, 0x2B, 0x0E, 0x03, 0x02, 
 0x1A, 0x05, 0x00, 0xA0, 0x81, 0xD3, 0x30, 0x17, 0x06, 0x09, 
 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x09, 0x03, 0x31, 
 0x0A, 0x06, 0x08, 0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x06, 
 0x02, 0x30, 0x1C, 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 
 0x0D, 0x01, 0x09, 0x05, 0x31, 0x0F, 0x17, 0x0D, 0x30, 0x37, 
 0x30, 0x35, 0x31, 0x37, 0x32, 0x31, 0x31, 0x30, 0x30, 0x32, 
 0x5A, 0x30, 0x23, 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 
 0x0D, 0x01, 0x09, 0x04, 0x31, 0x16, 0x04, 0x14, 0x46, 0x77, 
 0xCE, 0xF4, 0x2D, 0xC0, 0x0D, 0xF6, 0xD3, 0x5F, 0x82, 0x20, 
 0x73, 0xF5, 0x22, 0x52, 0xA6, 0xF9, 0x33, 0x55, 0x30, 0x27, 
 0x06, 0x08, 0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x06, 0x06, 
 0x31, 0x1B, 0x04, 0x19, 0xD6, 0x50, 0x18, 0x58, 0x21, 0x0C, 
 0x2D, 0x31, 0x71, 0xB5, 0x25, 0xA1, 0x68, 0x5A, 0x08, 0xC9, 
 0x2A, 0xDE, 0x0A, 0x61, 0x86, 0x50, 0x18, 0x43, 0xE2, 0x30, 
 0x4C, 0x06, 0x08, 0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x06, 
 0x05, 0x31, 0x40, 0x30, 0x3E, 0x31, 0x0D, 0x30, 0x0B, 0x06, 
 0x03, 0x55, 0x04, 0x0A, 0x13, 0x04, 0x4E, 0x49, 0x53, 0x54, 
 0x31, 0x0B, 0x30, 0x09, 0x06, 0x03, 0x55, 0x04, 0x06, 0x13, 
 0x02, 0x55, 0x53, 0x31, 0x20, 0x30, 0x1E, 0x06, 0x03, 0x55, 
 0x04, 0x03, 0x13, 0x17, 0x50, 0x49, 0x56, 0x20, 0x54, 0x65, 
 0x73, 0x74, 0x20, 0x43, 0x6F, 0x6E, 0x74, 0x65, 0x6E, 0x74, 
 0x20, 0x53, 0x69, 0x67, 0x6E, 0x65, 0x72, 0x30, 0x0D, 0x06, 
 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x01, 0x01, 
 0x05, 0x00, 0x04, 0x82, 0x01, 0x00, 0x43, 0xBA, 0x77, 0xF6, 
 0x1B, 0xDD, 0x0C, 0x42, 0xB1, 0x8C, 0xAA, 0xA4, 0xA7, 0x23, 
 0x60, 0xF4, 0x6A, 0xB1, 0x15, 0xA8, 0x08, 0x71, 0xE9, 0xA8, 
 0x46, 0x6C, 0x26, 0x71, 0x5B, 0x27, 0xE4, 0xDB, 0x58, 0x4B, 
 0x08, 0x22, 0x61, 0xF7, 0xE6, 0x5E, 0x71, 0xEA, 0x9C, 0x6A, 
 0xB1, 0x37, 0x61, 0x9B, 0x64, 0x39, 0xF3, 0x86, 0xC7, 0x21, 
 0x2A, 0xB2, 0x66, 0x49, 0x1E, 0x6D, 0x6B, 0x34, 0xE5, 0xD6, 
 0x03, 0xE8, 0xAF, 0xA7, 0x28, 0xCA, 0xD9, 0x84, 0xB1, 0x5D, 
 0x9F, 0x38, 0xE5, 0x2E, 0x43, 0x03, 0x8C, 0x4A, 0x05, 0xC1, 
 0x77, 0x55, 0x73, 0xF4, 0x76, 0xA7, 0xC8, 0x05, 0x21, 0x64, 
 0xEF, 0xFA, 0xF6, 0x6B, 0x41, 0x33, 0xF2, 0xB2, 0x5F, 0x83, 
 0x29, 0x4E, 0x2D, 0x27, 0x81, 0xA1, 0xDD, 0x50, 0xBA, 0x40, 
 0xD4, 0xD6, 0xD8, 0x2D, 0xD0, 0x46, 0xF2, 0x80, 0x6A, 0x85, 
 0x7C, 0x97, 0x61, 0xEC, 0xFB, 0x06, 0x25, 0xED, 0xC5, 0xF5, 
 0x89, 0x6D, 0x60, 0x60, 0x47, 0x4B, 0x5A, 0xC3, 0xD1, 0x34, 
 0xFD, 0x32, 0xBB, 0x33, 0xAD, 0x98, 0xEB, 0x2B, 0x83, 0xF1, 
 0x2C, 0x34, 0x03, 0xA3, 0x18, 0x58, 0x51, 0x2C, 0x30, 0xB8, 
 0x47, 0x11, 0x72, 0xDB, 0xD0, 0xD5, 0x86, 0x0F, 0x10, 0x7D, 
 0xE7, 0xE6, 0xCC, 0xB9, 0xD8, 0xDB, 0x6E, 0x7E, 0x8F, 0xD3, 
 0xAD, 0xC2, 0xE2, 0x34, 0x6B, 0x60, 0xB2, 0xEB, 0xE9, 0x55, 
 0xA5, 0x1F, 0x5F, 0x39, 0xE1, 0x18, 0x55, 0x4D, 0x7B, 0x13, 
 0x3B, 0x49, 0x34, 0x78, 0x32, 0x77, 0x21, 0x7C, 0x75, 0x42, 
 0x4D, 0x53, 0x9C, 0x86, 0x87, 0x85, 0x05, 0xBA, 0xCC, 0xE2, 
 0xBA, 0xBD, 0x69, 0xB0, 0x83, 0x89, 0x76, 0x1A, 0xD7, 0xDE, 
 0x8F, 0x0A, 0x6A, 0xF5, 0x64, 0x94, 0x24, 0x71, 0x67, 0x63, 
 0x40, 0xBD, 0x53, 0x20, 0xBE, 0x39, 0x7C, 0x3B, 0xF3, 0xE3, 
 0x4F, 0x8F, 0xFE, 0x00
}
;

// BER-TLV Tag 5FC109
static Octet PRINTED_INFO_DATA [ ] = 
{ 0x01, 0x20, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 
 0x39, 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 
 0x39, 0x30, 0x31, 0x20, 0x2D, 0x20, 0x50, 0x49, 0x56, 0x20, 
 0x54, 0x65, 0x73, 0x74, 0x02, 0x14, 0x31, 0x32, 0x33, 0x34, 
 0x35, 0x36, 0x37, 0x38, 0x39, 0x30, 0x31, 0x32, 0x33, 0x34, 
 0x35, 0x36, 0x37, 0x38, 0x39, 0x30, 0x03, 0x14, 0x31, 0x32, 
 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x30, 0x31, 0x32, 
 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x30, 0x04, 0x09, 
 0x32, 0x30, 0x30, 0x38, 0x41, 0x55, 0x47, 0x32, 0x34, 0x05, 
 0x0A, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 
 0x30, 0x06, 0x0F, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 
 0x38, 0x39, 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0xFE, 0x00
}
;
 
 
// BER-TLV Tag 5FC10A
static Octet SIGNING_X509_DATA [ ] = 
{ 0x70, 0x82, 0x04, 0xDF, 0x30, 0x82, 0x04, 0xDB, 0x30, 0x82, 
 0x03, 0xC3, 0xA0, 0x03, 0x02, 0x01, 0x02, 0x02, 0x01, 0x17, 
 0x30, 0x0D, 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 
 0x01, 0x01, 0x05, 0x05, 0x00, 0x30, 0x32, 0x31, 0x0B, 0x30, 
 0x09, 0x06, 0x03, 0x55, 0x04, 0x06, 0x13, 0x02, 0x55, 0x53, 
 0x31, 0x0D, 0x30, 0x0B, 0x06, 0x03, 0x55, 0x04, 0x0A, 0x13, 
 0x04, 0x4E, 0x49, 0x53, 0x54, 0x31, 0x14, 0x30, 0x12, 0x06, 
 0x03, 0x55, 0x04, 0x03, 0x13, 0x0B, 0x50, 0x49, 0x56, 0x20, 
 0x54, 0x65, 0x73, 0x74, 0x20, 0x43, 0x41, 0x30, 0x1E, 0x17, 
 0x0D, 0x30, 0x37, 0x30, 0x34, 0x31, 0x39, 0x31, 0x35, 0x32, 
 0x32, 0x33, 0x33, 0x5A, 0x17, 0x0D, 0x30, 0x39, 0x30, 0x34, 
 0x31, 0x39, 0x31, 0x35, 0x32, 0x32, 0x33, 0x33, 0x5A, 0x30, 
 0x71, 0x31, 0x0B, 0x30, 0x09, 0x06, 0x03, 0x55, 0x04, 0x06, 
 0x13, 0x02, 0x55, 0x53, 0x31, 0x27, 0x30, 0x25, 0x06, 0x03, 
 0x55, 0x04, 0x0B, 0x13, 0x1E, 0x6F, 0x72, 0x67, 0x61, 0x6E, 
 0x69, 0x7A, 0x61, 0x74, 0x69, 0x6F, 0x6E, 0x61, 0x6C, 0x20, 
 0x55, 0x6E, 0x69, 0x74, 0x20, 0x2D, 0x20, 0x50, 0x49, 0x56, 
 0x20, 0x54, 0x65, 0x73, 0x74, 0x31, 0x18, 0x30, 0x16, 0x06, 
 0x03, 0x55, 0x04, 0x0A, 0x13, 0x0F, 0x55, 0x2E, 0x53, 0x2E, 
 0x20, 0x47, 0x6F, 0x76, 0x65, 0x72, 0x6E, 0x6D, 0x65, 0x6E, 
 0x74, 0x31, 0x1F, 0x30, 0x1D, 0x06, 0x03, 0x55, 0x04, 0x03, 
 0x0C, 0x16, 0x63, 0x6F, 0x6D, 0x6D, 0x6F, 0x6E, 0x5F, 0x6E, 
 0x61, 0x6D, 0x65, 0x20, 0x2D, 0x20, 0x50, 0x49, 0x56, 0x20, 
 0x54, 0x65, 0x73, 0x74, 0x30, 0x81, 0x9F, 0x30, 0x0D, 0x06, 
 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x01, 0x01, 
 0x05, 0x00, 0x03, 0x81, 0x8D, 0x00, 0x30, 0x81, 0x89, 0x02, 
 0x81, 0x81, 0x00, 0xCC, 0xD8, 0x7D, 0xEE, 0x80, 0xF0, 0x7B, 
 0x65, 0x53, 0xB2, 0x16, 0x08, 0xD6, 0xFC, 0xD1, 0xA3, 0x89, 
 0xF7, 0x77, 0x65, 0x18, 0x58, 0x3F, 0xD0, 0x83, 0x6E, 0x07, 
 0x2D, 0xE0, 0xD7, 0x58, 0x3F, 0x5E, 0x11, 0x4D, 0x00, 0x28, 
 0x85, 0x13, 0x50, 0xD1, 0x0E, 0x52, 0xA5, 0x39, 0xD6, 0x51, 
 0xF9, 0x1A, 0x12, 0x1F, 0xBA, 0x17, 0x5E, 0xB1, 0x8F, 0xE2, 
 0xDF, 0xF3, 0x02, 0x67, 0x60, 0x70, 0x76, 0xA1, 0x08, 0x00, 
 0xEF, 0x0A, 0xF4, 0x65, 0xDB, 0xA7, 0xDA, 0xE9, 0xEF, 0xD2, 
 0xC0, 0x4B, 0x9A, 0x80, 0x10, 0xE5, 0x73, 0x5F, 0xFE, 0x5A, 
 0xB0, 0xFA, 0x49, 0xA5, 0xFF, 0x9B, 0x79, 0x3B, 0x83, 0x1E, 
 0x7B, 0xF8, 0x75, 0x8F, 0xE9, 0x5C, 0x8A, 0xD2, 0x71, 0x49, 
 0x18, 0xEC, 0x6E, 0xAB, 0x1C, 0x1D, 0x51, 0x5F, 0x3B, 0x5E, 
 0xDF, 0xF1, 0x6C, 0x2E, 0x68, 0x66, 0xA5, 0x22, 0x75, 0xB8, 
 0x21, 0x02, 0x03, 0x01, 0x00, 0x01, 0xA3, 0x82, 0x02, 0x3F, 
 0x30, 0x82, 0x02, 0x3B, 0x30, 0x1F, 0x06, 0x03, 0x55, 0x1D, 
 0x23, 0x04, 0x18, 0x30, 0x16, 0x80, 0x14, 0xEB, 0xDA, 0x19, 
 0xD2, 0x08, 0x42, 0x8D, 0xF4, 0xDE, 0x25, 0x87, 0x69, 0xC9, 
 0xBB, 0xAB, 0x0C, 0xD3, 0x96, 0x30, 0x01, 0x30, 0x1D, 0x06, 
 0x03, 0x55, 0x1D, 0x0E, 0x04, 0x16, 0x04, 0x14, 0xF8, 0x36, 
 0x17, 0xF6, 0xBA, 0x89, 0x6C, 0x0B, 0xBE, 0xF7, 0x9B, 0xC4, 
 0xF6, 0x10, 0x70, 0x52, 0x64, 0xA1, 0x93, 0xBA, 0x30, 0x0E, 
 0x06, 0x03, 0x55, 0x1D, 0x0F, 0x01, 0x01, 0xFF, 0x04, 0x04, 
 0x03, 0x02, 0x06, 0xC0, 0x30, 0x17, 0x06, 0x03, 0x55, 0x1D, 
 0x20, 0x04, 0x10, 0x30, 0x0E, 0x30, 0x0C, 0x06, 0x0A, 0x60, 
 0x86, 0x48, 0x01, 0x65, 0x03, 0x02, 0x01, 0x03, 0x0D, 0x30, 
 0x81, 0x86, 0x06, 0x03, 0x55, 0x1D, 0x1F, 0x04, 0x7F, 0x30, 
 0x7D, 0x30, 0x7B, 0xA0, 0x79, 0xA0, 0x77, 0x86, 0x1B, 0x68, 
 0x74, 0x74, 0x70, 0x3A, 0x2F, 0x2F, 0x6C, 0x6F, 0x63, 0x61, 
 0x6C, 0x68, 0x6F, 0x73, 0x74, 0x2F, 0x63, 0x72, 0x6C, 0x2F, 
 0x63, 0x61, 0x2E, 0x63, 0x72, 0x6C, 0x86, 0x58, 0x6C, 0x64, 
 0x61, 0x70, 0x3A, 0x2F, 0x2F, 0x73, 0x6D, 0x69, 0x6D, 0x65, 
 0x32, 0x2E, 0x6E, 0x69, 0x73, 0x74, 0x2E, 0x67, 0x6F, 0x76, 
 0x2F, 0x63, 0x6E, 0x3D, 0x47, 0x6F, 0x6F, 0x64, 0x25, 0x32, 
 0x30, 0x43, 0x41, 0x2C, 0x6F, 0x3D, 0x54, 0x65, 0x73, 0x74, 
 0x25, 0x32, 0x30, 0x43, 0x65, 0x72, 0x74, 0x69, 0x66, 0x69, 
 0x63, 0x61, 0x74, 0x65, 0x73, 0x2C, 0x63, 0x3D, 0x55, 0x53, 
 0x3F, 0x63, 0x65, 0x72, 0x74, 0x69, 0x66, 0x69, 0x63, 0x61, 
 0x74, 0x65, 0x52, 0x65, 0x76, 0x6F, 0x63, 0x61, 0x74, 0x69, 
 0x6F, 0x6E, 0x4C, 0x69, 0x73, 0x74, 0x30, 0x82, 0x01, 0x21, 
 0x06, 0x08, 0x2B, 0x06, 0x01, 0x05, 0x05, 0x07, 0x01, 0x01, 
 0x04, 0x82, 0x01, 0x13, 0x30, 0x82, 0x01, 0x0F, 0x30, 0x3E, 
 0x06, 0x08, 0x2B, 0x06, 0x01, 0x05, 0x05, 0x07, 0x30, 0x01, 
 0x86, 0x32, 0x68, 0x74, 0x74, 0x70, 0x3A, 0x2F, 0x2F, 0x66, 
 0x69, 0x63, 0x74, 0x69, 0x74, 0x69, 0x6F, 0x75, 0x73, 0x2E, 
 0x6E, 0x69, 0x73, 0x74, 0x2E, 0x67, 0x6F, 0x76, 0x2F, 0x66, 
 0x69, 0x63, 0x74, 0x69, 0x74, 0x69, 0x6F, 0x75, 0x73, 0x4F, 
 0x43, 0x53, 0x50, 0x4C, 0x6F, 0x63, 0x61, 0x74, 0x69, 0x6F, 
 0x6E, 0x2F, 0x30, 0x5E, 0x06, 0x08, 0x2B, 0x06, 0x01, 0x05, 
 0x05, 0x07, 0x30, 0x02, 0x86, 0x52, 0x68, 0x74, 0x74, 0x70, 
 0x3A, 0x2F, 0x2F, 0x66, 0x69, 0x63, 0x74, 0x69, 0x74, 0x69, 
 0x6F, 0x75, 0x73, 0x2E, 0x6E, 0x69, 0x73, 0x74, 0x2E, 0x67, 
 0x6F, 0x76, 0x2F, 0x66, 0x69, 0x63, 0x74, 0x69, 0x74, 0x69, 
 0x6F, 0x75, 0x73, 0x43, 0x65, 0x72, 0x74, 0x73, 0x4F, 0x6E, 
 0x6C, 0x79, 0x43, 0x4D, 0x53, 0x64, 0x69, 0x72, 0x65, 0x63, 
 0x74, 0x6F, 0x72, 0x79, 0x2F, 0x63, 0x65, 0x72, 0x74, 0x73, 
 0x49, 0x73, 0x73, 0x75, 0x65, 0x64, 0x54, 0x6F, 0x47, 0x6F, 
 0x6F, 0x64, 0x43, 0x41, 0x2E, 0x70, 0x37, 0x63, 0x30, 0x6D, 
 0x06, 0x08, 0x2B, 0x06, 0x01, 0x05, 0x05, 0x07, 0x30, 0x02, 
 0x86, 0x61, 0x6C, 0x64, 0x61, 0x70, 0x3A, 0x2F, 0x2F, 0x73, 
 0x6D, 0x69, 0x6D, 0x65, 0x32, 0x2E, 0x6E, 0x69, 0x73, 0x74, 
 0x2E, 0x67, 0x6F, 0x76, 0x2F, 0x63, 0x6E, 0x3D, 0x47, 0x6F, 
 0x6F, 0x64, 0x25, 0x32, 0x30, 0x43, 0x41, 0x2C, 0x6F, 0x3D, 
 0x54, 0x65, 0x73, 0x74, 0x25, 0x32, 0x30, 0x43, 0x65, 0x72, 
 0x74, 0x69, 0x66, 0x69, 0x63, 0x61, 0x74, 0x65, 0x73, 0x2C, 
 0x63, 0x3D, 0x55, 0x53, 0x3F, 0x63, 0x41, 0x43, 0x65, 0x72, 
 0x74, 0x69, 0x66, 0x69, 0x63, 0x61, 0x74, 0x65, 0x2C, 0x63, 
 0x72, 0x6F, 0x73, 0x73, 0x43, 0x65, 0x72, 0x74, 0x69, 0x66, 
 0x69, 0x63, 0x61, 0x74, 0x65, 0x50, 0x61, 0x69, 0x72, 0x30, 
 0x22, 0x06, 0x03, 0x55, 0x1D, 0x11, 0x04, 0x1B, 0x30, 0x19, 
 0x81, 0x17, 0x63, 0x6F, 0x6D, 0x6D, 0x6F, 0x6E, 0x5F, 0x6E, 
 0x61, 0x6D, 0x65, 0x40, 0x70, 0x69, 0x76, 0x64, 0x65, 0x6D, 
 0x6F, 0x2E, 0x6F, 0x72, 0x67, 0x30, 0x0D, 0x06, 0x09, 0x2A, 
 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x01, 0x05, 0x05, 0x00, 
 0x03, 0x82, 0x01, 0x01, 0x00, 0x2E, 0x40, 0x3B, 0xE4, 0xA3, 
 0x6D, 0xF7, 0xDF, 0xFF, 0x47, 0x9B, 0x37, 0xCB, 0x4B, 0x8B, 
 0x17, 0xF9, 0xB2, 0x4E, 0xB1, 0x70, 0x86, 0x01, 0x58, 0xDD, 
 0xD4, 0x75, 0x99, 0x03, 0xEF, 0xDE, 0x1B, 0xC1, 0xC8, 0x37, 
 0xD9, 0xA0, 0x86, 0x36, 0x2D, 0xCB, 0x36, 0xED, 0x97, 0xB6, 
 0x88, 0x16, 0x08, 0x93, 0x08, 0x89, 0x66, 0x0A, 0x34, 0x43, 
 0x07, 0x8F, 0x97, 0x49, 0xFE, 0x7D, 0x9A, 0xAB, 0xB0, 0x92, 
 0xBB, 0x60, 0xC2, 0x73, 0x6D, 0x6F, 0xCA, 0x2E, 0xE7, 0x88, 
 0x01, 0xE7, 0x67, 0xDA, 0xFB, 0x8D, 0xBE, 0x13, 0x69, 0x93, 
 0x94, 0x29, 0x49, 0xF1, 0xA5, 0x86, 0x9E, 0x65, 0x0E, 0x1C, 
 0xAF, 0xA8, 0x41, 0xE8, 0x07, 0xDA, 0xE3, 0x00, 0x5F, 0xBF, 
 0x1E, 0xE6, 0xFE, 0x32, 0x28, 0xD3, 0xB9, 0x9A, 0xB3, 0x36, 
 0x80, 0x38, 0x43, 0x42, 0xB8, 0xA5, 0x8C, 0x42, 0x7A, 0x51, 
 0x40, 0x69, 0xA2, 0x49, 0x9C, 0x0B, 0x6A, 0x67, 0x05, 0x29, 
 0x5A, 0x16, 0x7F, 0x44, 0xB2, 0xF4, 0x84, 0x91, 0x70, 0xC4, 
 0x90, 0x67, 0xDE, 0x9F, 0x13, 0x05, 0x41, 0xC6, 0xB4, 0x40, 
 0xFF, 0x0B, 0x3B, 0xDC, 0xDA, 0x34, 0x86, 0x99, 0x5D, 0x9C, 
 0xFC, 0x8D, 0x5A, 0x36, 0x5F, 0x96, 0x49, 0xA5, 0x74, 0x9A, 
 0x4B, 0x5F, 0x97, 0xB4, 0x4C, 0x39, 0x22, 0x9C, 0xA0, 0xDA, 
 0xD1, 0x8E, 0xB7, 0x16, 0x2F, 0x91, 0xAA, 0x57, 0x18, 0xFF, 
 0xD0, 0x75, 0x3D, 0x83, 0x07, 0xD9, 0x45, 0x64, 0xBB, 0xE3, 
 0xCC, 0xDF, 0x0F, 0x9E, 0x1B, 0xF9, 0xA4, 0xCC, 0x07, 0x62, 
 0x5F, 0x85, 0xC7, 0xD8, 0xA9, 0x23, 0xA3, 0xB6, 0x95, 0x6E, 
 0xD3, 0x6B, 0x21, 0x44, 0x1A, 0xC7, 0x19, 0xAA, 0x03, 0x18, 
 0x28, 0x07, 0x6B, 0x7F, 0x7C, 0x21, 0x03, 0x0E, 0xB4, 0x61, 
 0x0B, 0x59, 0xE6, 0x3E, 0xA0, 0xC8, 0xED, 0xA9, 0x9E, 0x7E, 
 0xCA, 0x71, 0x01, 0x00, 0xFE, 0x00
}
;

// BER-TLV Tag 5FC10B
static Octet KEY_MANAGEMENT_X509_DATA [ ] = 
{ 0x70, 0x82, 0x04, 0xDF, 0x30, 0x82, 0x04, 0xDB, 0x30, 0x82, 
 0x03, 0xC3, 0xA0, 0x03, 0x02, 0x01, 0x02, 0x02, 0x01, 0x18, 
 0x30, 0x0D, 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 
 0x01, 0x01, 0x05, 0x05, 0x00, 0x30, 0x32, 0x31, 0x0B, 0x30, 
 0x09, 0x06, 0x03, 0x55, 0x04, 0x06, 0x13, 0x02, 0x55, 0x53, 
 0x31, 0x0D, 0x30, 0x0B, 0x06, 0x03, 0x55, 0x04, 0x0A, 0x13, 
 0x04, 0x4E, 0x49, 0x53, 0x54, 0x31, 0x14, 0x30, 0x12, 0x06, 
 0x03, 0x55, 0x04, 0x03, 0x13, 0x0B, 0x50, 0x49, 0x56, 0x20, 
 0x54, 0x65, 0x73, 0x74, 0x20, 0x43, 0x41, 0x30, 0x1E, 0x17, 
 0x0D, 0x30, 0x37, 0x30, 0x34, 0x31, 0x39, 0x31, 0x35, 0x32, 
 0x32, 0x33, 0x33, 0x5A, 0x17, 0x0D, 0x30, 0x39, 0x30, 0x34, 
 0x31, 0x39, 0x31, 0x35, 0x32, 0x32, 0x33, 0x33, 0x5A, 0x30, 
 0x71, 0x31, 0x0B, 0x30, 0x09, 0x06, 0x03, 0x55, 0x04, 0x06, 
 0x13, 0x02, 0x55, 0x53, 0x31, 0x27, 0x30, 0x25, 0x06, 0x03, 
 0x55, 0x04, 0x0B, 0x13, 0x1E, 0x6F, 0x72, 0x67, 0x61, 0x6E, 
 0x69, 0x7A, 0x61, 0x74, 0x69, 0x6F, 0x6E, 0x61, 0x6C, 0x20, 
 0x55, 0x6E, 0x69, 0x74, 0x20, 0x2D, 0x20, 0x50, 0x49, 0x56, 
 0x20, 0x54, 0x65, 0x73, 0x74, 0x31, 0x18, 0x30, 0x16, 0x06, 
 0x03, 0x55, 0x04, 0x0A, 0x13, 0x0F, 0x55, 0x2E, 0x53, 0x2E, 
 0x20, 0x47, 0x6F, 0x76, 0x65, 0x72, 0x6E, 0x6D, 0x65, 0x6E, 
 0x74, 0x31, 0x1F, 0x30, 0x1D, 0x06, 0x03, 0x55, 0x04, 0x03, 
 0x0C, 0x16, 0x63, 0x6F, 0x6D, 0x6D, 0x6F, 0x6E, 0x5F, 0x6E, 
 0x61, 0x6D, 0x65, 0x20, 0x2D, 0x20, 0x50, 0x49, 0x56, 0x20, 
 0x54, 0x65, 0x73, 0x74, 0x30, 0x81, 0x9F, 0x30, 0x0D, 0x06, 
 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x01, 0x01, 
 0x05, 0x00, 0x03, 0x81, 0x8D, 0x00, 0x30, 0x81, 0x89, 0x02, 
 0x81, 0x81, 0x00, 0xCC, 0xD8, 0x7D, 0xEE, 0x80, 0xF0, 0x7B, 
 0x65, 0x53, 0xB2, 0x16, 0x08, 0xD6, 0xFC, 0xD1, 0xA3, 0x89, 
 0xF7, 0x77, 0x65, 0x18, 0x58, 0x3F, 0xD0, 0x83, 0x6E, 0x07, 
 0x2D, 0xE0, 0xD7, 0x58, 0x3F, 0x5E, 0x11, 0x4D, 0x00, 0x28, 
 0x85, 0x13, 0x50, 0xD1, 0x0E, 0x52, 0xA5, 0x39, 0xD6, 0x51, 
 0xF9, 0x1A, 0x12, 0x1F, 0xBA, 0x17, 0x5E, 0xB1, 0x8F, 0xE2, 
 0xDF, 0xF3, 0x02, 0x67, 0x60, 0x70, 0x76, 0xA1, 0x08, 0x00, 
 0xEF, 0x0A, 0xF4, 0x65, 0xDB, 0xA7, 0xDA, 0xE9, 0xEF, 0xD2, 
 0xC0, 0x4B, 0x9A, 0x80, 0x10, 0xE5, 0x73, 0x5F, 0xFE, 0x5A, 
 0xB0, 0xFA, 0x49, 0xA5, 0xFF, 0x9B, 0x79, 0x3B, 0x83, 0x1E, 
 0x7B, 0xF8, 0x75, 0x8F, 0xE9, 0x5C, 0x8A, 0xD2, 0x71, 0x49, 
 0x18, 0xEC, 0x6E, 0xAB, 0x1C, 0x1D, 0x51, 0x5F, 0x3B, 0x5E, 
 0xDF, 0xF1, 0x6C, 0x2E, 0x68, 0x66, 0xA5, 0x22, 0x75, 0xB8, 
 0x21, 0x02, 0x03, 0x01, 0x00, 0x01, 0xA3, 0x82, 0x02, 0x3F, 
 0x30, 0x82, 0x02, 0x3B, 0x30, 0x1F, 0x06, 0x03, 0x55, 0x1D, 
 0x23, 0x04, 0x18, 0x30, 0x16, 0x80, 0x14, 0xEB, 0xDA, 0x19, 
 0xD2, 0x08, 0x42, 0x8D, 0xF4, 0xDE, 0x25, 0x87, 0x69, 0xC9, 
 0xBB, 0xAB, 0x0C, 0xD3, 0x96, 0x30, 0x01, 0x30, 0x1D, 0x06, 
 0x03, 0x55, 0x1D, 0x0E, 0x04, 0x16, 0x04, 0x14, 0xF8, 0x36, 
 0x17, 0xF6, 0xBA, 0x89, 0x6C, 0x0B, 0xBE, 0xF7, 0x9B, 0xC4, 
 0xF6, 0x10, 0x70, 0x52, 0x64, 0xA1, 0x93, 0xBA, 0x30, 0x0E, 
 0x06, 0x03, 0x55, 0x1D, 0x0F, 0x01, 0x01, 0xFF, 0x04, 0x04, 
 0x03, 0x02, 0x05, 0x20, 0x30, 0x17, 0x06, 0x03, 0x55, 0x1D, 
 0x20, 0x04, 0x10, 0x30, 0x0E, 0x30, 0x0C, 0x06, 0x0A, 0x60, 
 0x86, 0x48, 0x01, 0x65, 0x03, 0x02, 0x01, 0x03, 0x0D, 0x30, 
 0x81, 0x86, 0x06, 0x03, 0x55, 0x1D, 0x1F, 0x04, 0x7F, 0x30, 
 0x7D, 0x30, 0x7B, 0xA0, 0x79, 0xA0, 0x77, 0x86, 0x1B, 0x68, 
 0x74, 0x74, 0x70, 0x3A, 0x2F, 0x2F, 0x6C, 0x6F, 0x63, 0x61, 
 0x6C, 0x68, 0x6F, 0x73, 0x74, 0x2F, 0x63, 0x72, 0x6C, 0x2F, 
 0x63, 0x61, 0x2E, 0x63, 0x72, 0x6C, 0x86, 0x58, 0x6C, 0x64, 
 0x61, 0x70, 0x3A, 0x2F, 0x2F, 0x73, 0x6D, 0x69, 0x6D, 0x65, 
 0x32, 0x2E, 0x6E, 0x69, 0x73, 0x74, 0x2E, 0x67, 0x6F, 0x76, 
 0x2F, 0x63, 0x6E, 0x3D, 0x47, 0x6F, 0x6F, 0x64, 0x25, 0x32, 
 0x30, 0x43, 0x41, 0x2C, 0x6F, 0x3D, 0x54, 0x65, 0x73, 0x74, 
 0x25, 0x32, 0x30, 0x43, 0x65, 0x72, 0x74, 0x69, 0x66, 0x69, 
 0x63, 0x61, 0x74, 0x65, 0x73, 0x2C, 0x63, 0x3D, 0x55, 0x53, 
 0x3F, 0x63, 0x65, 0x72, 0x74, 0x69, 0x66, 0x69, 0x63, 0x61, 
 0x74, 0x65, 0x52, 0x65, 0x76, 0x6F, 0x63, 0x61, 0x74, 0x69, 
 0x6F, 0x6E, 0x4C, 0x69, 0x73, 0x74, 0x30, 0x82, 0x01, 0x21, 
 0x06, 0x08, 0x2B, 0x06, 0x01, 0x05, 0x05, 0x07, 0x01, 0x01, 
 0x04, 0x82, 0x01, 0x13, 0x30, 0x82, 0x01, 0x0F, 0x30, 0x3E, 
 0x06, 0x08, 0x2B, 0x06, 0x01, 0x05, 0x05, 0x07, 0x30, 0x01, 
 0x86, 0x32, 0x68, 0x74, 0x74, 0x70, 0x3A, 0x2F, 0x2F, 0x66, 
 0x69, 0x63, 0x74, 0x69, 0x74, 0x69, 0x6F, 0x75, 0x73, 0x2E, 
 0x6E, 0x69, 0x73, 0x74, 0x2E, 0x67, 0x6F, 0x76, 0x2F, 0x66, 
 0x69, 0x63, 0x74, 0x69, 0x74, 0x69, 0x6F, 0x75, 0x73, 0x4F, 
 0x43, 0x53, 0x50, 0x4C, 0x6F, 0x63, 0x61, 0x74, 0x69, 0x6F, 
 0x6E, 0x2F, 0x30, 0x5E, 0x06, 0x08, 0x2B, 0x06, 0x01, 0x05, 
 0x05, 0x07, 0x30, 0x02, 0x86, 0x52, 0x68, 0x74, 0x74, 0x70, 
 0x3A, 0x2F, 0x2F, 0x66, 0x69, 0x63, 0x74, 0x69, 0x74, 0x69, 
 0x6F, 0x75, 0x73, 0x2E, 0x6E, 0x69, 0x73, 0x74, 0x2E, 0x67, 
 0x6F, 0x76, 0x2F, 0x66, 0x69, 0x63, 0x74, 0x69, 0x74, 0x69, 
 0x6F, 0x75, 0x73, 0x43, 0x65, 0x72, 0x74, 0x73, 0x4F, 0x6E, 
 0x6C, 0x79, 0x43, 0x4D, 0x53, 0x64, 0x69, 0x72, 0x65, 0x63, 
 0x74, 0x6F, 0x72, 0x79, 0x2F, 0x63, 0x65, 0x72, 0x74, 0x73, 
 0x49, 0x73, 0x73, 0x75, 0x65, 0x64, 0x54, 0x6F, 0x47, 0x6F, 
 0x6F, 0x64, 0x43, 0x41, 0x2E, 0x70, 0x37, 0x63, 0x30, 0x6D, 
 0x06, 0x08, 0x2B, 0x06, 0x01, 0x05, 0x05, 0x07, 0x30, 0x02, 
 0x86, 0x61, 0x6C, 0x64, 0x61, 0x70, 0x3A, 0x2F, 0x2F, 0x73, 
 0x6D, 0x69, 0x6D, 0x65, 0x32, 0x2E, 0x6E, 0x69, 0x73, 0x74, 
 0x2E, 0x67, 0x6F, 0x76, 0x2F, 0x63, 0x6E, 0x3D, 0x47, 0x6F, 
 0x6F, 0x64, 0x25, 0x32, 0x30, 0x43, 0x41, 0x2C, 0x6F, 0x3D, 
 0x54, 0x65, 0x73, 0x74, 0x25, 0x32, 0x30, 0x43, 0x65, 0x72, 
 0x74, 0x69, 0x66, 0x69, 0x63, 0x61, 0x74, 0x65, 0x73, 0x2C, 
 0x63, 0x3D, 0x55, 0x53, 0x3F, 0x63, 0x41, 0x43, 0x65, 0x72, 
 0x74, 0x69, 0x66, 0x69, 0x63, 0x61, 0x74, 0x65, 0x2C, 0x63, 
 0x72, 0x6F, 0x73, 0x73, 0x43, 0x65, 0x72, 0x74, 0x69, 0x66, 
 0x69, 0x63, 0x61, 0x74, 0x65, 0x50, 0x61, 0x69, 0x72, 0x30, 
 0x22, 0x06, 0x03, 0x55, 0x1D, 0x11, 0x04, 0x1B, 0x30, 0x19, 
 0x81, 0x17, 0x63, 0x6F, 0x6D, 0x6D, 0x6F, 0x6E, 0x5F, 0x6E, 
 0x61, 0x6D, 0x65, 0x40, 0x70, 0x69, 0x76, 0x64, 0x65, 0x6D, 
 0x6F, 0x2E, 0x6F, 0x72, 0x67, 0x30, 0x0D, 0x06, 0x09, 0x2A, 
 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x01, 0x05, 0x05, 0x00, 
 0x03, 0x82, 0x01, 0x01, 0x00, 0x8C, 0x34, 0xD1, 0x6F, 0xB7, 
 0x4E, 0x38, 0xAB, 0x60, 0x97, 0xA5, 0x61, 0x99, 0x5E, 0x8A, 
 0xC1, 0x87, 0xA3, 0x8F, 0xFB, 0x47, 0x54, 0xED, 0xAE, 0xAB, 
 0xB3, 0x66, 0x24, 0x66, 0x7C, 0x65, 0xD7, 0xD0, 0x38, 0x2A, 
 0x69, 0x22, 0x52, 0x81, 0x9F, 0x34, 0xA2, 0x3D, 0x97, 0xA9, 
 0x0D, 0xE3, 0xFA, 0x40, 0xDD, 0x1A, 0x05, 0x00, 0x7B, 0xE6, 
 0x6C, 0x15, 0xFD, 0x9C, 0x6E, 0x6A, 0x3F, 0xD8, 0xAA, 0xC5, 
 0xFD, 0x85, 0xD6, 0x91, 0xD9, 0x66, 0x41, 0xA6, 0x93, 0xB2, 
 0x4D, 0xE6, 0x50, 0xE5, 0x05, 0xA6, 0x3B, 0x5A, 0x91, 0x49, 
 0xD4, 0x8D, 0x95, 0x9D, 0x53, 0x49, 0x51, 0x19, 0xFF, 0xF1, 
 0xFB, 0x8B, 0xA8, 0xDA, 0x7A, 0xA5, 0x5B, 0x5D, 0x4F, 0x89, 
 0x21, 0xC9, 0xB6, 0xC8, 0xBE, 0x41, 0x2B, 0xE3, 0x70, 0xD5, 
 0xE8, 0x64, 0xEF, 0x0F, 0xF1, 0x2A, 0x39, 0x57, 0xC9, 0xE6, 
 0x84, 0xF0, 0x97, 0x57, 0x60, 0x47, 0xFB, 0xC2, 0xE8, 0xD8, 
 0x76, 0xF1, 0x36, 0x58, 0xE5, 0x6E, 0x5B, 0x7A, 0x77, 0x7C, 
 0xD3, 0x10, 0x98, 0x04, 0x25, 0xC5, 0x92, 0xF6, 0x1C, 0x1D, 
 0x90, 0x5F, 0xFE, 0x67, 0xE0, 0xC0, 0x3F, 0xCD, 0x08, 0x2B, 
 0x19, 0x82, 0x75, 0x2D, 0xB5, 0x28, 0xC3, 0xEE, 0x2D, 0xDF, 
 0xAE, 0xC3, 0x19, 0xCB, 0x8B, 0xAF, 0x89, 0x72, 0x46, 0x30, 
 0x63, 0x29, 0xCD, 0x38, 0x3E, 0x93, 0x05, 0xB9, 0x2D, 0xC3, 
 0xBD, 0x1F, 0x69, 0xA3, 0x25, 0x9B, 0x2C, 0xCB, 0xAC, 0x35, 
 0x06, 0x6E, 0xAC, 0x83, 0x7E, 0xC5, 0xE8, 0xBE, 0xC6, 0xA9, 
 0x0C, 0x07, 0x5E, 0x9E, 0x17, 0x0A, 0x8C, 0x63, 0xCD, 0xA9, 
 0xB0, 0x24, 0x51, 0x4F, 0xC4, 0x88, 0xEA, 0x30, 0xC0, 0xD7, 
 0xB6, 0x10, 0xA6, 0x64, 0x31, 0x0E, 0x8E, 0xAE, 0x59, 0xE7, 
 0xA3, 0x25, 0x08, 0x7B, 0xA1, 0x69, 0x84, 0x66, 0xF8, 0xF0, 
 0xB4, 0x71, 0x01, 0x00, 0xFE, 0x00
}
;

//
// File Control Parameters for the SP 800-73 Data Objects
//

//
// Data Object: X.509 Certificate of PIV Card Authentication Key
// BER-TLV Tag: '5FC101'
// Access Control: READ->Always, UPDATE->PIV Card Application Administrator
//
    static Octet CARD_X509_Tag [ ] = { 0x5F , 0xC1 , 0x01 } ;
    static Octet CARD_X509_FCP [ ] =
    {
      FCP_TAG, 40,                                                                // 31
                FCP_FILEALLOC, 2, NETWORK_WORD_BYTES ( DO_PIV_X509_SIZE ),//   4
                FCP_FDB , 2 , FDB_SHAREABLE_SIMPLE_TLV , DCB_PROPRIETARY_BYTES ,  //   4
                FCP_FID , 2 , NETWORK_WORD_BYTES ( DO_PIV_APP_X509 ) ,            //   4
                FCP_LIFECYCLE , 1 , LCS_OPERATIONAL_ACTIVATED ,                   //   3
                FCP_DATA_OBJECT_TEMPLATE , 5 ,                                    //   7
                                  FCP_TAG_LIST , 3 , 0x5F, 0xC1, 0x01,            //     5
                FCP_ACR_EXPANDED , 16 ,                                           //  18
                                  ACR_AM_DO ,        1 , ACR_AM_DO_GET_DATA ,     //     3
                                  ACR_SC_DO_ALWAYS , 0 ,                          //     2
                                  ACR_AM_DO ,        1 , ACR_AM_DO_PUT_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , PIV_CARD_APPLICATION_ADMINISTRATION ,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_EXTERNAL_AUTHENTICATION      //       3
    } ;

//
// Data Object: Cardholder Unique Identifier (CHUID)
// BER-TLV Tag: '5FC102'
// Access Control: READ->Always, UPDATE->PIV Card Application Administrator
//
    static Octet CHUID_Tag [ ] = { 0x5F , 0xC1 , 0x02 } ;
    static Octet CHUID_FCP [ ] =
    {
      FCP_TAG, 29,                                                                // 31
                FCP_FILEALLOC, 2, NETWORK_WORD_BYTES ( DO_CHUID_SIZE ),   //   4
                FCP_FDB , 2 , FDB_SHAREABLE_SIMPLE_TLV , DCB_PROPRIETARY_BYTES ,  //   4
                FCP_FID , 2 , NETWORK_WORD_BYTES ( DO_CHUID ) ,                   //   4
                FCP_LIFECYCLE , 1 , LCS_OPERATIONAL_ACTIVATED ,                   //   3
                FCP_DATA_OBJECT_TEMPLATE , 5 ,                                    //   7
                                  FCP_TAG_LIST , 3 , 0x5F, 0xC1, 0x02,            //     5
                FCP_ACR_EXPANDED , 16 ,                                           //  18
                                  ACR_AM_DO ,        1 , ACR_AM_DO_GET_DATA ,     //     3
                                  ACR_SC_DO_ALWAYS , 0 ,                          //     2
                                  ACR_AM_DO ,        1 , ACR_AM_DO_PUT_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , PIV_CARD_APPLICATION_ADMINISTRATION ,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_EXTERNAL_AUTHENTICATION      //       3
    } ;

//
// Data Object: Cardholder Fingerprint I
// BER-TLV Tag: '5FC103'
// Access Control: READ->PIN, UPDATE->PIV Card Application Administrator
//
    static Octet FINGER_1_Tag [ ] = { 0x5F , 0xC1 , 0x03 } ;
    static Octet FINGER_1_FCP [ ] =
    {
      FCP_TAG, 46,                                                                // 48
                FCP_FILEALLOC, 2, NETWORK_WORD_BYTES ( DO_FINGER_1_SIZE ),//   4
                FCP_FDB , 2 , FDB_SHAREABLE_SIMPLE_TLV , DCB_PROPRIETARY_BYTES ,  //   4
                FCP_FID , 2 , NETWORK_WORD_BYTES ( DO_FINGER_1 ) ,                //   4
                FCP_LIFECYCLE , 1 , LCS_OPERATIONAL_ACTIVATED ,                   //   3
                FCP_DATA_OBJECT_TEMPLATE , 5 ,                                    //   7
                                  FCP_TAG_LIST , 3 , 0x5F, 0xC1, 0x03,            //     5
                FCP_ACR_EXPANDED , 22 ,                                           //  24
                                  ACR_AM_DO ,        1 , ACR_AM_DO_GET_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , CARDHOLDER_PIV_CARD_APPLICATION_PIN,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_USE,     //       3
                                  ACR_AM_DO ,        1 , ACR_AM_DO_PUT_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , PIV_CARD_APPLICATION_ADMINISTRATION ,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_EXTERNAL_AUTHENTICATION      //       3
    } ;

//
// Data Object: Cardholder Fingerprint II
// BER-TLV Tag: '5FC104'
// Access Control: READ->PIN, UPDATE->PIV Card Application Administrator
//
    static Octet FINGER_2_Tag [ ] = { 0x5F , 0xC1 , 0x04 } ;
    static Octet FINGER_2_FCP [ ] =
    {
      FCP_TAG, 46,                                                                // 48
                FCP_FILEALLOC, 2, NETWORK_WORD_BYTES ( DO_FINGER_2_SIZE ),//   4
                FCP_FDB , 2 , FDB_SHAREABLE_SIMPLE_TLV , DCB_PROPRIETARY_BYTES ,  //   4
                FCP_FID , 2 , NETWORK_WORD_BYTES ( DO_FINGER_2 ) ,                //   4
                FCP_LIFECYCLE , 1 , LCS_OPERATIONAL_ACTIVATED ,                   //   3
                FCP_DATA_OBJECT_TEMPLATE , 5 ,                                    //   7
                                  FCP_TAG_LIST , 3 , 0x5F, 0xC1, 0x04,            //     5
                FCP_ACR_EXPANDED , 22 ,                                           //  24
                                  ACR_AM_DO ,        1 , ACR_AM_DO_GET_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , CARDHOLDER_PIV_CARD_APPLICATION_PIN,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_USE,     //       3
                                  ACR_AM_DO ,        1 , ACR_AM_DO_PUT_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , PIV_CARD_APPLICATION_ADMINISTRATION ,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_EXTERNAL_AUTHENTICATION      //       3
    } ;

//
// Data Object: X.509 Certificate for PIV Authentication
// BER-TLV Tag: '5FC105'
// Access Control: READ->PIN, UPDATE->PIV Card Application Administrator
//
    static Octet PIV_X509_Tag [ ] = { 0x5F , 0xC1 , 0x05 } ;
    static Octet PIV_X509_FCP [ ] =
    {
      FCP_TAG, 46,                                                                // 48
                FCP_FILEALLOC, 2, NETWORK_WORD_BYTES ( DO_CARD_X509_SIZE ),//   4
                FCP_FDB , 2 , FDB_SHAREABLE_SIMPLE_TLV , DCB_PROPRIETARY_BYTES ,  //   4
                FCP_FID , 2 , NETWORK_WORD_BYTES ( DO_LOGICAL_X509 ) ,            //   4
                FCP_LIFECYCLE , 1 , LCS_OPERATIONAL_ACTIVATED ,                   //   3
                FCP_DATA_OBJECT_TEMPLATE , 5 ,                                    //   7
                                  FCP_TAG_LIST , 3 , 0x5F, 0xC1, 0x05,            //     5
                FCP_ACR_EXPANDED , 22 ,                                           //  24
                                  ACR_AM_DO ,        1 , ACR_AM_DO_GET_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , CARDHOLDER_PIV_CARD_APPLICATION_PIN,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_USE,     //       3
                                  ACR_AM_DO ,        1 , ACR_AM_DO_PUT_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , PIV_CARD_APPLICATION_ADMINISTRATION ,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_EXTERNAL_AUTHENTICATION      //       3
    } ;

//
// Data Object: Security Object
// BER-TLV Tag: '5FC106'
// Access Control: READ->Always, UPDATE->PIV Card Application Administrator
//
    static Octet SECURITY_OBJECT_Tag [ ] = { 0x5F , 0xC1 , 0x06 } ;
    static Octet SECURITY_OBJECT_FCP [ ] =
    {
      FCP_TAG, 40,                                                                // 42
                FCP_FILEALLOC, 2, NETWORK_WORD_BYTES ( DO_SECURITY_OBJECT_SIZE ), //   4
                FCP_FDB , 2 , FDB_SHAREABLE_SIMPLE_TLV , DCB_PROPRIETARY_BYTES ,  //   4
                FCP_FID , 2 , NETWORK_WORD_BYTES ( DO_SECURITY_OBJECT ) ,         //   4
                FCP_LIFECYCLE , 1 , LCS_OPERATIONAL_ACTIVATED ,                   //   3
                FCP_DATA_OBJECT_TEMPLATE , 5 ,                                    //   7
                                  FCP_TAG_LIST , 3 , 0x5F, 0xC1, 0x06,            //     5
                FCP_ACR_EXPANDED , 16 ,                                           //  18
                                  ACR_AM_DO ,        1 , ACR_AM_DO_GET_DATA ,     //     3
                                  ACR_SC_DO_ALWAYS , 0 ,                          //     2
                                  ACR_AM_DO ,        1 , ACR_AM_DO_PUT_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , PIV_CARD_APPLICATION_ADMINISTRATION ,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_EXTERNAL_AUTHENTICATION      //       3
    } ;

//
// Data Object: Card Capabilities Container
// BER-TLV Tag: '5FC107'
// Access Control: READ->Always, UPDATE->PIV Card Application Administrator
//
    static Octet CCC_Tag [ ] = { 0x5F , 0xC1 , 0x07 } ;
    static Octet CCC_FCP [ ] =
    {
      FCP_TAG, 40,                                                                // 42
                FCP_FILEALLOC, 2, NETWORK_WORD_BYTES ( DO_CCC_SIZE ),     //   4
                FCP_FDB , 2 , FDB_SHAREABLE_TRANSPARENT , DCB_PROPRIETARY_BYTES , //   4
                FCP_FID , 2 , NETWORK_WORD_BYTES ( DO_CCC ) ,                     //   4
                FCP_LIFECYCLE , 1 , LCS_OPERATIONAL_ACTIVATED ,                   //   3
                FCP_DATA_OBJECT_TEMPLATE , 5 ,                                    //   7
                                  FCP_TAG_LIST , 3 , 0x5F, 0xC1, 0x07,            //     5
                FCP_ACR_EXPANDED , 16 ,                                           //  18
                                  ACR_AM_DO ,        1 , ACR_AM_DO_GET_DATA ,     //     3
                                  ACR_SC_DO_ALWAYS , 0 ,                          //     2
                                  ACR_AM_DO ,        1 , ACR_AM_DO_PUT_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , PIV_CARD_APPLICATION_ADMINISTRATION ,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_EXTERNAL_AUTHENTICATION      //       3
    } ;

//
// Data Object: Cardholder Facial Image
// BER-TLV Tag: '5FC108'
// Access Control: READ->PIN, UPDATE->PIN
//
// Note: UPDATE is set to PIN for software testing purposes only.
//       Remove "| ACR_AM_DO_PUT_DATA" from the ACR for compliance assessment purposes.
//
    static Octet FACIAL_IMAGE_Tag [ ] = { 0x5F , 0xC1 , 0x08 } ;
    static Octet FACIAL_IMAGE_FCP [ ] =
    {
      FCP_TAG, 46,                                                                // 48
                FCP_FILEALLOC, 2, NETWORK_WORD_BYTES ( DO_FACIAL_IMAGE_SIZE ), //   4
                FCP_FDB , 2 , FDB_SHAREABLE_SIMPLE_TLV , DCB_PROPRIETARY_BYTES ,  //   4
                FCP_FID , 2 , NETWORK_WORD_BYTES ( DO_FACIAL_IMAGE ) ,            //   4
                FCP_LIFECYCLE , 1 , LCS_OPERATIONAL_ACTIVATED ,                   //   3
                FCP_DATA_OBJECT_TEMPLATE , 5 ,                                    //   7
                                  FCP_TAG_LIST , 3 , 0x5F, 0xC1, 0x08,            //     5
                FCP_ACR_EXPANDED , 22 ,                                           //  24
                                  ACR_AM_DO ,        1 , ACR_AM_DO_GET_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , CARDHOLDER_PIV_CARD_APPLICATION_PIN,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_USE,     //       3
                                  ACR_AM_DO ,        1 , ACR_AM_DO_PUT_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , PIV_CARD_APPLICATION_ADMINISTRATION ,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_EXTERNAL_AUTHENTICATION      //       3
    } ;

//
// Data Object: Printed Information
// BER-TLV Tag: '5FC109'
// Access Control: READ->PIN, UPDATE->PIV Card Application Administrator
//
    static Octet PRINTED_INFO_Tag [ ] = { 0x5F , 0xC1 , 0x09 } ;
    static Octet PRINTED_INFO_FCP [ ] =
    {
      FCP_TAG, 46,                                                                // 48
                FCP_FILEALLOC, 2, NETWORK_WORD_BYTES ( DO_PRINTED_INFO_SIZE ),                     //   4
                FCP_FDB , 2 , FDB_SHAREABLE_SIMPLE_TLV , DCB_PROPRIETARY_BYTES ,  //   4
                FCP_FID , 2 , NETWORK_WORD_BYTES ( DO_PRINTED_INFO ) ,            //   4
                FCP_LIFECYCLE , 1 , LCS_OPERATIONAL_ACTIVATED ,                   //   3
                FCP_DATA_OBJECT_TEMPLATE , 5 ,                                    //   7
                                  FCP_TAG_LIST , 3 , 0x5F, 0xC1, 0x09,            //     5
                FCP_ACR_EXPANDED , 22 ,                                           //  24
                                  ACR_AM_DO ,        1 , ACR_AM_DO_GET_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , CARDHOLDER_PIV_CARD_APPLICATION_PIN,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_USE,     //       3
                                  ACR_AM_DO ,        1 , ACR_AM_DO_PUT_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , PIV_CARD_APPLICATION_ADMINISTRATION ,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_EXTERNAL_AUTHENTICATION      //       3
    } ;

//
// Data Object: X.509 Certificate for Digital Signature
// BER-TLV Tag: '5FC10A'
// Access Control: READ->PIN Always, UPDATE->PIV Card Application Administrator
//
    static Octet SIGNING_X509_Tag [ ] = { 0x5F , 0xC1 , 0x0A } ;
    static Octet SIGNING_X509_FCP [ ] =
    {
      FCP_TAG, 46,                                                                // 48
                FCP_FILEALLOC, 2, NETWORK_WORD_BYTES ( DO_SIGNING_X509_SIZE ),                     //   4
                FCP_FDB , 2 , FDB_SHAREABLE_SIMPLE_TLV , DCB_PROPRIETARY_BYTES ,  //   4
                FCP_FID , 2 , NETWORK_WORD_BYTES ( DO_SIGNING_X509 ),             //   4
                FCP_LIFECYCLE , 1 , LCS_OPERATIONAL_ACTIVATED ,                   //   3
                 FCP_DATA_OBJECT_TEMPLATE , 5 ,                                    //  7
                                  FCP_TAG_LIST , 3 , 0x5F, 0xC1, 0x0A,            //     5
                FCP_ACR_EXPANDED , 22 ,                                           //  24
                                  ACR_AM_DO ,        1 , ACR_AM_DO_GET_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , CARDHOLDER_PIV_CARD_APPLICATION_PIN,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_USE,     //       3
                                  ACR_AM_DO ,        1 , ACR_AM_DO_PUT_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , PIV_CARD_APPLICATION_ADMINISTRATION ,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_EXTERNAL_AUTHENTICATION      //       3
    } ;

//
// Data Object: X.509 Certificate for Key Management
// BER-TLV Tag: '5FC10B'
// Access Control: READ->PIN, UPDATE->PIV Card Application Administrator
//
    static Octet KEY_MANAGEMENT_X509_Tag [ ] = { 0x5F , 0xC1 , 0x0B } ;
    static Octet KEY_MANAGEMENT_X509_FCP [ ] =
    {
      FCP_TAG, 46,                                                                // 48
                FCP_FILEALLOC, 2, NETWORK_WORD_BYTES ( DO_KEY_MANAGEMENT_X509_SIZE ),                     //   4
                FCP_FDB , 2 , FDB_SHAREABLE_SIMPLE_TLV , DCB_PROPRIETARY_BYTES ,  //   4
                FCP_FID , 2 , NETWORK_WORD_BYTES ( DO_KEY_MANAGEMENT_X509 ) ,     //   4
                FCP_LIFECYCLE , 1 , LCS_OPERATIONAL_ACTIVATED ,                   //   3
                FCP_DATA_OBJECT_TEMPLATE , 5 ,                                    //   7
                                  FCP_TAG_LIST , 3 , 0x5F, 0xC1, 0x0B,            //     5
                FCP_ACR_EXPANDED , 22 ,                                           //  24
                                  ACR_AM_DO ,        1 , ACR_AM_DO_GET_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , CARDHOLDER_PIV_CARD_APPLICATION_PIN,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_USE,     //       3
                                  ACR_AM_DO ,        1 , ACR_AM_DO_PUT_DATA ,     //     3
                                  ACR_SC_DO , 6 ,                                 //     8
                                     ACR_SC_KEY_REFERENCE   , 1 , PIV_CARD_APPLICATION_ADMINISTRATION ,          //       3
                                     ACR_SC_USAGE_QUALIFIER , 1 , ACR_UQ_EXTERNAL_AUTHENTICATION      //       3
    } ;



// The default PIN

static Octet the_default_PIN [ ] = { '1' , '2' , '3' , '4', 0xFF, 0xFF, 0xFF, 0xFF } ;
static Octet the_default_PUK [ ] = { '4' , '3' , '2' , '1', 0xFF, 0xFF, 0xFF, 0xFF } ;

static Key_Reference the_default_PIN_reference ( 0x20 ) ;  /* Internal "compressed" key reference for 0x80 */
static Key_Reference the_default_PUK_reference ( 0x21 ) ;  /* Internal "compressed" key reference for 0x81 */

static PIN_Retries the_default_PIN_retries (  3 ) ;
static PIN_Retries the_default_PUK_retries ( 10 ) ;

// The default symmetric key

static Octet the_default_symmetric_key [ ] =
  { 0x30 , 0x31 , 0x32 , 0x33 , 0x34 , 0x35 , 0x36 , 0x37 ,
    0x38 , 0x39 , 0x3A , 0x3B , 0x3C , 0x3D , 0x3E , 0x3F ,
    0x40 , 0x41 , 0x42 , 0x43 , 0x44 , 0x45 , 0x46 , 0x47 } ;
static Key_Reference the_default_symmetric_key_reference_1 ( 0x3B ) ;  /* Internal "compressed" key reference for 0x9B */
static Key_Reference the_default_symmetric_key_reference_2 ( 0x3E ) ;  /* Internal "compressed" key reference for 0x9E */


// The default RSA key

static Octet the_default_RSA_key_n [ ] =
  { 	
	// Original modulus:
	
	0xcc, 0xd8, 0x7d, 0xee, 0x80, 0xf0, 0x7b, 0x65, 0x53, 0xb2, 0x16, 0x08, 0xd6, 0xfc, 
	0xd1, 0xa3, 0x89, 0xf7, 0x77, 0x65, 0x18, 0x58, 0x3f, 0xd0, 0x83, 0x6e, 0x07, 0x2d, 0xe0,
	0xd7, 0x58, 0x3f, 0x5e, 0x11, 0x4d, 0x00, 0x28, 0x85, 0x13, 0x50, 0xd1, 0x0e, 0x52, 0xa5,
	0x39, 0xd6, 0x51, 0xf9, 0x1a, 0x12, 0x1f, 0xba, 0x17, 0x5e, 0xb1, 0x8f, 0xe2, 0xdf, 0xf3,
	0x02, 0x67, 0x60, 0x70, 0x76, 0xa1, 0x08, 0x00, 0xef, 0x0a, 0xf4, 0x65, 0xdb, 0xa7, 0xda,
	0xe9, 0xef, 0xd2, 0xc0, 0x4b, 0x9a, 0x80, 0x10, 0xe5, 0x73, 0x5f, 0xfe, 0x5a, 0xb0, 0xfa,
	0x49, 0xa5, 0xff, 0x9b, 0x79, 0x3b, 0x83, 0x1e, 0x7b, 0xf8, 0x75, 0x8f, 0xe9, 0x5c, 0x8a,
	0xd2, 0x71, 0x49, 0x18, 0xec, 0x6e, 0xab, 0x1c, 0x1d, 0x51, 0x5f, 0x3b, 0x5e, 0xdf, 0xf1,
	0x6c, 0x2e, 0x68, 0x66, 0xa5, 0x22, 0x75, 0xb8, 0x21
  } ;

static Octet the_default_RSA_key_d [ ] =
  {   
	// Private exponent:
	
	0x7b, 0xc0, 0x2e, 0x13, 0xf0, 0x01, 0x58, 0x0a, 0x96, 0xcd, 0x77, 0x52, 0x4f, 0xce, 0xdc,
	0x37, 0x18, 0x1a, 0x50, 0x1e, 0xda, 0xde, 0x35, 0x6f, 0x1a, 0x77, 0x56, 0x0e, 0xf9, 0x4e,
	0x1f, 0x19, 0xe9, 0x12, 0x3a, 0x9a, 0x65, 0xe0, 0x3f, 0x13, 0x0b, 0xb8, 0xc3, 0x64, 0xdd,
	0xd4, 0x04, 0x21, 0xa1, 0x06, 0x61, 0xf4, 0x62, 0x39, 0xea, 0xbb, 0x2a, 0x2c, 0x70, 0xfa,
	0x7a, 0xc9, 0x60, 0x26, 0xb5, 0xc4, 0x1d, 0xdb, 0xd0, 0xe1, 0xb6, 0x73, 0x4d, 0xa0, 0xe8,
	0x4c, 0x9f, 0xcf, 0x8e, 0x5f, 0x7b, 0xe6, 0x58, 0x83, 0x02, 0x39, 0x34, 0xe1, 0x35, 0x38,
	0xd8, 0xd4, 0xcb, 0xa0, 0x96, 0x6b, 0x5f, 0x68, 0x6e, 0xfa, 0x0c, 0x4d, 0xab, 0xfb, 0x64,
	0x28, 0x24, 0x2c, 0x31, 0x20, 0x5d, 0xd3, 0x54, 0xe7, 0xc6, 0xad, 0x50, 0x12, 0x01, 0x05,
	0x97, 0x4a, 0x7f, 0x70, 0x0b, 0xbf, 0xeb, 0x81
  } ;

static Octet the_default_RSA_key_e [ ] =
  { 
  //Public exponent
	0x01, 0x00, 0x01
  } ;

static Key_Reference the_default_RSA_key_reference ( 0x3A ) ; /* Internal "compressed" key reference for 0x9A */

